Change notes from older releases. For current info see RELEASE-NOTES-1.22.

== MediaWiki 1.21 ==

MediaWiki 1.21 is an alpha-quality branch and is not recommended for use in
production.

=== Configuration changes in 1.21 ===
* (bug 29374) $wgVectorUseSimpleSearch is now enabled by default.
* Deprecated $wgAllowRealName is removed. Use $wgHiddenPrefs[] = 'realname'
  instead.
* (bug 39957) Added $wgUnwatchedPageThreshold, specifying minimum count
  of page watchers required for the number to be accessible to users
  without the unwatchedpages permission.
* $wgBug34832TransitionalRollback has been removed.
* (bug 29472) $wgUseDynamicDates has been removed and its functionality
  disabled.

=== New features in 1.21 ===
* (bug 38110) Schema changes (adding or dropping tables, indices and
  fields) can be now be done separately from from other changes that
  update.php makes.  This is useful in environments that use database
  permissions to restrict schema changes but allow the DB user that
  MediaWiki normally runs as to perform other changes that update.php
  makes.  Schema changes can be run separately.  See the file UPGRADE
  for more information.
* (bug 34876) jquery.makeCollapsible has been improved in performance.
* Added ContentHandler facility to allow extensions to support other content
  than wikitext. See docs/contenthandler.txt for details.
* New feature was developed for showing high-DPI thumbnails for high-DPI mobile
  and desktop displays (configurable with $wgResponsiveImages).
* Added new backend to represent and store information about sites and site
  specific configuration.
* jQuery upgraded from 1.8.2 to 1.8.3.
* jQuery UI upgraded from 1.8.23 to 1.8.24.
* Added separate fa_sha1 field to filearchive table. This allows sha1
  searches with the api in miser mode for deleted files.
* Add initial and programmatic sorting for tablesorter.
* Add the event "sortEnd.tablesorter", triggered after sorting has completed.
* The Job system was refactored to allow for different backing stores for
  queues as well as cross-wiki access to queues, among other things. The schema
  for the DB queue was changed to support better concurrency and reduce
  deadlock errors.
* Added ApiQueryORM class to facilitate creation of query API modules based on
  tables that have a corresponding ORMTable class.
* (bug 40876) Icon for PSD (Adobe Photoshop) file types.
* (bug 40641) Implemented Special:Version/Credits with a list of contributors.
* (bug 7851) Implemented one-click AJAX patrolling.
* The <data>, <time>, <meta>, and <link> elements are allowed within WikiText
  for use with Microdata.
* The HTML5 <mark> tag has been whitelisted.
* Added ParserCloned hook for when the Parser object is cloned.
* Added AlternateEditPreview hook to allow extensions to replace the page
  preview from the edit page.
* Added EditPage::showStandardInputs:options hook to allow extensions to add
  new fields to the "editOptions" area of the edit form.
* Upload stash DB schema altered to improve upload performance.
* The following global functions are now reporting deprecated warnings in
  debug mode: wfMsg, wfMsgNoTrans, wfMsgForContent, wfMsgForContentNoTrans,
  wfMsgReal, wfMsgGetKey, wfMsgHtml, wfMsgWikiHtml, wfMsgExt, wfEmptyMsg. Use
  the Message class, or the global method wfMessage.
* Added $wgEnableCanonicalServerLink, off by default. If enabled, a
  <link rel=canonical> tag is added to every page indicating the correct server
  to use.
* Debug message emitted by wfDebugLog() will now be prefixed with the group
  name when its logged to the default log file. That is the case whenever the
  group has no key in wgDebugLogGroups, that will help triage the default log.
* (bug 24620) Add types to LogFormatter.
* jQuery JSON upgraded from 2.3 to 2.4.0.
* Added GetDoubleUnderscoreIDs hook, for modifying the list of magic words.
* DatabaseUpdater class has two new methods to ease extensions schema changes:
  dropExtensionIndex and renameExtensionIndex.
* New preference type - 'api'. Preferences of this type are not shown on
  Special:Preferences, but are still available via the action=options API.
* (bug 39397) Hide rollback link if a user is the only contributor of the page.
* $wgPageInfoTransclusionLimit limits the list size of transcluded articles
  on the info action. Default is 50.
* Added action=createaccount to allow user account creation.
* (bug 40124) action=options API also allows for setting of arbitrary
  preferences, provided that their names are prefixed with 'userjs-'. This
  officially reenables the feature that was undocumented and defective
  in MW 1.20 (saving preferences using Special:Preferences cleared any
  additional fields) and which has been disabled in 1.20.1 as a part of
  a security fix (bug 42202).
* Added option to specify "others" as author in extension credits using
  "..." as author name.
* Added the ability to limit the wall clock time used by shell processes,
  as well as the CPU time. Configurable with $wgMaxShellWallClockTime.
* Allow memory of shell subprocesses to be limited using Linux cgroups
  instead of ulimit -v, which tends to cause deadlocks in recent versions
  of ImageMagick. Configurable with $wgShellCgroup.
* Added $wgWhitelistReadRegexp for regex whitelisting.
* (bug 5346) Categories that are redirects will be displayed italic in
  the category links section at the bottom of a page.
* (bug 43915) New maintenance script deleteEqualMessages.php.
* You can now create checkbox option matrices through the HTMLCheckMatrix
  subclass in HTMLForm.
* WikiText now permits the use of WAI-ARIA's role="presentation" inside of
  html elements and tables. This allows presentational markup, especially
  tables. To be marked up as such.
* maintenance/sql.php learned the --cluster option. Let you run the script
  on some external cluster instead of the primary cluster for a given wiki.
* (bug 20281) test the parsing of inline URLs.
* Added Special:PagesWithProp, which lists pages using a particular page property.
* Implemented language-specific collations for category sorting for 67 languages
  based in latin, greek and cyrillic alphabets. This allows one to *finally* get
  articles to be correctly sorted on category pages. They are named
  'uca-<langcode>', where <langcode> is one of: af, ast, az, be, bg, br, bs, ca,
  co, cs, cy, da, de, dsb, el, en, eo, es, et, eu, fi, fo, fr, fur, fy, ga, gd,
  gl, hr, hsb, hu, is, it, kk, kl, ku, ky, la, lb, lt, lv, mk, mo, mt, nl, no,
  oc, pl, pt, rm, ro, ru, rup, sco, sk, sl, smn, sq, sr, sv, tk, tl, tr, tt, uk,
  uz, vi.
* Added 'CategoryAfterPageAdded' and 'CategoryAfterPageRemoved' hooks.
* Added 'HistoryRevisionTools' and 'DiffRevisionTools' hooks.
* Added 'SpecialSearchResultsPrepend' and 'SpecialSearchResultsAppend' hooks.
* (bug 33186) Add image rotation api "imagerotate"
* (bug 34040) Add "User rights management" link on user page toolbox.
* (bug 45526) Add QUnit assertion helper "QUnit.assert.htmlEqual" for asserting
  structual equality of HTML (ignoring insignificant differences like
  quotmarks, order and whitespace in the attribute list).
* (bug 23393) HTML <hN> headings containing line breaks are now handled
  correctly.
* (bug 45803) Whitespace within == Headline == syntax and within <hN> headings
  is now non-significant and not preserved in the HTML output.

=== Bug fixes in 1.21 ===
* (bug 40353) SpecialDoubleRedirect should support interwiki redirects.
* (bug 40352) fixDoubleRedirects.php should support interwiki redirects.
* (bug 9237) SpecialBrokenRedirect should not list interwiki redirects.
* (bug 34960) Drop unused fields rc_moved_to_ns and rc_moved_to_title from
  recentchanges table.
* (bug 32951) Do not register internal externals with absolute protocol,
  when server has relative protocol.
* (bug 39005) When purging proxies listed in $wgSquidServers using HTTP PURGE
  method requests, we now send a Host header by default, for Varnish
  compatibility. This also works with Squid in reverse-proxy mode. If you wish
  to support Squid configured in forward-proxy mode, set
  $wgSquidPurgeUseHostHeader to false.
* (bug 37020) sql.php with readline eats semicolon.
* (bug 11748) Properly handle optionally-closed HTML tags when Tidy is
  disabled, and don't wrap HTML-syntax definition lists in paragraphs.
* (bug 41409) Diffs while editing an old revision should again diff against the
  current revision.
* (bug 41494) Honor $wgLogExceptionBacktrace when logging non-API exceptions
  caught during API execution.
* (bug 37963) Fixed loading process for user options.
* (bug 26995) Update filename field on Upload page after having sanitized it.
* (bug 41793) Contribution links to users with 0 edits on Special:ListUsers
  didn't show up red.
* (bug 41899) A PHP notice no longer occurs when using the "rvcontinue" API
  parameter.
* (bug 42036) Account creation emails now contain canonical (not
  protocol-relative) URLs.
* (bug 41990) Fix regression: API edit with redirect=true and lacking
  starttimestamp and basetimestamp should not cause an edit conflict.
* (bug 41706) EditPage: Preloaded page should be converted if possible and
  needed.
* (bug 41886) Rowspans are no longer exploded by tablesorter until the table is
  actually sorted.
* (bug 2865)  User interface HTML elements don't use lang attribute.
  (completed the fix by adding the lang attribute to firstHeading).
* (bug 42173) Removed namespace prefixes on Special:UncategorizedCategories.
* (bug 36053) Log in "returnto" feature forgets query parameters if no
  title parameter was specified.
* (bug 42410) API action=edit now returns correct timestamp for the new edit.
* (bug 14901) Email notification mistakes log action for new page creation.
  Enotif no longer sends "page has been created" notifications for some log
  actions. The following events now have a correct message: page creation,
  deletion, move, restore (undeletion), change (edit). Parameter
  $CHANGEDORCREATED is deprecated in 'enotif_body' and scheduled for removal in
  MediaWiki 1.23.
* (bug 457) In the sidebar of Vector, CologneBlue, Monobook, and Monobook-based
  skins, the heading levels have been changed from (variously per skin)
  <h4>, <h5> or <h6> to only <h3>s, with a <h2> hidden heading above them.
  If you are styling or scripting the headings in a custom way, this change
  will require updates to your site's CSS or JS.
* (bug 41342) jquery.suggestions should cancel any active (async) fetches
  before it triggers another fetch.
* (bug 42184) $wgUploadSizeWarning missing second variable.
* (bug 34581) removeUnusedAccounts.php maintenance script now ignores newuser
  log when determining whether an account is used.
* (bug 43379) Gracefully fail if rev_len is unavailable for a revision on the
  History page.
* (bug 42949) API no longer assumes all exceptions are MWException.
* (bug 41733) Hide "New user message" (.usermessage) element from printable view.
* (bug 39062) Special:Contributions will display changes that don't have
  a parent id instead of just an empty bullet item.
* (bug 37209) "LinkCache doesn't currently know about this title" error fixed.
* wfMerge() now works if $wgDiff3 contains spaces
* (bug 43052) mediawiki.action.view.dblClickEdit.dblClickEdit should trigger
  ca-edit click instead opening URL directly.
* (bug 43964) Invalid value of "link" parameter in <gallery> no longer produces
  a fatal error.
* (bug 44775) The username field is not pre-filled when creating an account.
* (bug 45069) wfParseUrl() no longer produces a PHP notice if passed a "mailto:"
  URL without address
* (bug 45012) Creating an account by e-mail can no longer show a
  "password mismatch" error.
* (bug 44599) On Special:Version, HEADs for submodule checkouts (e.g. for
  extensions) performed using Git 1.7.8+ should now appear.
* (bug 42184) $wgUploadSizeWarning missing second variable
* (bug 40326) Check if files exist with a different extension during uploading
* (bug 34798) Updated CSS for Atom/RSS recent changes feeds to match on-wiki diffs.
* (bug 42430) Calling numRows on MySQL no longer propagates unrelated errors.
* (bug 44719) Removed mention of non-existing maintenance/migrateCurStubs.php
  script in includes/DefaultSettings.php
* (bug 45143) jquery.badge: Treat non-Latin variants of zero as zero as well.
* (bug 46151) mwdocgen.php should not ignore exit code of doxygen command.
* (bug 41889) Fix $.tablesorter rowspan exploding for complex cases.

=== API changes in 1.21 ===
* prop=revisions can now report the contentmodel and contentformat.
  See docs/contenthandler.txt.
* action=edit and action=parse now support contentmodel and contentformat
  parameters to control the interpretation of page content.
  See docs/contenthandler.txt for details.
* (bug 35693) ApiQueryImageInfo now suppresses errors when unserializing metadata.
* (bug 40111) Disable minor edit for page/section creation by API.
* (bug 41042) Revert change to action=parse&page=... behavior when the page
  does not exist.
* (bug 27202) Add timestamp sort to list=allimages.
* (bug 43137) Don't return the sha1 of revisions through the API if the content is
  revision-deleted.
* ApiQueryImageInfo now also returns imageinfo for redirects.
* list=alltransclusions added to enumerate every instance of page embedding
* list=alllinks & alltransclusions now allow both 'from' and 'continue' in
  the same query. When both are present, 'from' is simply ignored.
* list=alllinks & alltransclusions now allow 'unique' in generators, to yield
  a list of all link/template target pages instead of source pages.
* BREAKING CHANGE: list=logevents output format changed for details of some log
  types. Specifically, details that were formerly reported under a key like
  "4::foo" will now be reported under a key of simply "foo".
* BREAKING CHANGE: '??_badcontinue' error code was changed to '??badcontinue'
  for all query modules.
* ApiQueryBase adds 'badcontinue' error code if module has 'continue' parameter.
* (bug 35885) Removed version parameter and all getVersion() methods.
* action=options now takes a "resetkinds" option, which allows only resetting
  certain types of preferences when the "reset" option is set.
* (bug 36751) ApiQueryImageInfo now returns imageinfo for the redirect target
  when queried with &redirects=.
* (bug 31849) ApiQueryImageInfo no longer gets confused when asked for info on
  a redirect and its target.
* (bug 43849) ApiQueryImageInfo no longer throws exceptions with ForeignDBRepo
  redirects.
* On error, any warnings generated before that error will be shown in the result.
* action=help supports generalized submodules (modules=query+value), querymodules obsolete
* ApiQueryImageInfo continuation is more reliable. The only major change is
  that the imagerepository property will no longer be set on page objects not
  processed in the current query (i.e. non-images or those skipped due to
  iicontinue).
* Add supports for all pageset capabilities - generators, redirects, converttitles to
  action=purge and action=setnotificationtimestamp.
* (bug 43251) prop=pageprops&ppprop= now accepts multiple props to query.
* ApiQueryImageInfo will now limit the number of calls to File::transform made
  in any one query. If there are too many, iicontinue will be returned.
* action=query&meta=siteinfo&siprop=general will now return the regexes used for
  link trails and link prefixes. Added for Parsoid support.
* Added an API query module list=pageswithprop, which lists pages using a
  particular page property.
* Added an API query module list=pagepropnames, which lists all page prop names
  currently in use on the wiki.
* (bug 44921) ApiMain::execute() will now return after the CORS check for an
  HTTP OPTIONS request.
* (bug 44923) action=upload works correctly if the entire file is uploaded in
  the first chunk.
* Added 'continue=' parameter to streamline client iteration over complex query results
* (bug 44909) API parameters may now be marked as type "upload", which is now
  used for action=upload's 'file' and 'chunk' parameters. This type will raise
  an error during parameter validation if the parameter is given but not
  recognized as an uploaded file.
* (bug 44244) prop=info may now return the number of people watching each page.
* (bug 33304) list=allpages will no longer return duplicate entries when
  querying protection.
* (bug 33304) list=allpages will now find really old indefinite protections.
* (bug 45937) meta=allmessages will report a syntactically invalid lang as a
  proper error instead of as an uncaught exception.
* (bug 25325) added support for wlshow filtering (bots/anon/minor/patrolled)
  to action=feedwatchlist
* WDDX formatted output will actually be formatted (and normal output will no
  longer be), and will no longer choke on booleans.

=== API internal changes in 1.21 ===
* For debugging only, a new global $wgDebugAPI removes many API restrictions when true.
  Never use on the production servers, as this flag introduces security holes.
  Whenever enabled, a warning will also be added to all output.
* ApiModuleManager now handles all submodules (actions,props,lists) and instantiation
* Query stores prop/list/meta as submodules
* ApiPageSet can now be used in any action to process titles/pageids/revids or any generator.
* BREAKING CHANGE: ApiPageSet constructor now has two params instead of three, with only the
  first one keeping its meaning. ApiPageSet is now derived from ApiBase.
* BREAKING CHANGE: ApiQuery::newGenerator() and executeGeneratorModule() were deleted.
* ApiQueryGeneratorBase::setGeneratorMode() now requires a pageset param.
* $wgAPIGeneratorModules is now obsolete and will be ignored.
* Added flags ApiResult::OVERRIDE and ADD_ON_TOP to setElement() and addValue()
* Internal API calls will now include <warnings> in case of unused parameters

=== Languages updated in 1.21 ===

MediaWiki supports over 350 languages. Many localisations are updated
regularly. Below only new and removed languages are listed, as well as
changes to languages because of Bugzilla reports.

* South Azerbaijani (azb) added.
* (bug 30040) Autonym for nds-nl is now 'Nedersaksies' (was 'Nedersaksisch').
* (bug 45436) Autonym for pi (Pali) is now 'पालि' (was ''पाळि').
* (bug 34977) Now formatted numbers in Spanish use space as separator
  for thousands, as mandated by the Real Academia Española.
* (bug 35031) Kurdish formatted numbers now use period and comma
  as separators for thousands and decimals respectively.

=== Other changes in 1.21 ===
* BREAKING CHANGE: (bug 44385) Removed the jquery.collapsibleTabs module and
  moved it to the Vector extension. It was entirely Vector-extension-specific,
  deeply interconnected with the extension, and this functionality really
  belongs to the extension instead of the skin anyway. In the unlikely case you
  were using it, you have to either copy it to your extension, or install the
  Vector extension (and possibly disable its features using config settings if
  you don't want them).
* Experimental IBM DB2 support was removed due to lack of interest and maintainership
* BREAKING CHANGE: Filenames of maintenance scripts were standardized into
  lowerCamelCase format, and made more explicit:
  - clear_stats.php -> clearCacheStats.php
  - clear_interwiki_cache.php -> clearInterwikiCache.php
  - initStats.php -> initSiteStats.php
  - proxy_check.php -> proxyCheck.php
  - stats.php -> showCacheStats.php
  - showStats.php -> showSiteStats.php.
  Class names were renamed accordingly:
  - clear_stats -> ClearCacheStats
  - InitStats -> InitSiteStats
  - CacheStats -> ShowCacheStats
  - ShowStats -> ShowSiteStats.
* BREAKING CHANGE: (bug 38244) Removed the mediawiki.api.titleblacklist module
  and moved it to the TitleBlacklist extension.

== MediaWiki 1.20 ==

=== PHP 5.3 now required ===
Since 1.20, the lowest supported version of PHP is now 5.3.2. Please
upgrade PHP if you have not done so prior to upgrading MediaWiki.

=== Configuration changes in 1.20 ===
* $wgGitRepositoryViewers defines a mapping from Git remote repository to the
  Gitweb instance URL used in Special:Version.
* `$wgUsePathInfo = true;` is no longer needed to make $wgArticlePath work on servers
  using like nginx, lighttpd, and apache over fastcgi. MediaWiki now always extracts
  path info from REQUEST_URI if it's available.
* The user right 'upload_by_url' is no longer given to sysops by default.
  This only affects installations which have $wgAllowCopyUploads set to true.
* Removed f-prot support from $wgAntivirusSetup.
* New variable $wgDBerrorLogTZ to provide dates in the error log in a
  different timezone than the wiki timezone set by $wgLocaltimezone.
* New variables $wgDBssl and $wgDBcompress to enable SSL and compression for database
  connections, if either are available for the selected DB type.
* $wgUseCombinedLoginLink now defaults to false, making MediaWiki output separate
  login and create account links by default.

=== New features in 1.20 ===
* Added TitleIsAlwaysKnown hook which gets called when determining if a page exists.
* Added NamespaceIsMovable hook which gets called when determining if pages in a
  certain namespace can be moved.
* Added SpecialPageBeforeExecute hook which gets called before SpecialPage::execute.
* Added SpecialPageAfterExecute hook which gets called after SpecialPage::execute.
* Added ORMTable, ORMRow and ORMResult classes for additional abstraction of
  database interaction.
* Added CacheHelper and associated SpecialCachedPage and CachedAction helper classes.
* (bug 32341) Add upload by URL domain limitation.
* &useskin=default will now always display the default skin. Useful for users with a
  preference for the non-default skin to look at something using the default skin.
* (bug 27619) Remove preference option to display broken links as link?
* (bug 34896) jQuery JSON plugin upgraded to v2.3 (2011-09-17).
* (bug 34302) Add CSS classes to email fields in user preferences.
* Introduced $wgDebugDBTransactions to trace transaction status (currently PostgreSQL only).
* (bug 23795) Add parser itself to ParserMakeImageParams hook.
* Introduce a cryptographic random number generator source api for use when
  generating various tokens.
* (bug 30963) Option on Special:Prefixindex and Special:Allpages to not show redirects.
* (bug 18062) New message when edit or create the local page of a shared file.
* (bug 22870) Separate interface message when creating a page.
* (bug 17615) nosummary option should be reassigned on preview/captcha.
* (bug 34355) Add a variable and parser function for the namespace number.
* (bug 35649) Special:Version now shows hashes of extensions checked out from git.
* (bug 35728) Git revisions are now linked on Special:Version.
* "Show Changes" on default messages shows now diff against default message text
* (bug 23006) create #speciale parser function.
* generateSitemap can now optionally skip redirect pages.
* (bug 27757) New API command just for retrieving tokens (not page-based).
* Added GitViewers hook for extensions using external git repositories to have a web-based
  repository viewer linked to from Special:Version.
* Memcached debug logs can now be sent to their own file logs by setting
  $wgDebugLogFile['memcached'] to some filepath.
* (bug 35685) api.php URL and other entry point URLs are now listed on
  Special:Version
* Edit notices can now be translated.
* jQuery upgraded to 1.8.2.
* jQuery UI upgraded to 1.8.23.
* QUnit upgraded from v1.2.0 to v1.10.0.
* (bug 37604) jquery.cookie upgraded to 2011 version.
* (bug 22887) Add warning and tracking category for preprocessor errors
* (bug 31704) Allow selection of associated namespace on the watchlist
* (bug 5445) Now remove autoblocks when a user is unblocked.
* Added $wgLogExceptionBacktrace, on by default, to allow logging of exception
  backtraces.
* Added device detection for determining device capabilities.
* QUnit.newMwEnvironment now supports passing a custom setup and/or teardown function.
  Arguments signature has changed. First arguments is now an options object of which
  'config' can be a property. Previously 'config' itself was the first and only argument.
* New getCreator and getOldestRevision methods added to WikiPage class
* (bug 4220) the XML dump format schema now have unique identity constraints
  for page and revision identifiers. Patch by Elvis Stansvik.
* cleanupSpam.php now can delete spam pages if --delete was specified instead of blanking
  them.
* Added new hook ChangePasswordForm to allow adding of additional fields in Special:ChangePassword
* Added new function getDomain to AuthPlugin for getting a user's domain
* (bug 23427) New magic word {{PAGEID}} which gives the current page ID.
  Will be null on previewing a page being created.
* (bug 37627) UserNotLoggedIn() exception to show a generic error page whenever
  a user is not logged in.
* Watched status in changes lists are no longer indicated by <strong></strong>
  tags with class "mw-watched". Instead, each line now has a class
  "mw-changeslist-line-watched" or "mw-changeslist-line-not-watched", and the
  title itself is surrounded by <span></span> tags with class "mw-title".
* Added ContribsPager::reallyDoQuery hook allowing extensions to data to MyContribs
* Added new hook ParserAfterParse to allow extensions to affect parsed output
  after the parse is complete but before block level processing, link holder
  replacement, and so on.
* (bug 34678) Added InternalParseBeforeSanitize hook which gets called during Parser's
  internalParse method just before the parser removes unwanted/dangerous HTML tags.
* Added new hook AfterFinalPageOutput to allow modifications to buffered page output before sent
  to the client.
* (bug 36783) Implement jQuery Promise interface in mediawiki.api module.
* Make dates in sortable tables sort according to the page content language
  instead of the site content language
* (bug 37926) Deleterevision will no longer allow users to delete log entries,
  the new deletelogentry permission is required for this.
* (bug 14237) Allow PAGESINCATEGORY to distinguish between 'all', 'pages', 'files'
  and 'subcats'
* (bug 38362) Make Special:Listuser includeable on wiki pages.
* Added support in jquery.localize for placeholder attributes.
* (bug 38151) Implemented mw.user.getRights for getting and caching the current
  user's user rights.
* Session storage can now configured independently of general object cache
  storage, by using $wgSessionCacheType. $wgSessionsInMemcached has been
  renamed to $wgSessionsInObjectCache, with the old name retained for backwards
  compatibility. When this feature is enabled, the expiry time can now be
  configured with $wgObjectCacheSessionExpiry.
* Added a Redis client for object caching.
* Implemented mw.user.getGroups for getting and caching user groups.
* (bug 37830) Added $wgRequirePasswordforEmailChange to control whether password
  confirmation is required for changing an email address or not.
* HTMLForm mutators can now be chained (they return $this)
* A new message, "api-error-filetype-banned-type", is available for formatting
  API upload errors due to the file extension blacklist.
* New hook 'ParserTestGlobals' allows to set globals before running parser tests.
* Allow importing pages as subpage.
* Add lang and hreflang attributes to language links on Login page.
* (bug 22749) Create Special:MostInterwikis.
* Show change tags when transclude Special:Recentchanges(linked) or Special:Newpages.
* (bug 23226) Add |class= parameter to image links in order to add class(es) to HTML img tag.
* (bug 39431) SVG animated status is now shown in long description.
* (bug 39376) jquery.form upgraded to 3.14.
* SVG files will now show the actual width in the SVG's specified units
  in the metadata box.
* Added ResourceLoader module "jquery.jStorage" (v0.3.0, http://jStorage.info/).
* (bug 39273) Added AJAX support for "Show changes" (diff) in LivePreview.
* Added ResourceLoader module "jquery.badge".
* mw.util.$content now points to the overall content area in the skin rather than just
  page text content area. If you need the old behavior please use $( '#mw-content-text').
* jsMessage has been replaced with a floating bubble notification system complete
  with auto-hide, multi-message support, and message replacement tags.
* jquery.messageBox which appears to be unused by both core and extensions has
  been removed.
* (bug 34939) Made link parsing insensitive ([HttP://]).
* (bug 40072) Add CSS classes to items in output of ChangesList pages.
* Added $wgCopyUploadProxy global to define which proxy to use for copy
  uploads.
* (bug 40448) mediawiki.legacy.mwsuggest has been replaced with a new module,
  mediawiki.searchSuggest, based on SimpleSeach from Extension:Vector.

=== Known issues in 1.20.0 ===
These are issues that we're targeting to be fixed in a later release
in the 1.20 series.  Issues may be added or removed from this list as
we see fit.  For now, it is comprised of those bugs on the 1.20.0
milestone in Bugzilla.

* (bug 35894): Reports of secret key generation "hanging" on windows
    This is probably a bug that has been fixed in PHP.  If you run
    into this, try upgrading your PHP.
* (bug 38334): PHP Notice:  Undefined index: href in /www/w/skins/Vector.php on line 416
    We think this is a problem in some extension.  If you see this,
    try disabling your extensions and check out the logging patch on
    this bug.  Or try this patch:
    <https://gerrit.wikimedia.org/r/#/c/27937/1/skins/Vector.php>
* (bug 39268): [Regression] Toolbar inserts in main textarea only (instead of the focussed textarea)
    This should only be an issue if you are using the ProofreadPage
    extension.
* (bug 40641): Clicking "others" in Special:Version asks to download a file
    If you encounter this, you can tell your webserver to serve the
    CREDITS file with text/plain MIME type to fix it.

=== Bug fixes in 1.20 ===
* (bug 40939): [Regression] InfoAction: Call to a member function getUserText() on a non-object
* (bug 40780): searchsuggest-containing line ("containing...") doesn't include the entered text
* (bug 37714): [Regression] Incomplete log entries
* (bug 27202): API: Add timestamp sort to list=allimages
* (bug 30245) Use the correct way to construct a log page title.
* (bug 34237) Regenerate an empty user_token and save to the database
  when we try to set the user's cookies for login.
* (bug 32210) New edit emails for watched pages always provide a link to the
  edit which triggered the mail.
* (bug 12021) Added user talk link on Special:Listusers.
* (bug 34445) section edit and TOC hide/show links are excluded from selection and
  copy/paste on supporting browsers.
* (bug 34428) Fixed incorrect hash mismatch errors in the DiffHistoryBlob
  history compression method.
* (bug 34702) Localised parentheses are now used in more special pages.
* (bug 34723) When editing a script page on a RTL wiki the textbox should be LTR.
* (bug 34762) Calling close() on a DatabaseBase object now clears the connection.
* (bug 34863) Show deletion log extract on non-existent file pages if applicable.
* (bug 28019) Let ?preloadtitle=foo be passed on to target of
  Special:MyPage and Special:MyTalk.
* (bug 34929) Show the correct diff when a section edit is rejected by the spam
  filter.
* (bug 15816) Add a switch for SETting the search_path (Postgres).
* (bug 34521) Returning to the previous page after logging in loses any array-
  valued parameters in the query string.
* (bug 34735) Updated compressOld.php documentation to mention the different
  usages of -s and -n parameters depending on compression type.
* (bug 13896) Rendering of devanagari numbers in automatic '#' number lists.
* (bug 33689) Upgrade to 1.19 on Postgres fails due to incomplete query when.
  trying to defer foreign key for externallinks.
* (bug 32748) Printer friendly version of article decode Unicode chars as a
  pretty IRI in footer.
* Removed white border around thumbnails in galleries.
* (bug 31236) "Next" and "Previous" buttons are shown incorrectly in
  an RTL environment.
* (bug 35749) Updated maintenance/checkSyntax.php to use Git instead of
  Subversion when invoked with the --modified option.
* (bug 35069) On history pages, the " . . " separator after the number of
  characters changed in a revision is now suppressed if no text would follow.
* (bug 18704) Add a unique CSS class or ID to the tagfilter table row at RecentChanges
* (bug 33564) transwiki import sometimes result in invalid title.
* (bug 35572) Blocks appear to succeed even if query fails due to wrong DB structure
* (bug 31757) Add a word-separator between help-messages in HTMLForm
* (bug 30410) Removed deprecated $wgFilterCallback and the 'filtered' API error.
* (bug 32604) Some messages needs escaping of wikitext inside username.
* (bug 36537) Rename wfArrayToCGI to wfArrayToCgi for consistency with wfCgiToArray.
* (bug 25946) The message on the top of Special:RecentChanges is now displayed.
  in user language instead of content language.
* (bug 35264) Wrong type used for <ns> in export.xsd
* (bug 24985) Use $wgTmpDirectory as the default temp directory so that people
  who don't have access to /tmp can specify an alternative.
* (bug 27283) SqlBagOStuff breaks PostgreSQL transactions.
* (bug 35727) mw.Api ajax() should put token parameter last.
* (bug 37708) mw.Uri.clone() should make a deep copy.
* (bug 38024) ResourceLoader should not create empty stylesheets for modules
  that don't have stylesheets.
* (bug 36812) Special:ActiveUsers "Hide bots" should hide users from any group
  having the "bot" user right, instead of just the default "bot" user group.
* (bug 35082) mw.util.addPortletLink incorrectly adds link to mutiple <ul> tags.
* (bug 36991) jquery.tablesorter should extract date sort format from date
  string instead of global config. Dates like "April 1 2012" and "1 April 2012"
  now sort correctly regardless of the content language's DefaultDateFormat.
* (bug 31895) mw.loader mode now correct when triggered from a $.fn.ready
  handler that is bound before mediawiki.js's handler (e.g. browser-userscripts
  like greasemonkey).
* (bug 38152) jquery.tablesorter: Use .data() instead of .attr(), so that live
  values are used instead of just the fixed values from when the tablesorter
  was initialized.
* (bug 38093) Gender of changed user groups missing in Special:Log/rights
* (bug 35893) Special:Block needs to load mediawiki.special.block.js.
* (bug 37331) ResourceLoader modules sometimes execute twice in Firefox
* (bug 31644) GlobalUsage, CentralAuth and AbuseLog extensions should not use
  insecure links to foreign wikis in the WikiMap.
* (bug 36073) Avoid duplicate element IDs on File pages.
* (bug 25095) Special:Categories should also include the first relevant item
  when "from" is filled.
* (bug 35526) jquery.tablesorter now uses a stable sort.
* (bug 38953) --memory-limit switch not working for runJobs.php.
* (bug 33037) Make subpage of Special:newfiles control how many files
  are returned, like in previous versions.
* (bug 36524) "Show" options on Special:RecentChanges and Special:RecentChangesLinked
  are now remembered between successive clicks.
* (bug 26069) Page title is no longer "Error" for all error pages.
* (bug 39297) Show warning if thumbnail of animated image will not be animated.
* (bug 38249) Parser will throw an exception instead of outputting gibberish if
  PCRE is compiled without support for unicode properties.
* (bug 30390) Suggested file name on Special:Upload should not contain
  illegal characters.
* EXIF below sea level GPS altitude data is now shown correctly.
* (bug 39284) jquery.tablesorter should not consider "."" or "?"" to be a currency.
* (bug 39273) "Show changes" should not be incorrectly displayed in the Live Preview state.
* Made body-content lang attribute honor the variant language when it is set.
* (bug 36761) "Mark pages as visited" now submits previously established filter options.
* (bug 39635) PostgreSQL LOCK IN SHARE MODE option is a syntax error.
* (bug 36329) Accesskey tooltips for Firefox 14 on Mac should use "ctrl-option-" prefix.
* (bug 32552) Drop unused database field cat_hidden from table category.
* (bug 24502) Do not allow multiple language links to the same language.
* (bug 40214) Category pages no longer use deprecated "width" HTML attribute.
* (bug 39941) Add missing stylesheets to the installer pages
* In HTML5 mode, allow new input element types values (such as color, range..)
* (bug 36151) mw.Title: Don't limit extension in title parsing.
* (bug 38158) jquery.byteLimit sometimes causes an unexpected 0 maxLength being enforced.
* (bug 38163) jquery.byteLimit incorrectly limits input when using methods other than
  basic per-char typing.
* (bug 34495) patrol log now credit the user patrolling (instead of patrolled
  user).
* (bug 31676) ResourceLoader should work around IE stylesheet limit.
* (bug 40498) ResourceLoader should not output an empty "@media print { }" block.
* (bug 40500) ResourceLoader should not ignore media-type for urls in debug mode.
* (bug 40660) ResourceLoaderWikiModule should not convert "&nbsp;" to a space
  for pages from the MediaWiki-namespace.
* (bug 40329) (bug 40632) Removed CleanupPresentationalAttributes feature.

=== API changes in 1.20 ===
* (bug 34316) Add ability to retrieve maximum upload size from MediaWiki API.
* (bug 34313) MediaWiki API intro message about "HTML format" should mention
  the format parameter.
* (bug 32384) Allow descending order for list=watchlistraw.
* (bug 31883) Limit of bkusers of list=blocks and titles of action=query is
  not documented in API help.
* (bug 32492) API now allows editing using pageid.
* (bug 32497) API now allows changing of protection level using pageid.
* (bug 32498) API now allows comparing pages using pageids.
* (bug 30975) API import of pages with invalid characters in this wiki leads to Fatal Error.
* (bug 30488) API now allows listing of backlinks/embeddedin/imageusage per pageid.
* (bug 34927) Output media_type for list=filearchive.
* (bug 28814) add properties to output of action=parse.
* (bug 33224) add variants of content language to meta=siteinfo.
* (bug 32643) action=purge with forcelinkupdate no longer crashes when ratelimit is reached.
* The paraminfo module now also contains result properties for most modules.
* (bug 32348) Allow descending order for list=alllinks.
* (bug 31777) Upload unknown error ``fileexists-forbidden''.
* (bug 32382) Allow descending order for list=iwbacklinks.
* (bug 32381) Allow descending order for list=backlinks, list=embeddedin and list=imageusage.
* (bug 32383) Allow descending order for list=langbacklinks.
* API meta=siteinfo can now return the list of known variable IDs.
* (bug 35980) list=deletedrevs now honors drdir correctly in "all" mode (mode #3).
* (bug 29290) API avoids mangling fields in continuation parameters
* (bug 36987) API avoids mangling fields in continuation parameters
* (bug 30836) siteinfo prop=specialpagealiases will no longer return nonexistent special pages
* (bug 38190) Add "required" flag to some token params for hint in api docs.
* (bug 27567) Add file repo support to prop=duplicatefiles.
* (bug 27610) Add archivename for non-latest image version to list=filearchive
* (bug 38231) Add xml parse tree to action=parse.
* Watchlist notification timestamp may be queried by page and may be updated via the API.
* (bug 38904) prop=revisions&rvstart=... no longer blows up when continuing.
* (bug 39032) ApiQuery generates help in constructor.
* (bug 11142) Improve file extension blacklist error reporting in API upload.
* (bug 39665) List of query generators is now not built using reflection, instead it is
  defined in code.
* (bug 35993) Deprecated gettoken parameter - support will be removed in 1.22.

=== Languages updated in 1.20 ===

MediaWiki supports over 350 languages. Many localisations are updated
regularly. Below only new and removed languages are listed, as well as
changes to languages because of Bugzilla reports.

* Emilian (egl) added.
* Tornedalen Finnish (fit) added.
* Mizo (lus) added.
* Santali (sat) added.
* (bug 34192) Namespace gender aliases for Albanian languages (sq & aln).
* (bug 35541) Namespace gender aliases for Croatian (hr).
* (bug 36012) Space in $separatorTransformTable should be non-breaking in
  Portuguese, Esperanto and Udmurt.
* Turoyo (tru) added.
* Cyrillic-Latin language converter added for Uzbek (uz).

=== Other changes in 1.20 ===
* The user_token field is now left empty until a user attempts to login and
  cookies need to be set. It is also now possible to reset every user's
  user_token simply by clearing the values in the user_token column.
* Removed ./tests/qunit/index.html from core. It wasn't actively maintained and
  has been made obsolete when [[Special:JavaScriptTest/qunit]] was introduced,
  which actually uses ResourceLoader, LocalSettings and the Skin.
* Removed $wgDBtransactions global. This was only checked in one class
  and only applies to MyISAM or similar DBs. Those should only be used
  for archived sites anyway. We can't get edit conflicts on such sites,
  so the WikiPage code wasn't useful there either.
* Deprecated mw.user.name in favour of mw.user.getName.
* Deprecated mw.user.anonymous in favour of mw.user.isAnon.
* Deprecated DatabaseBase functions newFromParams(), newFromType(), set(),
  quote_ident(), and escapeLike() were removed.
* Use of __DIR__ instead of dirname( __FILE__ ).
* OutputPage::wrapWikiMsg() no longer supports the 'options' parameter. It was
  not used and complicated migration to Message class.
* Live preview functionality has been improved and moved into the
 'mediawiki.action.edit.preview' module. The old 'mediawiki.legacy.preview' module
  has been removed.
* (bug 40448) Removed mediawiki.legacy.mwsuggest module, and removed the
  following that has become obsolete:
  - globals $wgEnableMWSuggest and $wgMWSuggestTemplate.
  - mw.config.values wgMWSuggestTemplate and wgSearchNamespaces.
  - method SearchEngine::getMWSuggestTemplate().

== MediaWiki 1.19 ==

== MediaWiki 1.19.2 ==

This is a security release of the MediaWiki 1.19 branch

=== Changes since 1.19.1 ===
* (bug 39700) File: link to non-existing file can inject html
* (bug 39823) Hidden block text leaking to admins
* (bug 39184) LDAP password leakage
* (bug 39180) Disallow framing of api results
* (bug 37587) Enforce language codes to be html safe
* (bug 39824) Check global blocks on account creation

== MediaWiki 1.19 ==

MediaWiki 1.19 is a large release that contains many new features and bug
fixes. This is a summary of the major changes of interest to users.
You can consult the RELEASE-NOTES-1.19 file for the full list of changes in
this version.

Our thanks go to everyone who helped to improve MediaWiki by testing the beta
release and submitting bug reports.

=== Changes since 1.19.1 ===
* (bug 38406) Properly quote table names in DatabaseBase::tableName()
* (bug 38249) Parser will throw an exception instead of outputting gibberish if
  PCRE is compiled without support for unicode properties.

=== Changes since 1.19.0 ===
* (bug 36568) Fixed "Illegal string offset 'LIMIT'" warnings in updater
* (bug 36938) Correctly escape uselang attribute to prevent xss
* Expanded Blacklist for SVG Files

=== Changes since 1.19 beta 2 ===
* Special:Watchlist no longer sets links to feed when the user is anonymous.
* (bug 35961) Hash comparison should always be strict.
* Fix broken email confirmation expiration caused by MWCryptRand changes.
* (bug 35671) PHP Notice: Undefined index: gettoken in includes/api/ApiMain.php
  on line 598.
* (bug 36042) 'show' causes a fatal in blocks API.

=== Changes since 1.19 beta 1 ===
* (bug 35014) Including a special page no longer sets the page's title to the
  included page
* (bug 35019) Edit summaries are no longer transformed in notification e-mails
* (bug 35152) Help message for e-mail is shown again in user preferences
* (bug 34887) $3 and $4 parameters are now substituted correctly in message
  "movepage-moved"
* (bug 34841) Edit links are no longer displayed when display old page versions
* (bug 34889) User name should be normalized on Special:Contributions
* (bug 35051) If heading has a trailing space after == then its name is not
  preloaded into edit summary on section edit
* (bug 31417) New ID mw-content-text around the actual page text, without categories,
  contentSub, ... The same div often also contains the class mw-content-ltr/rtl.
* (bug 35303) Proxy and DNS blacklist blocking works again
* (bug 22555) Remove or skip strip markers from tag hooks like &lt;nowiki&gt; in
  core parser functions which operate on strings, such as padleft.
* (bug 18295) Don't expose strip markers when a tag appears inside a link
  inside a heading.
* (bug 34212) ApiBlock/ApiUnblock allow action to take place without a token
  parameter present.
* (bug 34907) Fixed exposure of tokens through load.php that could have facilitated
  CSRF attacks.
* (bug 35317) CSRF in Special:Upload.

=== Configuration changes in 1.19 ===
* Removed SkinTemplateSetupPageCss hook; use BeforePageDisplay instead.
* (bug 27132) movefile right granted by default to registered users.
* Default cookie lifetime ($wgCookieExpiration) is increased to 180 days.
* (bug 31204) Removed old user.user_options.
* $wgMaxImageArea now applies to jpeg files if they are not scaled with
  ImageMagick.
* Introduced $wgQueryPageDefaultLimit (defaults to 50) for the number of
  items to show by default on query pages (special pages such as Whatlinkshere).
* (bug 32470) Increase the length of ug_group.
* (bug 32239) Removed $wgEnableTooltipsAndAccesskeys.
* Removed $wgVectorShowVariantName.
* Removed $wgExtensionAliasesFiles. Use $wgExtensionMessagesFiles.
* Removed $wgResourceLoaderInlinePrivateModules , now always enabled.

=== New features in 1.19 ===
* (bug 19838) Add ability to get all interwiki prefixes also if the interwiki
  cache is used.
* $wgDnsBlacklistUrls now accepts an array with url and key as the
  elements to work with DNSBLs that require keys, such as
  Project Honeypot.
* (bug 30022) Add support for custom loadScript sources to ResourceLoader.
* (bug 19052) Unicode space separator characters (Zs) now terminates external
  links and images links.
* (bug 30160) Add public method to mw.loader to get module names from registry.
* (bug 15558) Parameters to special pages included in wikitext can now be passed
  as with templates.
* Installer now issues a warning if mod_security is present.
* (bug 29455) Add support for a filter callback function in jQuery byteLimit
  plugin.
* Added two new GetLocalURL hooks to better serve extensions working on a
  limited type of titles.
* Added a --no-updates flag to importDump.php that skips updating the links
  tables.
* Most presentational html attributes like valign are now converted to inline
  css style rules. These attributes were removed from html5 and so we clean
  them up when $wgHtml5 is enabled. This can be disabled using
  $wgCleanupPresentationalAttributes.
* Magic words (time and number-formatting ones, plus DIRECTIONMARK, but not
  NAMESPACE) now depend on the page content language instead of the site
  language. In theory this sets the right magic words in system messages,
  although they are not used there.
* (bug 30451) Add page_props to RefreshLinks::deleteLinksFromNonexistent.
* (bug 30450) Clear page_props table on page deletion.
* Hook added to check for exempt from account creation throttle.
* (bug 30344) Add configuration variable for setting custom priorities when
  generating sitemaps.
* (bug 96170) Add array support for space-separated list attributes (like
  'class') in the Html helper class.
* (bug 26470) Add checkered background image on hover on files pages.
* (bug 30774) mediawiki.html: Add support for numbers and booleans in the
  attribute values and element contents.
* Conversion script between Tifinagh and Latin for the Tachelhit language.
* (bug 16755) Add options 'noreplace' and 'noerror' to {{DEFAULTSORT:...}}
  to stop it from replace an already existing default sort, and suppress error.
* (bug 18578) Rewrote revision delete related messages to allow better
  localisation.
* (bug 30364) LanguageConverter now depends on the page content language
  instead of the wiki content language.
* Jump links will now be usable in CSS-capable browsers instead of only
  in outdated text browsers.
* New common*.css files usable by skins instead of having to copy piles
  of generic styles from MonoBook or Vector's css.
* Some deprecated presentational html attributes will now be automatically
  converted to css.
* (bug 31297) Add support for namespaces in Special:RecentChanges subpage filter
  syntax.
* The default user signature now contains a talk link in addition to the user link.
* (bug 25306) Add link of old page title to MediaWiki:Delete_and_move_reason.
* Added hook BitmapHandlerCheckImageArea.
* (bug 30062) Add $wgDBprefix option to cli installer.
* getUserPermissionsErrors and getUserPermissionsErrorsExpensive hooks are now
  also called when checking for 'read' permission.
* Introduce $wgEnableSearchContributorsByIP which controls whether searching
  for an IP address redirects to the contributions list for that IP.
* (bug 8859) Database::update should take array of tables too.
* (bug 19698) Add "Inverse namespaces" option to Special:Contributions.
* (bug 24037) Add byte length of revision to Special:Contributions.
* (bug 1672) Added $wgDisableUploadScriptChecks to allow uploading of files
  containing HTML or JS. DISABLING THESE CHECKS IS VERY DANGEROUS.
* New path mappings can be added using the WebRequestPathInfoRouter hook
  and adding paths to the PathRouter.
* (bug 32666) Special:ActiveUsers now allows a subpage to be used as value for the
  "target" query parameter (eg. Special:ActiveUsers/Username).
* New JavaScript variable wgPageContentLanguage.
* Added new debugging toolbar, enabled with $wgDebugToolbar.
* Differences in the history page now uses slightly better colors for people
  perceiving colors differently.
* (bug 32879) Upgrade jQuery to 1.7.1.
* jQuery UI upgraded to 1.8.17.
* Extensions can use the 'Language::getMessagesFileName' hook to define new
  languages using messages files outside of core.
* (bug 32512) Add 'Associated namespace' checkbox to Special:Contributions.
* Added $wgSend404Code, true by default, which can be set to false to send a
  200 status code instead of 404 for nonexistent articles.
* (bug 33447) Link to the broken image tracking category from Special:Wantedfiles.
* (bug 27724) Add timestamp to job queue.
* (bug 30339) Implement SpecialPage for running javascript tests. Disabled by default, due to
  tests potentially being harmful, not to be run on a production wiki.
  Enable by setting $wgEnableJavaScriptTest to true.
* Extensions can use the RequestContextCreateSkin hook to override what skin is
  loaded in some contexts.
* (bug 33456) Show $wgQueryCacheLimit on cached query pages.
* (bug 10574) Add an option to allow all pages to be exported by Special:Export.
* mediawiki.js Message object constructor is now publicly available as mw.Message.
* (bug 29309) Allow CSS class per tooltip (tipsy).
* (bug 33565) Add accesskey/tooltip to submit buttons on Special:EditWatchlist.
* (bug 17959) Inline rendering/thumbnailing for Gimp XCF images.
* (bug 27775) Namespace has it's own XML tag in the XML dump file.
* (bug 30513) Redirect tag is now resolved in XML dump file.
* sha1 xml tag added to XML dump file.
* (bug 33646) Badtitle error page now emits a 400 HTTP status.
* Special:MovePage now has a dropdown menu for namespaces.
* (bug 34420) Special:Version now shows git HEAD sha1 when available.
* (bug 33952) Refactor mw.toolbar to allow dynamic additions at any time.

=== Bug fixes in 1.19 ===
* $wgUploadNavigationUrl should be used for file redlinks if.
  $wgUploadMissingFileUrl is not set. The first was used for this
  until the second was introduced in 1.17.
* BREAKING CHANGE:  Style rules for wikitable are now more specific and prevent
  inheritance to nested tables which caused various issues (bug 30485 and bug
  33434). If your wiki has overriden rules for ".wikitable", please revise them and
  adjust where neccecary. For comparison, use the "table.wikitable" section in
  skins/common/shared.css as base.
* $wgUploadNavigationUrl is now used for file redlinks if
  $wgUploadMissingFileUrl is not set. The former was used for this until the
  second was introduced in 1.17.
* (bug 27894) Move 'editondblclick' event listener down from body to
  div#bodyContent.
* (bug 30172) The check for posix_isatty() in maintenance scripts did not detect
  when the function exists but is disabled. Introduced
  Maintenance::posix_isatty().
* (bug 30264) Changed installer-generated LocalSettings.php to use
  require_once() instead require() for included extensions.
* Do not convert text in the user interface language to another script.
* (bug 26283) Previewing user JS/CSS pages didn't load other user JS/CSS pages.
* (bug 26486) ResourceLoader modules with paths to nonexistent files cause PHP
  warnings/notices to be thrown.
* (bug 30335) Fix for HTMLForms using GET that were breaking when non-friendly
  URLs are used.
* (bug 28649) Preventing half truncated multi-byte unicode characters when
  truncating log comments.
* Show --batch-size option in help of maintenance scripts that support it.
* (bug 4381) Magic quotes cleaning was not comprehensive, key strings were not
  unescaped.
* (bug 23057) Importers no longer can 'edit' or 'create' a fully-protected page by
  importing a new revision into it.
* Allow moving the associated talk pages of subpages even if the base page
  has no subpage.
* Per page edit-notices now work in namespaces without subpages enabled.
* (bug 31081) $wgEnotifUseJobQ is no longer unconditionally enqueueing jobs.
* (bug 30202) File names are now restricted on upload to 240 bytes, because of
  restrictions on some of the database fields.
* Timezones are now recognised in user preferences when offset is different
  due to DST.
* (bug 31692) "summary" parameter now also works when undoing revisions.
* (bug 18823) "move succeeded" text displayed bluelinks even when redirect was
  suppressed.
* (bug 19186) Special:UserLogin's title on Special:SpecialPages now says
  "create account" when the user cannot create an account.
* (bug 31818) 'usercreated' message now supports GENDER.
* (bug 32022) Our phpunit.php script can now be executed from another directory.
* (bug 26020) Setting $wgEmailConfirmToEdit to true no longer removes diffs.
  from recent changes feeds.
* (bug 30232) add current time to message wlnote on Special:Watchlist.
* (bug 29110) $wgFeedDiffCutoff did not affect new pages.
* (bug 32168) Add wfRemoveDotSegments for use in wfExpandUrl.
* (bug 32358) Do not display "No higher resolution available" for dimensionless
  files (like audio files).
* (bug 32168) Add wfAssembleUrl for use in wfExpandUrl.
* (bug 32168) fixed - wfExpandUrl expands dot segments now.
* (bug 31535) Upload comments now truncated properly, and don't have brackets.
* (bug 32086) Special:PermanentLink now show an error message when no subpage
  was specified.
* (bug 30368) Special:Newpages now shows the new page name for moved pages.
* (bug 1697) The way to search blocked usernames in block log should be clearer.
* (bug 29747) eAccelerator shared memory caching has been removed since it is
  now disabled by default and is buggy. APC, XCache and WinCache are not affected.
* Installer now refuses to install if php was not compiled with Ctype support.
* (bug 29475) Remove "trackback" feature entirely from core.
* (bug 32665) Special:BlockList prefills the username in the input field if
  using the Special:BlockList/username URL.
* (bug 27721) Make JavaScript variables wgSeparatorTransformTable and
  wgDigitTransformTable depend on page content language so the sort script
  sorts correctly more often.
* (bug 32230) Expose wgRedirectedFrom in JavaScript.
* (bug 31212) History tab not collapsed when the screen is narrow.
* (bug 15521) Use new section summary when the action of adding a new section
  also happens to create the page.
* (bug 32960) Remove EmailAuthenticationTimestamp from database when a
  email address is removed.
* (bug 32414) Empty page get a empty bytes attribute in Export/Dump.
* (bug 33101) Viewing a User or User talk of username resembling IP ending
  with .xxx causes Internal error.
* Warning about undefined index in certain situations when $wgLogRestrictions
  causes the first log type requested to be removed but not the others.
* Use separate message ('prefixindex-namespace') for title of
  Special:PrefixIndex rather then re-using Special:AllPages's allinnamespace.
* (bug 33156) Special:Block now allows you to confirm you want to block yourself
  when using non-normalized username.
* (bug 33246) News icon shown for news:// URLs but not for news: URLs.
* (bug 33305) Make mw.util.addCSS resistant to IE's @font-face bug by setting
  cssText after DOM insertion.
* (bug 30711) When adding a new section to a page with section=new, the text is
  now always added to the current version of the page.
* (bug 31719) Fix uploads of SVGs exported by Adobe Illustrator by expanding
  XML entities correctly.
* (bug 30914) Embeddable ResourceLoader modules (user.options, user.tokens)
  should be loaded in <head> for proper dependency resolution.
* (bug 32702) Removed method Skin::makeGlobalVariablesScript() has been readded
  for backward compatibility.
* (bug 31469) Make sure tracking category messages expand variables like
  {{NAMESPACE}} relative to correct title.
* (bug 33454) ISO-8601 week-based year number (format character 'o') is now
  calculated correctly with respect to timezone.
* (bug 32219) InstantCommons now fetches content from Wikimedia Commons using
  HTTPS when the local wiki is served over HTTPS.
* (bug 33525) clearTagHooks doesn't clear function hooks.
* (bug 33523) Function tag hooks don't appear on Special:Version.
* Files with IPTC blocks we can't read no longer prevent extraction of exif
  or other metadata.
* (bug 33587) Remove action "historysubmit" from history pages.
* (bug 25800) mw.config wgAction should contain the actually performed action instead
  of whatever the query value contains.
* (bug 4438) Add CSS hook for current WikiPage action.
* (bug 33703) Common border-bottom color for <abbr> should inherit default (text) color.
* (bug 33819) Display file sizes in appropriate units.
* (bug 32948) {{REVISIONID}} and related variables are no longer blank after doing
  a null edit.
* (bug 33880) $wgUsersNotifiedOnAllChanges should not send e-mail to user who made
  the edit.
* (bug 33902) Decoding %2B with mw.Uri.decode results in ' ' instead of +.
* (bug 33762) QueryPage-based special pages no longer misses *-summary message.
* Other sizes links are no longer generated for wikis without a 404 thumbnail handler.
* (bug 29454) Enforce byteLimit for page title input on Special:MovePage.
* (bug 34114) CSSMin::remap() doesn't respect its $embed parameter.
* Special:Contributions/newbies now shows the contributions for the user "newbies".
  New user contributions are obtained using the form or using ?contribs=newbie in URL.
* It is now possible to delete images that have no corresponding description pages.
* (bug 33165) GlobalFunctions.php line 1312: Call to a member function
  getText() on a non-object.
* (bug 31676) Group dynamically inserted CSS into a single <style> tag, to work
  around a bug where not all styles were applied in Internet Explorer.
* (bug 28936, bug 5280) Broken or invalid titles can't be removed from watchlist.
* (bug 34600) Older skins using useHeadElement=false were broken in 1.18.
* (bug 34604) [mw.config] wgActionPaths should be an object instead of a numeral
  array.* (bug 12262) Indents and lists are now aligned
* (bug 29753) mw.util.tooltipAccessKeyPrefix should be alt-shift for Chrome
   on Windows
* (bug 25095) Special:Categories should also include the first relevant item
   when "from" is filled.
* (bug 34972) An error occurred while changing your watchlist settings for
  [[Special:WhatLinksHere/Example]]

=== API changes in 1.19 ===
* Made action=edit less likely to return "unknownerror", by returning the actual error
  message (which may have come from a hook call or similar).
* (bug 19838) siprop=interwikimap can now use the interwiki cache.
* (bug 29748) Add API search prefix support.
* (bug 29684) Set forgotten parameter types in ApiQueryIWLinks.
* (bug 29685) do not output NULL parentid with list=deletedrevs&drprop=parentid.
* siprop=interwikimap and siprop=languages can use silanguagecode to have
  a best effort language name translation. Use CLDR extension for best result.
* (bug 30230) action=expandtemplates should not silently override invalid title
  inputs.
* (bug 18634) Create API to fetch MediaWiki's language fallback tree structure.
* (bug 26885) Allow show/hide of account blocks, temporary blocks and single IP
  address blocks for list=blocks.
* (bug 30591) Add support to only return keys in ApiAllMessages.
* The API now respects $wgShowHostnames and won't share the hostname in
  severedby if it's set to false.
* wlexcludeuser parameter added to ApiFeedWatchlist.
* (bug 7304) Links on redirect pages no longer cause the redirect page to show
  up as a redirect to the linked page on Special:Whatlinkshere.
* (bug 32609) API: Move captchaid/captchaword of action=edit from core
  to Captcha extension(s).
* Added 'APIGetDescription' hook.
* (bug 32688) Paraminfo for parameter "generator" of the query module shows too
  many types.
* (bug 32415) Empty page get no size attribute in API output.
* (bug 31759) Undefined property notice in querypages API.
* (bug 32495) API should allow purge by pageids.
* (bug 33147) API examples should explain what they do.
* (bug 33482) Api incorrectly calls ApiBase::parseMultiValue if allowed
  values is given as an array.
* (bug 32948) {{REVISIONID}} and related variables are no longer blank after
  calling action=purge&forcelinkupdate.
* (bug 34377) action=watch now parses messages using the correct title instead
  of "API".
* (bug 35036) WikiLove messages were not automatically updated in JavaScript
  after having been changed on-wiki due to a bug in core

=== Languages updated in 1.19 ===

MediaWiki supports over 350 languages. Many localisations are updated
regularly. Below only new and removed languages are listed, as well as
changes to languages because of Bugzilla reports.

* Canadian English (en-ca) (new).
* Norwegian (bokmål) (nb) (renamed from no).
* Uighur (Latin) (ug-latn) was incorrectly marked as right-to-left language.
* (bug 30217) Make pt-br a fallback of pt.
* (bug 31193) Set fallback language of Assamese from Bengali to English.
* Update date format for dsb and hsb: month names need the genitive.
* (bug 28643) Serbian variant conversion improvements (Nikola Smolenski).
* (bug 29405, bug 30809) Lower diacritics are invisible in titles in Indic
  languages Assamese, Bengali, Hindi, Malyalam and Odiya.
* (bug 32826) Titles in indic languages are partially cut.
* (bug 33367) Gendered namespaces for Czech.
* (bug 33014) Language::formatSize()/formatBitrate() should be able to deal
  with larger numbers (tera-yotta).

=== Other changes in 1.19 ===
* BREAKING CHANGE: Legacy global array 'ta' and global function 'akeytt' have
  been removed from wikibits.js.
* jquery.mwPrototypes module was renamed to jquery.mwExtension.
* The maintenance script populateSha1.php was renamed to the more concise
  populateImageSha1.php.
* The Client-IP header is no longer checked for when trying to resolve a client's
  real IP address.
* (bug 22096) Although IE5.x and below was already unsupported officially, stylesheets
  existing exclusively for IE5.0 and IE5.5 have now been removed (which were in skins
  'chick' and 'monobook').
* The constructor for CategoryView has changed, the second parameter is now a
  Context source and is required.
* The Title::escape{Local,Full,Canonical}URL methods are deprecated, please use
  proper html building methods to escape the normal get{...}URL methods instead.
* The $variant arguments in the Title::get{Local,Full,Link,Canonical}URL methods
  have been replaced with a secondary query argument.
* The $variant argument in the hooks for the Title::get{Local,Full,Link,Canonical}URL
  methods have been removed, the variant is now part of the $query argument.
* Removed Title::isValidCssJsSubpage(), deprecated since 1.17 in favor of
  using Title::isCssJsSubpage() or checking Title::isWrongCaseCssJsPage().
* Support for the deprecated hook MagicWordMagicWords was removed.
* The Xml::namespaceSelector method has been deprecated, please use
  Html::namespaceSelector instead (note that the parameters have changed also).
* (bug 33746) Preload popular ResourceLoader modules (mediawiki.util) as stop-gap
  for scripts missing dependencies.
  New configuration variable $wgPreloadJavaScriptMwUtil has been introduced for this
  (set to false by default for new installations). Set to true if your wiki has a large
  amount of user/site scripts that are lacking dependency information. In the short to
  medium term these user/site scripts should be fixed by adding the used modules to the
  dependencies in the module registry and/or wrapping them in a callback to mw.loader.using.

== MediaWiki 1.18 ==

== MediaWiki 1.18.5 ==
2012-08-30

This is a security release of the MediaWiki 1.18 branch

=== Changes since 1.18.4 ===
* (bug 39700) File: link to non-existing file can inject html
* (bug 39823) Hidden block text leaking to admins
* (bug 39184) LDAP password leakage
* (bug 39180) Disallow framing of api results
* (bug 37587) Enforce language codes to be html safe
* (bug 39824) Check global blocks on account creation

== MediaWiki 1.18.4 ==
2012-06-12

This is a security release of the MediaWiki 1.18 branch.

=== Changes since 1.18.3 ===
* (bug 36938) Correctly escape uselang attribute to prevent xss
* Expanded Blacklist for SVG Files

== MediaWiki 1.18.3 ==
2012-04-25

This is a maintenance release of the MediaWiki 1.18 branch.

=== Changes since 1.18.2 ===
* (bug 35446) Using "{{nse:}}" with an invalid namespace name no longer throws
  a PHP warning.
* (bug 35567) The whole password reminder e-mail is now sent in the same language.
* (bug 35961) Hash comparison should always be strict.
* (bug 35671) PHP Notice: Undefined index: gettoken in includes/api/ApiMain.php
  on line 598.
* Fix broken email confirmation expiration caused by MWCryptRand changes.

== MediaWiki 1.18.2 ==
2012-03-21

This is a maintenance and security release of the MediaWiki 1.18 branch.

=== Changes since 1.18.1 ===
* (bug 33686) could not get a list of contributor for an article when using
 a SQLite database.
* (Bug 33865) Exception thrown in action=parse when attempting to use the title
  parameter without setting the text parameter.
* UserMailer could potentially throw a fatal error when a MailAddress object had
  an empty email address.
* (Bug 33087) Exchange server rejected mail sent by MediaWiki
* (bug 34528) Edit section tooltips show correction section name again
* (bug 34246) MediaWiki:Whatlinkshere-summary message is displayed again in
  Special:Whatlinkshere
* (bug 22555) Remove or skip strip markers from tag hooks like &lt;nowiki&gt; in
  core parser functions which operate on strings, such as formatnum.
* (bug 34212) ApiBlock/ApiUnblock allow action to take place without a token
  parameter present.
* (bug 34907) Fixed exposure of tokens through load.php that could have facilitated
  CSRF attacks.
* (bug 35317) CSRF in Special:Upload.

== MediaWiki 1.18.1 ==
2012-01-11

This a maintenance and security release of the MediaWiki 1.18 branch.

=== Changes since 1.18.0 ===
* (bug 32712) Fix for search indexing of pages with certain unicode chars following URL.
* (bug 3901) Lang, hreflang attribs added to sidebar interlanguage links for screen readers.
* (bug 30774) mediawiki.html: Add support for numbers and booleans in the
  attribute values and element contents.
* (bug 32473) [[Special:PasswordReset]] can not be used on private wiki.
* (bug 32853) Fixed CACHE_DBA object cache type.
* (bug 32786) Backward compatibility for extension using 1.17's Database::newFromType().
* Fixed exception when using Special:WhatLinksHere on a Media: file.
* (bug 32709) Private Wiki users were always taken to Special:Badtitle on login.
* (bug 33240) Sort images are missing but referenced in css.
* (bug 31921) Magic words REVISIONDAY, REVISIONMONTH and REVISIONYEAR were
  not showing their values on preview.
* (bug 32702) Removed method Skin::makeGlobalVariablesScript() has been readded
  for backward compatibility.
* (bug 30172) The check for posix_isatty() in maintenance scripts did not detect
  when the function exists but is disabled. Introduced Maintenance::posix_isatty().
* (bug 33305) Make mw.util.addCSS resistant to IE's @font-face bug by setting
  cssText after DOM insertion.
* (bug 29102) Upgrades no longer fail with the error "Unknown character set: 'mysql4'.
* (bug 25355) Parser generates edit section links for special pages.
* (bug 33321) Adding a line to MediaWiki:Sidebar that contains a pipe, but doesn't
  have any pipes after being transformed by MessageCache, causes exception on
  all pages.
* Fixed recentchanges FK violation on page delete and cache purge error in updater
  for Oracle DB.
* (bug 33117) prop=revisions allows deleted text to be exposed through cache pollution.

== MediaWiki 1.18.0 ==
2011-11-24

This is the first stable release of the MediaWiki 1.18 branch.

=== Summary of selected changes in 1.18 ===

Selected changes since MediaWiki 1.17 that may be of interest:

* Some of the more commonly used MediaWiki extensions are now included in the
  release tarball. These extensions are ConfirmEdit, Gadgets, Nuke, ParserFunctions,
  Renameuser, Vector and WikiEditor.

* Gender support has been improved, meaning user pages can display the correct gender
  variant of "User" can now be used.

* MediaWiki can now detect the camera orientation of an image from the Exif metadata, and
  can rotate the image thumbnail appropriately. Metadata support has been generally
  improved, and can now extract IPTC and XMP metadata.

* Improved directionality support in 1.18 means that MediaWiki is better to use for
  RTL users.

* MediaWiki now supports protocol - relative URLs in links, interwiki targets and $wgServer

* Math support has been removed from core

=== Changes since 1.18.0rc1 ===
* (bug 32228) regression in Special:Search which did not conserve profile on new search
* (bug 32460) Categories were improperly aligned in Simple and CologneBlue
* (bug 32412) TOC links on [[Special:EditWatchlist]] points to the fieldsets
* (bug 32582) Fix TOC show/hide link regression on IE 8

=== Changes since 1.18 beta 1 ===
* (bug 31886) Wrong titles redirecting to Special:Badtitle in the 1.18 deployment.
* (bug 32051) Fix description for wlprop=sizes.
* (bug 31913) Special:MostLinkedTemplates had an incorrect GROUP BY clause
  under Microsoft SQL.
* (bug 32100) installer complains about suhosin GET limit.
* (bug 31933) fix 1.18 regression in Monobook sidebar: huge spacing between portlets
  on IE 7 and IE 8/9 in compatibility view.
* (bug 32126) Fix 1.18 regression in watchlist editor when items already removed
  from watchlist.
* (bug 32183) remove the client-* classes added from user-agent-sniffing onto
  the <html> element.
* (bug 29912) Unit tests break if parsertest tables are still present.
* (bug 31694) During installation, tabbing order (cursor focus) goes to logo
  instead of 'continue'.
* (bug 29102) Upgrade fails "Unknown character set: 'mysql4".
* (bug 31990) justify paragraphs pref adds extra space to category listing.
* (bug 20148) Better title for [[Special:Disambiguations]] page.
* (bug 31502) TOC is missing on Special:EditWatchlist.
* (bug 32256) API list=search stops at first invalid result.
* (bug 32047) jquery.tablesorter.js: thead is before caption.
* (bug 29854) Store protocol-relative links twice in the externallinks table,
  one with http: in el_index and once with https.
* (bug 31822) Error during upgrade due to output buffer reset in stdout.

=== Configuration changes in 1.18 ===
* The WantedPages::getSQL hook has been removed and replaced with
  WantedPages::getQueryInfo. This may break older extensions.
* The SkinTemplateBuildContentActionUrlsAfterSpecialPage,
  SkinTemplateContentActions and SkinTemplateTabs hooks have been removed in
  favor of SkinTemplateNavigation and SkinTemplateNavigation::SpecialPage.
* $wgUseCombinedLoginLink controls whether to output a combined
  login / create account link in the personal bar, or to output separate login
  and create account links.
* Skin names are no longer created based on a ucfirst version of the key in
  $wgValidSkinNames but now the value. This means for
  $wgValidSkinNames["monobook"] = "MonoBook"; the skin loader will no longer try
  loading SkinMonobook and will instead load SkinMonoBook.
* $wgMaxUploadSize may now be set to an array to specify the upload size limit
  per upload type.
* $wgAPICacheHelp added in 1.16 is now removed. To disable API help caching, set
  $wgAPICacheHelpTimeout = 0;
* OutputPage::isUserJsAllowed() no longer returns false when scripts are allowed
  by the page, but $wgAllowUserJs is set to false.
* Pure "Skin" class based custom skins are no longer supported, all custom skins
  should be put together using SkinTemplate and BaseTemplate or QuickTemplate.
* The transliteration for passwords in case they were migrated from an old
  Latin-1 install (previous to MediaWiki 1.5) is now only done for wikis with
  $wgLegacyEncoding set.
* (bug 27508) Add $wgSVGMetadataCutoff to limit the maximum amount of an SVG we
  look at when finding metadata to prevent excessive resource usage.
* $wgSysopUserBans and $wgSysopRangeBans (deprecated in 1.17) are now removed.
  Use $wgBlockCIDRLimit = array( 'IPv4' => 43, 'IPv6' => 128 ) to achieve the
  same functionality as $wgSysopRangeBans; you can use the BlockIp hook to
  replicate $wgSysopUserBans functionality.
* The options on the block form have been standardised such that checking a box
  makes the block 'more serious'; so while "check to prevent account creation"
  and "check to enable autoblock" remain the same, "check to allow user-talk
  edit" is reversed to "check to *disable* user-talk edit", and "check to block
  anon-only" becomes "check to block logged-in users too".  The default settings
  remain the same.
* Most of the field names on the Special:Block form have been changed, which
  will probably break screen-scraping bots.
* (bug 26866) The 'trackback' right is no longer granted to sysops by default.
  $wgUseTrackbacks is already false by default.
* (bug 17009) the hiddenStructure CSS class, a highly hackish way of at least
  *appearing* to hide article elements, has been removed.  Use the
  ParserFunctions extension to actually remove unwanted elements from the
  output.
* (bug 14202) $wgUseTeX has been superseded by the Math extension. To re-enable
  math conversion after upgrading, obtain the Math extension from SVN or from
  http://www.mediawiki.org/wiki/Extension:Math and add to LocalSettings.php:
  require_once "$IP/extensions/Math/Math.php";
* $wgProfiler is now a configuration array, see StartProfiler.sample for
  details.
* $wgProfiling has been removed.
* The spyc library is now no longer included in phase3.
* (bug 28343) Unused preferences contextlines/contextchars have been removed
* $wgSkinExtensionFunctions has been removed. Use $wgExtensionFunctions instead.
* $wgProto has been removed. You now only need to set $wgServer to change the
  URL protocol.
* $wgRateLimitsExcludedGroups (deprecated in 1.13) has been removed.
* $wgInputEncoding and $wgOutputEncoding (deprecated in 1.5) have now been removed.
* $wgAllowUserSkin (deprecated in 1.16) has now been removed.
* $wgExtraRandompageSQL (deprecated in 1.16) has now been removed.
* LogReader and LogViewer classes (deprecated in 1.14) have now been removed.
* (bug 26033) Added $wgArticleCountMethod to select the method to use to say
  whether a page is an article or not. $wgUseCommaCount is now deprecated.
* $wgEnableDublinCoreRdf and $wgEnableCreativeCommonsRdf no longer work in core,
  and the functionality has been moved to the relevant extensions. See
  http://www.mediawiki.org/wiki/Extension:DublinCoreRdf and
  http://www.mediawiki.org/wiki/Extension:CreativeCommonsRdf as appropriate.
* (bug 21107) Split error "customcssjsprotected" into separate messages for JS and CSS
* Removed $wgCheckCopyrightUpload from DefaultSettings, since the relevant feature
  was removed in about 1.5.
* LogPageValidTypes, LogPageLogName, LogPageLogHeader and LogPageActionText
  hooks have been removed.
* New hook "Collation::factory" to allow extensions to create custom
  category collations.
* $wgGroupPermissions now supports per namespace permissions.
* $wgEnableAutoRotation enables or disables auto-rotation. Leaving it set to
  null will cause MediaWiki to determine if auto-rotation is available.

=== New features in 1.18 ===
* BREAKING CHANGE: action=watch / action=unwatch now requires a token.
* BREAKING CHANGE: Article class hierarchy split into WikiPage (backend).
  and Article (frontend) hierarchies. Several hooks now pass a WikiPage object instead
  of an Article object. These hooks all use an $article paramater as documented in hooks.txt.
  Extensions should be updated to account for this, though most won't require any changes.
* (bug 27860) Minor edit after clicking 'new section' tab
  Now the "This is a minor edit" checkbox is not available when you
  create a page or new section.
* (bug 8130) Query pages should limit to content namespaces, not just main
  namespace.
* Special:Contribs now redirects to Special:Contributions.
* (bug 6672) Images are now autorotated according to their EXIF orientation.
  This only affects thumbnails; the source remains unrotated.
* (bug 25708) Update case mappings and normalization to Unicode 6.0.0.
* New hook ArticlePrepareTextForEdit added, called when preparing text to be
  saved.
* New parser option PreSaveTransform added, allows the pre-save transformation
  to be selectively disabled.
* Alternative to $wgHooks implemented, using the new Hooks class.
* Add width parameter to Special:Filepath to allow getting the file path of a
  thumbnail.
* (bug 26870) Add size to {{filepath:}}.
* Upload warnings now show a thumbnail of the uploaded file.
* Introduced the edittools-upload message, which will be inserted under the
  upload form instead of edittools if available.
* (bug 26285) Extensions will be automatically generated on upload if the user
  specified a filename without extension.
* (bug 26851) Special:UserRights now allows to prefill the reason field
* New maintenance script to fix double redirects
  (maintenance/fixDoubleRedirects.php).
* (bug 23315) New body classes to allow easier styling of special pages.
* (bug 27159) Make email confirmation code expiration time configurable.
* (bug 29047) CSS/JS for each user group is imported from MediaWiki:Group-sysop.js,
  MediaWiki:Group-autoconfirmed.css, etc.
* (bug 24230) Uploads of ZIP types, such as MS Office or OpenOffice can now be
  safely enabled. A ZIP file reader was added which can scan a ZIP file for
  potentially dangerous Java applets. This allows applets to be blocked
  specifically, rather than all ZIP files being blocked.
* (bug 2429) Allow selection of associated namespace in recent changes.
* (bug 26217) File size is now checked before uploading in HTML5 browsers.
* CSS stylesheet MediaWiki:Noscript.css is now loaded for users with JavaScript
  disabled (enclosed in the head in a <noscript> tag).
* Added UserGetLanguageObject hook to change the language used in $wgLang.
* (bug 14645) When $wgMiserMode is on, expensive special pages are styled
  differently (italicized by default) on Special:SpecialPages.
* Added $wgAggregateStatsID, which allows UDP stats to be aggregated over
  several wikis.
* When $wgAllowMicrodataAttributes is true, all itemtypes are allowed, not just
  the three that were defined in the original specification.
* (bug 14706) Added support for the Imagick PHP extension.
* (bug 18691) Added support for SVG rasterization using the Imagick PHP
  extension.
* (bug 2581, bug 6834) Added links to thumbnail in several resolutions to the
  file description page. The sizes are set by $wgImageLimits.
* (bug 28031) Add pageCount support to ArchivedFile.
* (bug 27924) PhpHttpRequest doesn't return response body if HTTP != 200.
* Added hook BitmapHandlerTransform to allow extension to transform a file
  without overriding the entire handler.
* The parser now attempts to output markers for editsection tokens and defer the
  rendering of them post-cache to reduce parser cache fragmentation and ensure
  skin customizability of edit section links.
* (bug 24755) AuthPlugin auto-creation of local accounts can now be aborted by
  other extensions by handling the 'AbortAutoAccount' hook, similar to the
  'AbortNewAccount' triggered by explicit account creations. (They are separate
  to avoid loops and confusion; auth plugins like CentralAuth need to handle
  AbortNewAccount separately.
* Special:ListFiles is now transcludable.
* (bug 13879) Special:Emailuser asks for suitable target user if called without.
* (bug 16956) IPTC and XMP metadata now extracted from images.
* (bug 23816) A tracking category is now added for any pages with broken images.
* (bug 23495) Allow createAndPromote.php to create non-sysop users.
* (bug 28916) A way to to toggle mw.config legacy globals settings from
  LocalSettings.php has been created by introducing $wgLegacyJavaScriptGlobals.
* (bug 28503) Support for ircs:// URL protocols.
* (bug 26033) It is now possible to count all non-redirect pages in content
  namespaces as articles.
* Images can now be embedded in an XML dump stream using backupDump.php
  --include-files and can be imported using importDump.php --uploads;
  furthermore, it can import files from the filesystem using --image-base-path.
* Three new hooks in Special:Undelete, 'UndeleteForm::showHistory',
  'UndeleteForm::showRevision' and 'UndeleteForm::undelete', so that extensions
  may override the usage of PageArchive class and replace it with their own
  class that extends PageArchive.
* (bug 28915) Implement QUnit test suite for MediaWiki JavaScript.
  Also built-in support for distribution through a TestSwarm instance.
* (bug 29036) For cascade-protected pages, the mw-textarea-cprotected class is
  added to the textarea on the edit form.
* mw.util.wikiScript has been implemented (like wfScript in GlobalFunctions.php)
* (bug 29067) Expose user.tokens (like we do user.options) in ResourceLoader.
* New 'Debug' hook used by wfDebug() and wfDebugLog().
* (bug 27655) Require token for watching/unwatching pages)
* (bug 28904) (bug 29773) Update jQuery version from 1.4.4 to 1.6.2 (the latest version)
* (bug 29441) Expose CapitalLinks config in JS to allow modules to properly
  handle titles on case-sensitive wikis.
* (bug 29397) Implement mw.Title module in core.
* In MySQL 4.1.9+ with replication enabled, fetch the slave lag from SHOW SLAVE
  STATUS instead of SHOW PROCESSLIST. This ensures that lag is reported
  correctly in the case where there are no write events occurring. Note that
  the DB user now needs to have the REPLICATION CLIENT privilege if you are
  using replication.
* Language codes in $wgDummyLanguageCodes are now excluded on localization
  statistics (maintenance/language/transstat.php).
* (bug 29586) Make the (next 200) links on categories link directly to
  the relevant section of the category.
* (bug 29109) Allow the automatic edit summary for redirect creation
  show the first bit of the new redirect page.
* (bug 29723) mw.util.wikiGetlink() now defaults to wgPageName.
* (bug 29680) Add GetDefaultSortkey hook to override the default sortkey.
* (bug 16699) {{#language:}} accepts second parameter to specify the language in
  which the language name is wanted. Coverage depends on the cldr extension.
* (bug 15802) An easy way to look up messages: language qqx which returns
  the message keys.
* (bug 29868) Add support for passing parameters to mw.msg in jquery.localize.
* (bug 29558) $wgMiserMode now disables update.php by default.
* AjaxCategories: Easily add, edit or delete categories on article pages.
  Suggests possible categories when typing, all saves are done via AJAX.
  Supports editing of multiple categories and then saving them in one batch.
* $wgAutopromoteOnce was added, allowing for users to be automatically promoted
  to explicit usergroups. If a group is removed from a user via Special:UserRights,
  it will not automatically be re-added. Configuration is similar to
  $wgAutopromote (see DefaultSettings.php).
* The PerformRetroactiveAutoblock hook was added to allow overriding or complementing
  retroactive autoblock handling. This runs when blocking a user with the 'autoblock' option.
* MediaWiki now supports using protocol-relative URLs in links, interwiki
  targets and $wgServer.
* Introduced $wgVaryOnXFPForAPI which will cause the API to send
  Vary: X-Forwarded-Proto headers.
* New maintenance script to refresh image metadata (maintenance/refreshImageMetadata.php).
* (bug 16428) Include permalink in printable version.
* (bug 30722) Add an identity collation that sorts things based on what the
  unicode code point is (aka pre-1.17 behavior).
* (bug 30940) Add a hook in User:getDefaultOptions.
  To give extensions a better and more flexible way of providing default
  values for preferences a hook has been introdiced in User:getDefaultOptions().
  Setting preferences in $wgDefaultUserOptions still work fine, but when reading
  them (i.e. with array_keys) to get a list of all preferences, then
  $wgDefaultUserOptions should no longer be used as it will contain those set via
  User:getDefaultOptions().
* (bug 30497) Add client-nojs and client-js classes on document element
  to let styles easily hide or show things based on general JS availability.
* (bug 31293) If Special:Userlogin is loaded over HTTPS, display
  MediaWiki:loginend-https instead of MediaWiki:loginend, if it's not empty.
  Same for signupend on the account creation page.
* (bug 31233) New OutputPage::addJsConfigVars() method to make the output page specific
  mw.config map extendable.
* mw.util.wikiScript has been implemented (like wfScript in GlobalFunctions.php).

=== Bug fixes in 1.18 ===
* (bug 27860) Minor edit after clicking 'new section' tab.
* (bug 23119) WikiError class and subclasses are now marked as deprecated.
* (bug 10871) Javascript and CSS pages in MediaWiki namespace are no longer
  treated as wikitext on preview.
* (bug 22753) Output from update.php is more clear when things changed, entries
  indicating nothing changed are now all prefixed by "...".
* Page existence is now not revealed (in the colour of the tabs) to users who
  cannot read the page in question.
* (bug 19006) {{REVISIONUSER}} no longer acts like {{CURRENTUSER}} in some
  cases.
* (bug 16019) $wgArticlePath = "/$1" no longer breaks API edit/watch actions.
* (bug 18372) File types blacklisted by $wgFileBlacklist will no longer be shown
  as "Permitted file types" on the upload form.
* (bug 26379) importImages.php gives more descriptive error message on failure.
* (bug 26410) + signs are no longer treated as spaces in internal links if
  link has a % sign in it.
* (bug 26412) Search results headers no longer show a bogus edit link.
* (bug 26540) Fixed wrong call to applyPatch in MysqlUpdater.
* (bug 26574) Added 'upload' to $wgRestrictionTypes, allowing upload protected
  pages to be queried via the API and Special:ProtectedPages, and allowing
  disabling upload protection by removing it from $wgRestrictionTypes.
* If an edit summary exceeds 250 bytes and is truncated, add an ellipse.
* (bug 26638) Database error pages display correctly in RTL languages.
* (bug 26187) Confirmrecreate no longer parses the edit summary.
* (bug 26208) Mark directionality of some interlanguage links.
* (bug 26034) Make the "View / Read" tab in content_navigation style tabs remain
  selected when the action is "purge".
* (bug 14267) Support a MediaWiki:Mainpage-nstab override for the subject
  namespace tab on the mainpage of a wiki.
* (bug 10158) Do not mention allowing others to contact you when the feature
  is disabled ($wgEnableUserEmail=false).
* (bug 26733) Wrap initial table creation in transaction.
* (bug 26729) Category pages should return 404 if they do not exist and have no
  members.
* (bug 2585) Image pages should send 404 if no image, no shared image and no
  description page.
* Custom editintro's using the editintro url parameter will no longer show
  <noinclude> sections on pages they are included on.
* (bug 26449) Keep underlines from headings outside of tables and thumbs by
  adding overflow:hidden to h1,h2,h3,h4,h5,h6 (also fixes editsection bunching).
* (bug 26708) Remove background-color:white from tables in Monobook and Vector.
* (bug 28422) Remove color:black from tables in Monobook and Vector. And add it
  to table.wikitable instead.
* (bug 26781) {{PAGENAME}} and related parser functions escape their output
  better.
* (bug 26716) Provide link to instructions for external editor related
  preferences and add a comment to the ini control file explaining what is
  going on.
* Trying to upload a file with no extension or with a disallowed MIME type now
  gives the right message instead of complaining about a MIME/extension
  mismatch.
* (bug 26809) Uploading files with multiple extensions where one of the
  extensions is blacklisted now gives the proper extension in the error message.
* (bug 26961) Hide anon edits in watchlist preference now actually works.
* (bug 19751) Filesystem is now checked during image undeletion.
* Send last modified headers for Special:Recentchanges when RC patrol is
  enabled, but user cannot see rc patrol links.
* (bug 26548) ForeignAPIRepo (InstantCommons) now works with PDF files
  and other multi-paged file formats.
* Files with a mime type that does not match the extension are now properly
  thumbnailed.
* (bug 27201) Special:WhatLinksHere output no longer contains duplicate IDs.
* (bug 15905) Nostalgia skin could become more usable by including a Talk:
  link at the top of the page.
* (bug 27560) Search queries no longer fail in Walloon language.
* (bug 27679) Broken embedded files with special characters are no longer
  double HTML escaped.
* (bug 27700) The upload protection can now also be set for files that do not
  exist.
* (bug 27763) Article::getParserOutput() no longer throws a fatal given when an
  incorrect revision ID is passed.
* Trim the form field for uploading by url to remove extra spaces which could
  cause confusing error messages.
* (bug 27854) Http::isValidURI is way too lax.
* Do not show enotifminoredits preference, if disabled by $wgEnotifMinorEdits.
* AbortLogin returning "ABORTED" now handled.  Also allows message identifier
  for "ABORTED" reason to be returned and displayed to user.
* (bug 28034) uploading file to local wiki when file exists on shared repository
  (commons) gives spurious info in the warning message.
* Usernames get lost when selecting different sorts on Special:listfiles.
* (bug 14005) editing section 0 of an existing but empty page gives no such
  section error.
* (bug 26939) Installer does not set $wgMetaNamespace.
* (bug 28166) UploadBase assumes that 'edit' and 'upload' rights are not per
  page restrictions.
* Make truncate function automatically consider length of '...' string,
  since length can vary by localization.
* (bug 28242) Make redirects generated by urls containing a local interwiki
  prefix be a 301 instead of a 302.
* (bug 15641) blocked administrators are now prevented from deleting or
  protecting their own talk page; and all blocked users are more
  comprehensively prevented from performing other actions.
* (bug 27893) Edit-on-doubleclick now applies only on view and purge actions;
  no longer triggers unexpectedly on delete, history etc.
* (bug 28417) Fix PHP notice when importing revision without a listed id.
* (bug 28430) Make html and TeX output of <math> always be left-to-right.
* (bug 28306) Fix exposure of suppressed usernames in ForeignDBRepo.
* (bug 28372) Fix bogus link to suppressed file versions in ForeignDBRepo.
* (bug 27473) Fix regression: bold, italic no longer interfere with linktrail
  for ca, kaa.
* (bug 28444) Fix regression: edit-on-doubleclick retains revision id again.
* &apos; character entity is now allowed in wikitext.
* UtfNormal::cleanUp on an invalid utf-8 sequence no longer returns false if
  intl installed.
* (bug 28561) The css class small will no longer make nested elements even
  smaller.
* (bug 13172) Array type exif data (like GPS) was not being extracted from
  images.
* (bug 28532) wfMsgExt() and wfMsgWikiHtml() use $wgOut->parse().
* (bug 16129) Transcluded special pages expose strip markers when they output
  parsed messages.
* (bug 27249) "Installed software" table in Special:Version should always be
  left-to-right.
* (bug 28719) Do not call mLinkHolders __destruct explicitly.
* (bug 21196) Article::getContributors() no longer fails on PostgreSQL.
* (bug 28752) XCache doesn't work in CLI mode.
* (bug 28076) Thumbnail height limited to 360 pixels on Special:Listfiles.
* (bug 22227) Special:Listfiles no longer throws an error on bogus file entries.
* (bug 19408) user_properties.up_property: 32 bytes is not enough.
* (bug 25262) Fix for minification of hardcoded data: URIs in CSS.
* (bug 29263) Add LTR class to the shared CSS to be used for left-to-right text
  such as SQL queries shown in dberrortext and similar messages in RTL
  environments.
* (bug 14977) Fixed $wgServer detection in cases where an IPv6 address is used
  as the server name.
* The View X deleted revisions is now shown again on Special:Upload.
* (bug 29071) mediawiki.action.watch.ajax.js should pass uselang to API.
* (bug 28868) Show total pages in the subtitle of an image on the
  file description page for multi-paged documents.
* (bug 28883) Message names for different compression types commonly
  used in Tiff files.
* When translcuding a special page, do not let it interpret url parameters.
* (bug 28887) Special page classes are no longer re-used during 1 request.
* (bug 28888) Searching for something starting with a # sign no longer tells
  the user a page named [[:]] already exists.
* (bug 23002) Imagelinks table not updated after imagemove.
* (bug 27864) Transcluding {{Special:Prefix}} with empty prefix now lists all
  pages.
* (bug 18803) JPEG2000 images should not be uploadable as .jpg files.
* (bug 11868) If using links to count articles, the checking will now be based
  on the real presence of an internal link instead of the "[[" string.
* (bug 28287) The "your changes" box for edit conflicts is now read-only.
* (bug 28940) When making a thumb of an SVG, and only specifying the height
  make the width be the max SVG size, not the natrual width of the SVG.
* (bug 1780) Uploading files with non-ascii characters are now forbidden on
  Windows.
* (bug 23464) File: prefixes are now chopped off during uploading.
* (bug 28174) Message config-logo-help amended to not explicitly assume any
  LTR/RTL screen layout.
* (bug 28992) Revision numbers in the patrol log are transformed in the user
  language.
* (bug 27073) ResourceLoaderDynamicStyles marker should be dynamically appended to
  the document head if it doesn't exist.
* (bug 27023) After the document is ready, mw.loader is broken (calls callback
  before module is parsed).
* (bug 4330) External URLs without a custom title should be treated as LTR,
  even in RTL text.
* (bug 29055) Make "don't send email on minor edits" preference apply to
  changes to talk page in addition to watchlist edits.
* (bug 28272) Special:AllMessages should have only one "Go" button.
* (bug 29101) Special:FileDuplicateSearch no longer shows silly message.
* (bug 29048) jQuery.tabIndex: firstTabIndex() should not output the same
  as lastTabIndex().
* (bug 29332) Warn if user requests mediawiki-announce subscription but does not
  enter an e-mail address.
* (bug 25375) Add canonical namespaces to "wgNamespaceIds" in mw.config.
* The class JpegOrTiffHandler was renamed ExifBitmapHandler.
* (bug 29443) Special:Undelete should use JavaScript to invert all checkboxes
  instead of reloading the page.
* (bug 29325) Setting $wgStrictFileExtensions to false no longer gives incorrect warning.
* (bug 29437) Multiple apostrophes in deleted article title cause odd rendering.
* (bug 29485) RSS feed of Special:RecentChange grouped together multiple
  consecutive edits by same user in included diff, but then linked to
  a single ungrouped diff.
* Do not try to group together a page creation and edit in the RSS feed of RC.
* (bug 29342) Patrol preferences shouldn't be visible to users who don't have
  patrol permissions.
* (bug 29471) Exception no longer thrown for files with invalid date in metadata.
* (bug 29492) Long-running steps in the installer (such as Upgrade and Install)
  no longer cause timeouts.
* (bug 29507) Change 'image link' to 'file link' in Special:Whatlinkshere.
* If the db is really screwed up, and doesn't have a recentchanges table,
  make the updater throw an exception instead of a fatal.
* wfArrayToCGI() and wfCgiToArray() now handle nested and associative arrays
  correctly.
* (bug 29567) mw.util.addPortletLink should only wrap link in <span> for
  "vectorTabs" portlets.
* (bug 8556) Incorrect session failure warning on preview-on-open
  namespaces (categories) when combined with $wgRawHtml.
* Use content language in formatting of dates in revertpage message
  (rollback revert edit summary) and do not adjust for user timezone.
* (bug 29277) MediaWiki:Filepage.css is also shown on the local wiki
* Make sure Backlink cache does not retrieve interwiki redirects when looking for
  redirects to a local page.
* (bug 6100) Allow different directionality (LTR/RTL) for user interface
  and wiki content, along with many other RTL and directionality improvements
  (such as bugs 28030, 12406, 28349).
* (bug 29712) Removed broken defaultUserOptionOverrides in MessagesXx files and
  unneeded CSS flipping of quickbar. Instead, introduce option 5 which sets
  left/right according to the directionality of your interface language.
* (bug 19514) Unordered list list-style-image should be IE6-compatible (8-bit).
* (bug 27410) The tag filter on a history page is now within a <label> element.
* (bug 29779) DairikiDiff/WikiDiff <ins> and <del> should undo browser default
  styling (strike/underline).
* (bug 28630) Add iwlinks, langlinks, redirect to
  RefreshLinks::deleteLinksFromNonexistent.
* (bug 29797) Error: "Tried to load block with invalid type" when subpages
  are disabled for user pages.
* (bug 12205) Bidirectional names in action=credits are split and displayed.
  incorrectly when wrapped to the next line.
* (bug 20781) Move 'mainpagetext' messages to installer's .i18n file.
* (bug 29737) "MediaWiki:Qbsettings-directionality" should refer to script,
  not language.
* (bug 26360) $wgSessionHandler was overriding system settings unconditionally.
* Removed AjaxFunctions.php. The last remaining function js_unescape() was moved
  to the FCKEditor extension.
* (bug 28762) Resizing to specified height broken for very thin images.
* (bug 29959) Installer fatal when cURL and allow_url_fopen is disabled and user
  tries to subsribe to mediawiki-announce.
* (bug 27427) mw.util.getParamValue shouldn't return value from hash even if
  param is only present in hash.
* Installer checked for magic_quotes_runtime instead of register_globals.
* (bug 30131) XCache with variable caching disabled no longer used for variable
  caching (CACHE_ACCEL)
* $wgSVGMaxSize is now applied to the smaller of width or height, making very wide
  pano/timeline/diagram SVGs renderable at saner sizes.
* (bug 30219) The page shown when LocalSettings.php does not exist was broken on
  Windows servers.
* (bug 30074) Moving user JS subpages resulted in JS errors because
  #REDIRECT [[Foo]] is invalid JS.
* (bug 30335) Fix for HTMLForms using GET breaking when non-friendly URLs
  are used.
* (bug 30264) Changed installer-generated LocalSettings.php to use require_once()
 instead require() for included extensions.
* Tracking categories are no longer shown in footer for special pages.
* (bug 30684) Fix bad escaping in mw.message for inexistent messages (i.e. <key>).
* $wgOverrideSiteFeed no longer double escapes urls.
* The preprocessor no longer fails with a PHP warning about XML_PARSE_HUGE when
  processing complex pages using newer versions of libxml2.
* (bug 30907) Special:Unusedcategories should sort ascendingly.
* (bug 28545) When using the uca-default collation, sortkey's starting with a
  space (U+20) will sort under an invisible header like in 1.16 rather than a U+6DE.
* (bug 30192) Thumbnails of archived files are now deleted.
* (bug 30843) mediawiki.Title should not convert extensions (anything after the
  last full stop) to lower case).
* (bug 31213) Exception thrown when trying to move file cross-namespace.
* (bug 18424) Special:Prefixindex and Special:Allpages paging links are
  really small, and somewhat inconsistent with each other.
* (bug 30466) Entries in iwlinks table are now cleared when moving a page over
  redirect.
* (bug 31674) Can't edit watchlist if it contains special pages.
* (bug 32100) Installer complains about Suhosin GET limit even if it is
  already set above 1024 bytes.

=== API changes in 1.18 ===
* BREAKING CHANGE: action=watch now requires POST and token.
* (bug 26339) Throw warning when truncating an overlarge API result.
* (bug 14869) Add API module for accessing QueryPage-based special pages.
* (bug 14020) API for Special:Unwatchedpages.
* (bug 24287) Wrap API Help output at 100 characters.
* Add a realname uiprop option to query=userinfo so a user's realname can be
  extracted.
* Add a &watchuser option to ApiBlock.
* (bug 26541) Generator-ise ApiQueryRecentChanges.
* action=parse now correctly returns an error for nonexistent pages.
* (bug 25767) Add userrights properties to allusers and users query lists.
* (bug 26558) list=allusers auprop=groups does not list groups a user is
  automatically a member of.
* (bug 26559) list=allusers auprop=rights does not match
  list=users usprop=rights.
* (bug 26560) On allusers if limit < total number of users, last user gets
  duplicate.
* (bug 25135) add "normalized" to action=parse.
* (bug 26460) Add support for listing category members by category pageid.
* (bug 26482) add a imimages param to prop=images.
* (bug 26498) allow LinksUpdate with API.
* (bug 26485) add a elextlinks param to prop=extlinks.
* (bug 26483) add a iwtitles param to prop=iwlinks.
* (bug 26484) add a lltitles param to prop=langlinks.
* (bug 26480) add a pppageprops param to prop=pageprops.
* (bug 26650) Remove $wgAPICacheHelp in favour of $wgAPICacheHelpTimeout.
* (bug 24650) Fix API to work with categorylinks changes.
* Expose list of skins in meta=siteinfo.
* (bug 26548) Add iiurlparam param to query=imageinfo and query=stashimageinfo.
* (bug 27205) aiprop=metadata and aiprop=parsedcomment need help text.
* Add a amtitle param to meta=allmessages.
* (bug 25832) query=allimages now outputs ns/title as well.
* (bug 27199) Thumbnail urls can be fetched for old files as well.
* (bug 27376) when using ApiBase::PARAM_TYPE => 'integer' without a min or
  max value, API doesn't validate the input is actually an integer.
* (bug 27479) API error when using both prop=pageprops and
  prop=info&inprop=displaytitle.
* (bug 27554) Update API information text to reflect change in bug 26125.
* (bug 27611) list=blocks: Use ipb_by_text instead of join with user table.
* (bug 27616) Add userid of blocked user and blocker to list=blocks.
* (bug 27688) Simplify queries to list user block information.
* (bug 27708) list=users does not have a property to return user id.
* (bug 27715) imageinfo didn't respect revdelete.
* (bug 27862) Useremail module didn't properly return success on success.
* (bug 27590) prop=imageinfo now allows querying the media type.
* (bug 27587) list=filearchive now outputs full title info.
* (bug 27018) Added action=filerevert to revert files to an old version.
* (bug 27897) list=allusers and list=users list hidden users.
* (bug 27717) API's exturlusage module does not respect $wgMiserMode.
* (bug 27588) list=filearchive&faprop=sha1 returns empty attribute.
* (bug 28010) Passing a non existant user to list=users gives internal error.
* (bug 27549) action=query&list=users&usprop=groups doesn't show implicit
  groups if a user doesn't have explicit groups.
* (bug 27670) Ordering by timestamp (and usage of start and end) isn't as clear
  in auto generated document, as it is on mediawiki.org.
* (bug 27182) API: Add filter by prefix for meta=allmessages.
* (bug 27183) API: Add filter by customisation state for meta=allmessages.
* (bug 27340) API: Allow listing of "small" categories.
* (bug 27342) Add audir param to list=allusers.
* (bug 27203) add fato param to list=filearchive.
* (bug 27341) Add drto param to list=deletedrevs.
* (bug 26630) Add API for Special:ActiveUsers.
* (bug 27020) API: Allow title prefix search of logevents (only when not in
  miser mode).
* (bug 26629) add Special:MIMESearch to API.
* (bug 27585) add pagecount to list=filearchive.
* (bug 28104) Namespace for local pages in interwiki backlinks (iwbacklinks)
  is missing.
* (bug 27343) Add parseddescription to list=filearchive.
* (bug 27469) label implicit groups in list=allusers&auprop=groups/
  list=users&usprop=groups.
* Addition of APIQuerySiteInfoGeneralInfo hook to add extra information to
  the general site info results.
* (bug 16288) API: consider making closure status of wikis more clear
  with meta=siteinfo.
* (bug 27589) list=allimages&aiprop=archivename is useless.
* (bug 27586) Remove duplication of props in ApiQueryStashImageInfo
  by using ApiQueryImageInfo.
* (bug 28226) prop=extlinks&eloffset should be an integer.
* (bug 28070) Fix watchlist RSS for databases that store timestamps in a
  real timestamp field.
* API upload errors may now return the parameter that needs to be changed and
  a sessionkey to fix the error.
* (bug 28249) allow dupes in meta=allmessages&amargs.
* (bug 28263) cannot import xml with the API, when have not "import" user
  right, but "importupload".
* (bug 28365) Added description for uiprop=preferencestoken in meta=userinfo.
* (bug 28394) Set forgotten parameters types in ApiUnblock.
* (bug 28395) Set forgotten parameters types in ApiParse.
* (bug 28368) add hint for multipart/form-data to API information of
  action=import&xml=.
* (bug 28391) action=feedwatchlist&allrev should be a bool.
* (bug 28364) add registration date to meta=userinfo.
* (bug 28254) action=paraminfo: Extract type from PARAM_DFLT if
  PARAM_TYPE is not set.
* (bug 27712) add parent_id to list=deletedrevs.
* (bug 28455) Add 'toponly' to recentchanges API module.
* (bug 26873) API: Add 'toponly' filter in usercontribs module.
* (bug 28586) YAML: strings that are the same as boolean literals.
* (bug 28591) Update/replace/supplement spyc (YAML parsing library).
* YAML API output is now 1.2 compliant, using JSON as the formatter.
* (bug 28672) give information about misermode on API.
* (bug 28558) Add iw_api and iw_wikiid to meta=siteinfo&siprop=interwikimap
* (bug 26882) Allow listing of indefinite protections with the API.
* (bug 27344) add drprefix param to list=deletedrevs.
* (bug 28560) list=deletedrevs should die, if combination of param is invalid.
* (bug 28238) paraminfo: output both limits for multi param.
* (bug 27179) API: List of extension tags through meta=siteinfo.
* Get a list of function hooks through meta=siteinfo.
* Get a list of all subscribed hooks, and those subscribers.
* (bug 28225) Allow hiding of user groups in list=allusers.
* (bug 27185) API: Add Special:ComparePages.
* (bug 28265) allow outputting of comments for action=expandtemplates.
* (bug 27790) Add query type for querymodules to output of ApiParamInfo.
* (bug 28963) Add langbacklinks query module to the api.
* (bug 27593) API should return error message when sha1/sha1base36 is invalid.
* (bug 28578) API's parse module should not silently override invalid
  title inputs.
* (bug 20699) Watchlist API should list log-events.
* (bug 29070) Require a token in API action=watch.
* (bug 29221) Expose oldrevid in ApiQueryWatchlist output.
* (bug 29267) Always give the servername for meta=siteinfo&siprop=dbrepllag.
* (bug 28897) rvparse now respects rvsection for action=query&prop=revisions.
* (bug 25734) API: Possible issue with revids validation.
* (bug 28002) Internal error in ApiFormatRaw::getMimeType.
* (bug 29237) ApiQuery now has an option to output the "iwurl" attribute.
* (bug 28392) Mark action=undelete&timestamps as type "timestamp".
* (bug 21346) Make deleted images searchable by hash (disabled in Miser Mode).
* (bug 27595) sha1 search of list=filearchive does not work.
* (bug 26763) Make RSS/Atom of user contributions more visible.
* (bug 25133) Allow redirects also for action=parse&pageid.
* (bug 29745) Fatal error in API search.
* (bug 29476) API returns page title instead of sectiontitle for
  srprop=sectiontitle.
* Correct the documentation of srprop properties.
* (bug 28817) Add reference help page link to API Modules.
* (bug 29935) Improve formatting of examples in ApiParamInfo.
* (bug 29938) list=users&usprop=rights shows rights the user doesn't have.
* (bug 24781) The API will include an XML namespace if the includexmlnamespace
  parameter is set.
* (bug 29392) Setting the start or end parameter now works with lists blocks,
  categorymembers, deletedrevs, logevents, protectedtitles, usercontributions
  and watchlist in Postgres.

=== Languages updated in 1.18 ===

MediaWiki supports over 330 languages. Many localisations are updated
regularly. Below only new and removed languages are listed, as well as
changes to languages because of Bugzilla reports.

* Angika (anp) (new).
* Brahui (brh) (new).
* Central Dusun (dtp) (new).
* Jamaican Creole English (jam) (new).
* Khowar (khw) (new).
* Liv (liv) (new).
* Kichwa (qug) (new).
* Tokipona (tp) (removed) 'tokipona' is still  valid.
* (bug 17160) Gender specific display text for User namespace.
* Link trail added for sl and sh.
* (bug 27633) Add characters to linkTrail for Portuguese (pt and pt-br).
* (bug 27426) Set $namespaceGenderAliases for Arabic (ar).
* (bug 27385) Set Polish $namespaceGenderAliases.
* (bug 27681) Set $namespaceGenderAliases for Portuguese (pt and pt-br).
* (bug 27785) Fallback language for Kabardian (kbd) is English now.
* (bug 27825) Raw watchlist edit message now uses formatted numbers.
* (bug 28040) Turkish: properly lower case 'I' to 'i' (dotless i) and
  uppercase 'i' to 'I' (dotted i).
* Conversion script between Syllabics and Latin for the Inuktitut language.
* Date formats for Indonesian (id) updated.
* Bhojpuri (bho) (renamed from "bh").
* (bug 29031) When translating block log entries, indefinite, infinite, and
  infinity are now considered the same.
* Aromanian (rup) (renamed from "rua-rup").
* Kashmiri (ks) split into Kashmiri (Perso-Arabic) (ks-arab) and Kashmiri
  (Devanagari) (ks-deva). Defaults to ks-arab.
* (bug 30864) Use bengali numerals for <ol> for Assamese.
* (bug 30817) Restored linktrail for kk (Kazakh).
* (bug 27398) Add $wgExtraGenderNamespaces for configured gendered namespaces.
* (bug 30846) New LanguageOs class.

=== Other changes in 1.18 ===
* Removed legacy wgAjaxWatch javascript global object, no longer in use.
* (bug 28556) Upload support for MacBinary files has been removed (Used by
  Internet Explorer 5 for Mac OS 9).
* On wiki farm setups using $wgConf, 'wgCanonicalServer' is now expected to be
  set for all wikis. This was already the case for 'wgServer'.

== MediaWiki 1.17 ==

== MediaWiki 1.17.5 ==
2012-06-12

This is a security release of the MediaWiki 1.17 branch.

=== Summary of selected changes in 1.17 ===

Selected changes since MediaWiki 1.16 that may be of interest:

* A new installer has been introduced. It has a wizard-style interface which is
  translated into many languages. Many shortcomings in the old installer were
  addressed with this rewrite. Note that it is no longer required for the config
  directory to be made writable by the webserver. Instead the generated
  LocalSettings.php file is offered as a download, which you must then upload
  to the wiki's base directory.

* ResourceLoader, a new framework for delivering client-side resources such as
  JavaScript and CSS, has been introduced. These resources are now delivered
  through the new entry point script "load.php", instead of as static files
  served directly by the web server. This allows minification, compression and
  client-side caching to be used more effectively, which should provide a net
  performance improvement for most users.

* Category sorting has been improved.
** Sorting is now case insensitive.
** Sub-categories, pages and files can now be paged separately.
** When several pages are given the same sort key, they sort by their
   names instead of randomly.

* The lowest supported version of PHP is now 5.2.3. If necessary, please
  upgrade PHP prior to upgrading MediaWiki.

=== Changes since 1.17.4 ===

* (bug 36938) Correctly escape uselang attribute to prevent xss
* Expanded Blacklist for SVG Files

=== Changes since 1.17.3 ===

* (bug 35961) Hash comparison should always be strict.
* Fix broken email confirmation expiration caused by MWCryptRand changes.
* (bug 35671) PHP Notice: Undefined index: gettoken in includes/api/ApiMain.php
  on line 598.

=== Changes since 1.17.2 ===

* (bug 22555) Remove or skip strip markers from tag hooks like &lt;nowiki&gt; in
  core parser functions which operate on strings, such as padleft.
* (bug 34212) ApiBlock/ApiUnblock allow action to take place without a token
  parameter present.
* (bug 34907) Fixed exposure of tokens through load.php that could have facilitated
  CSRF attacks.
* (bug 35317) CSRF in Special:Upload.

=== Changes since 1.17.1 ===
* (bug 33117) prop=revisions allows deleted text to be exposed through cache pollution.
* (bug 32709) Private Wiki users were always taken to Special:Badtitle on login.

=== Changes since 1.17.0 ===

* (bug 29535) Added missing Creative Commons CC0 icon.
* (bug 29726) Fixed failure to load internationalization messages in
  client-side scripts on WebKit-based browsers.
* Fixed a bug in message transformation where the previous language could leak
  into later transformations in the UI language.
* (bug 29091) Fixed form of native name for Ossetic language (Иронау -> Ирон)
* Fixed maintenance scripts upgrade1_5.php and rebuildImages.php, they did not
  work at all since 1.17 beta 1.
* (bug 29531) Fixed img_auth.php for thumbnails and other filenames with
  multiple dots, was broken by the fix for bug 28840.
* In the maintenance script purgeList.php, fixed a fatal error when a page
  title is given, instead of a URL.
* (bug 19514) Unordered list list-style-image should be IE6-compatible (8-bit).
* Installer checked for magic_quotes_runtime instead of register_globals.
* $wgSVGMaxSize is now applied to the smaller of width or height, making very
  wide pano/timeline/diagram SVGs renderable at saner sizes.
* (bug 29959) Installer fatal when cURL and allow_url_fopen is disabled and user
  tries to subsribe to mediawiki-announce.
* Installer checked for magic_quotes_runtime instead of register_globals
* (bug 30131) XCache with variable caching disabled no longer used for variable
  caching (CACHE_ACCEL)
* (bug 30264) Changed installer-generated LocalSettings.php to use require_once()
  instead require() for included extensions.
* (bug 26486) ResourceLoader modules with paths to nonexistent files cause PHP
  warnings/notices to be thrown
* (bug 30907) Special:Unusedcategories should sort ascendingly.
* (bug 30219) The page shown when LocalSettings.php does not exist was broken on
  Windows servers.
* Hardcoded NLS_NUMERIC_CHARACTERS for Oracle DB to prevent type conversion errors.
* Fixed recentchanges FK violation on page delete and cache purge error in updater
  for Oracle DB.
* (bug 32276) Skins were generating output using the internal page title which
  would allow anonymous users to determine wheter a page exists, potentially
  leaking private data. In fact, the curid and oldid request parameters would
  allow page titles to be enumerated even when they are not guessable.
* (bug 32616) action=ajax requests were dispatched to the relevant internal
  functions without any read permission checks being done. This could lead to
  data leakage on private wikis.

=== Changes since 1.17.0rc1 ===

* Fixed syntax error in generated LocalSettings.php when a non-default user
  rights profile is chosen.
* (bug 29399) Fixed PostgreSQL installation when the DB user for installation
  is the same as the one for web access.
* (bug 29233) Fixed failover for DB slave servers. When a DB slave went down,
  an error was immediately shown to the user, instead of trying another slave.
  Was broken since 1.17 beta 1.
* (bug 29278) Fixed PHP fatal error when attempting to add text to a page via a
  redirect.
* (bug 29408) Fixed uploads of files with MIME types that aren't detected by
  MediaWiki.
* Removed DEFAULT '' NOT NULL field definitions from Oracle DB schema because
  using the DEFAULT value ('') in DML broke Oracle backend as it treats an
  empty VARCHAR2 value as NULL. Indexes on Oracle do not require NOT NULL
  fields.

=== Changes since 1.17 beta 1 ===

* Fixed warning about missing file "password.js".
* When installing on MySQL, don't attempt to create a new database user if the
  same user is used for installation and web access.
* Fixed SQL query errors in queries with table aliases.
* (bug 27891) Fixed the "chronology protector", broken since 1.17beta1, which
  ensures that when database replication is used, the new version is seen by
  the user immediately after they create or edit an article.
* (bug 28845) Allow PostgreSQL installation using a non-root user account which
  has role creation abilities.
* When installing on PostgreSQL and the install account is the same as the web
  account, check to make sure that the account has suitable privileges in the
  mediawiki schema.
* (bug 28172) Fixed error in PostgreSQL installation when creating the wiki
  sysop account.
* Fixed an issue with the Oracle installer in cases where the user is different
  to the database name.
* Added "unblockself" to the list of available rights.
* In the installer, fixed the "user rights profile" option, it never worked.
* (bug 29117) Fixed Hebrew localisation of the installer.
* (bug 28840) Reduce the collateral damage caused by the fix for bug 28235 (XSS
  on Internet Explorer 6 due to a file extension in the query string) by
  reducing the number of URLs that are blocked, and by redirecting the request
  to a safer URL where possible instead of blocking it.
* (bug 28812) Fixed documentation of API action=parse.
* (bug 28979) Fixed styling of <abbr> and <acronym>.
* Fixed the error message displayed when you try to create an account by email,
  but an email address is not given.
* Fixed JS error due to missing dependency for jquery.suggestions.
* Exposed $wgExtensionAssetsPath in JavaScript.
* (bug 28738) Made ResourceLoader support environments with small URL length
  limits. The length limit can be configured via $wgResourceLoaderMaxQueryLength,
  and this is set automatically in the generated LocalSettings.php when the
  php.ini variable "suhosin.get.max_value_length" is set. When a URL exceeds
  this limit, the request is split up. Also, reduced the average length of
  load.php URLs by using a more compact parameter format.
* (bug 25262) Fix for minification of hardcoded data: URIs in CSS.
* (bug 25124) Respect $wgStyleDirectory in ResourceLoader.
* Allow installation when no HTTP client is available, don't throw an exception.
* (bug 27465) Fix metadata extraction for SVG files using unusual namespace
  names.
* (bug 29174) Fix regression in upload-by-URL: uploading files larger than the
  PHP memory limit should work again.
* Fixed the display of comments in the new user log.
* (bug 28237) When installing extensions using the web-based installer, create
  any necessary database tables.
* (bug 28983) Fixed automated installation of extensions that overwrite $path.
* Fixed error caused by missing magic words.
* Fixed breakage of article editing in PostgreSQL due to text search
  configuration errors.
* Fixed the HTTPS client used when Curl is not available. This avoids an error
  during install about failure of the mediawiki-announce subscription.
* (bug 28162) When installing to PostgreSQL, respect the "database port" input,
  it was ignored.

=== Configuration changes in 1.17 ===

* $wgLogAutocreatedAccounts controls whether autocreation of accounts is logged
  to new users log.
* (bug 22858) $wgLocalStylePath is by default set to the same value as
  $wgStylePath but should never point to a different domain than the site is
  on, allowing skins to use .htc files which are not cross-domain friendly.
* $wgFileStore has been deprecated. The only usage $wgFileStore['deleted'] has
  been turned into $wgDeletedDirectory.
* $wgDeletedDirectory has been added to specify what directory to place deleted
  uploads in.
* IBM DB2 database no longer uses the db specific $wgDBport_db2 variable but the
  normal $wgDBport.
* $wgCategoryPrefixedDefaultSortkey was removed and is now always false.  This
  provides more sensible sorting behavior for categories.
* Removed unused globals: $wgEnableSerializedMessages, $wgCheckSerialized,
  $wgUseMemCached, $wgDisableSearchContext, $wgColorErrors, $wgUseZhdaemon,
  $wgZhdaemonHost and $wgZhdaemonPort.
* (bug 24408) The include_path is not modified in the default LocalSettings.php
* $wgVectorExtraStyles was removed, and is no longer in use.
* Removed $wgUpdates for database updates; extensions should use
  DatabaseUpdater::addExtensionUpdate() via the LoadExtensionSchemaUpdates hook.
* Removed $wgServerName. It doesn't need to be set anymore and is no longer
  available as input for other configuration items, either.
* It's no longer necessary for LocalSettings.php to include DefaultSettings.php.
* It's no longer necessary to set $wgCacheEpoch to the file modification time
  of LocalSettings.php, in LocalSettings.php itself. Instead, this is done
  automatically if $wgInvalidateCacheOnLocalSettingsChange is true (which is
  the default).
* $wgCopyrightIcon is deprecated and $wgFooterIcons['copyright']['copyright']
  should be used instead.
* $wgSysopUserBans is deprecated, and will be made permanently true in 1.18.
  If you need this functionality, you should use the BlockIp hook to filter and
  reject such blocks.
* $wgSysopRangeBans is deprecated, you should set $wgBlockCIDRLimit to maximum
  (32 for IPv4, 128 for IPv6), equivalent to allowing rangeblocks of only 1
  address at a time.

=== New features in 1.17 ===

* (bug 10183) Users can now add personal styles and scripts to all skins via
  User:<name>/common.css and /common.js (if user css/js is enabled).
* (bug 22748) Add anchors on Special:ListGroupRights.
* (bug 21981) Add parameter 'showfilename' to <gallery> to automatically
  apply the names of the individual files within the gallery.
* Future-proof redirection to fragments in Gecko, so things work a little nicer
  if they fix <https://bugzilla.mozilla.org/show_bug.cgi?id=516293>.
* Support git:// and mms:// protocols by default for external links.
* (bug 15810) Blocked admins can no longer unblock themselves without the
  'unblockself' permission (which they have by default).
* (bug 18499) Added "enhanced" URL parameter to switch between old and enhanced
  changes list.
* (bug 22925) "sp-contributions-blocked-notice-anon" message now displayed when
  viewing contributions of a blocked IP address.
* (bug 22474) {{urlencode:}} now takes an optional second parameter for type of
  escaping.
* Special:Listfiles now supports a username parameter.
* Special:Random carries over query string parameters.
* (bug 23206) Add Special::Search hook for detecting successful "Go".
* When visiting a "red link" of a deleted file, a deletion and move log excerpt
  is provided on the Upload form.
* (bug 22647) Add category details in search results.
* (bug 23276) Add hook to Special:NewPages to modify query.
* Add accesskey 's' and tooltip to 'Save' button at Special:Preferences.
* Add accesskey 'b' and tooltip to the summary field of edit mode.
* (bug 20186) Allow filtering Special:Contributions for RevisionDeleted edits.
* ajaxwatch now uses the API and JQuery, and can be used to animate arbitrary
  watch links, not just to watch the page the link is on.
* (bug 20976) "searchmenu-new-nocreate" message now displayed when when there
  is no title match in search and the user has no rights to create pages.
* (bug 23429) Added new hook WatchlistEditorBuildRemoveLine.
* (bug 22844) Added support for WinCache object caching (for IIS).
* (bug 23580) Add two new events to LivePreview so that scripts can be notified
  about the beginning and finishing of LivePreview actions.
* (bug 21278) Now the sidebar allows inclusion of wiki markup.
* (bug 23733) Add IDs to messages used on CSS/JS pages.
* Show validity period of the login cookie in Special:UserLogin and
  Special:Preferences.
* Interlanguage links display the page title in their tooltip.
* (bug 23621) New Special:ComparePages to compare (diff) two articles.
* (bug 4597) Provide support in Special:Contributions to show only "current"
  contributions
* (bug 17857) {{anchorencode}} acts more like how the parser creates section ids
* (bug 21477) \& can now be used in <math>
* (bug 11641) \dotsc \dotsm \dotsi \dotso can now be used in <math>
* (bug 21475) \mathtt and \textsf can now be used in <math>
* texvc is now run via ulimit4.sh, to limit execution time.
* SQLite now supports $wgSharedDB.
* (bug 8507) Group file links by namespace:title on image pages.
* Stop emitting named entities, so we can use <!DOCTYPE html> while still being
  well-formed XML.
* texvc now supports \bcancel and \xcancel in addition to \cancel and \cancelto
* Added scriptExtension setting to $wgForeignFileRepos.
* ForeignApiRepo uses scriptDirUrl if apiBase not set.
* (bug 24212) Added MediaWiki:Filepage.css which is also included on foreign
  client wikis.
* (bug 14685) Double underscore magic word usage is now tracked in the
  page_props table, as well as the behavioral magic words {{DEFAULTSORT}} and
  {{DISPLAYTITLE}}
* (bug 24045) MediaWiki:Ipb-needreblock is now wrapped in a div with class
  "mw-ipb-needreblock"
* Non-file pages can no longer be moved to the file namespace, nor vice versa.
* (bug 671) The <dfn>, <kbd> and <samp> elements have been whitelisted in user
  input.
* (bug 21503) There's now a "reason" field when creating account for other users.
* (bug 24418) action=markpatrolled now requires a token.
* A variety of category sort-related fixes, including:
** (bug 164) In English, lowercase and uppercase letters now sort the same.
** (bug 1211) Subcategories, ordinary pages, and files now page separately.
** When several pages are given the same sort key, they sort by their names
   instead of randomly.
* (bug 23848) Add {{ARTICLEPATH}} Magic Word.
* (bug 8140) Add dedicated CSS classes to Special:Newpages elements.
* (bug 11005) Add CSS class to empty pages in Special:Newpages.
* The parser cache is now shared amongst users whose different settings aren't
  used in the page.
* Any attribute beginning with "data-" can now be used in wikitext, per HTML5.
* (bug 24007) Diff pages now mention the number of users having edited
  intermediate revisions.
* Added new hook GetIP.
* Special:Version now displays whether a SQLite database supports full-text
  search.
* TS_ISO_8691_BASIC was added as a time format, which is used by ResourceLoader
  for versioning.
* Maintenance scripts get a --memory-limit option to override defaults (which
  is usually to set it to -1 to disable the limit).
* (bug 25397) Allow uploading (not displaying) of WebP images, disabled
  by default.
* (bug 23194) Special:ListFiles now has thumbnails.
* Use hreflang to specify canonical and alternate links, search engine friendly
  when a wiki has multiple variant languages.
* (bug 19593) Specifying --server in now works for all maintenance scripts.
* Now rebuildtextindex.php warns if SQLite doesn't support full-text search.
* (bug 10541) Front/backend separation of installation/upgrade code.
* (bug 10596) Allow installer to enable extensions already in extensions folder.
* (bug 20627) Installer should be in languages other than English.
* Support for metadata in SVG files (title, description).
* Special:Search: Add CSS classes to 'none found' and 'create link' messages.
* Add CSS classes (including namespace and pagename) to the enhanced recent
  changes/watchlist entries.
* (bug 22463) Add hook 'SkinGetPoweredBy' to make 'powered by' icon/text
  customizable.
* Added CSS print pagination to the print stylesheets.
* (bug 25960) Add <link rel=canonical"> for File pages of shared/foreign
  file repositories.
* When viewing a redirect, the redirect arrow and redirection target are both
  wrapped in a div that has the class "redirectMsg" so that the redirection
  arrow can be customized with CSS.
* (bug 21911) Hard coded limit for long page warning removed. New message
  [[MediaWiki:Longpage-hint]] (empty per default) can be used instead.
  Parameters: $1 shows the formatted textsize in Byte/KB/MB, $2 is the raw
  number of the textsize in Byte.
* (bug 3276) Give image <gallery>s fluid width.
* Added uploads link to page subtitle in Special:Contributions.
* Added Special:Myuploads special page that redirects to Special:Listfiles.
* The footerlinks used in Monobook/Vector/Modern are now part of common skin
  code, SkinTemplateOutputPageBeforeExec can be used to customize the list.
* Special wrapping setups can now define MW_CONFIG_FILE to load a config file
  other than LocalSettings.php. This is like MW_CONFIG_CALLBACK but works in
  some cases where MW_CONFIG_CALLBACK will not work.
* (bug 26574) Added 'upload' to $wgRestrictionTypes, allowing upload protected
  pages to be queried via the API and Special:ProtectedPages, and allowing
  disabling upload protection by removing it from $wgRestrictionTypes.
* The name attribute of HTMLForm fields can now be overridden by passing a
  'name' key in the descriptor array.  Hidden field names are now treated
  consistently with other fields and, by default, prefixed with 'wp'.
* (bug 27402) Add support for disabling MWSuggest.
* (bug 26563) Add bytes changed per revision for stub and full article dumps.
* (bug 27508) Add $wgSVGMetadataCutoff to limit the maximum amount of an svg we
  look at when finding metadata to prevent excessive resource usage.
* (bug 198) $wgUpgradeKey allows unlocking the web installer for upgrades
  without having to move LocalSettings.php
* Added $wgAllowImageTag, which can be set to true to whitelist the <img> tag
  in wikitext.
* (bug 12797) Add $wgGalleryOptions for adjusting of default gallery display
  options.
* Added the $wgAllowUserCssPrefs option which allows disabling CSS-based
  preferences; which can improve page loading speed.
* Added $wgSQLMode for setting database SQL modes - either performance (null)
  or other reasons (such as enabling stricter checks).
* (bug 20193) Added $wgVectorShowVariantName global configuration variable
  which causes Vector to render the variants drop-down menu with a label
  showing the current variant name. This is off by default, pending further
  research into its user experience implications.
* The upload link for missing files can now be set separately from the
  navigation link with $wgUploadMissingFileUrl.
* $wgAdditionalMailParams added to allow setting extra options to mail() calls.
* Added $wgSecureLogin to optionally login using HTTPS.
* (bug 25728) Added $wgPasswordSenderName to make the name associated
  with $wgPasswordSender configurable.
* (bug 22463) $wgFooterIcons added to allow configuration of the icons shown in
  the footers of skins.
* $wgFileCacheDepth can be used to set the depth of the subdirectory hierarchy.
  used for the file cache. Default value is 2, which matches former behavior.

=== Bug fixes in 1.17 ===

* (bug 17560) Half-broken deletion moved image files to deletion archive
  without updating database.
* (bug 22666) Submitting user block form with an invalid user name no longer
  throws an error.
* (bug 22665, bug 22667) User '0' can now be unblocked and have its block
  settings changed.
* (bug 22606) The body of e-mail address confirmation message is now different
  when the address changed.
* (bug 22664) Special:Userrights now accepts '0' as a valid user name.
* (bug 5210)  Preload parser now parses <noinclude>, <includeonly> and
  redirects.
* (bug 22709) IIS7 mishandles redirects generated by OutputPage::output() when
  the URL contains a colon.
* (bug 22353) Categorised recent changes now works again.
* (bug 22747) "Reveal my e-mail address in notification e-mails" preference is
  now only displayed when relevant.
* (bug 22772) {{#special:}} parser function now works with subpages.
* (bug 18664) Relative URIs in interwiki links cause failed redirects.
* (bug 19270) Relative URIs in interwiki links break interwiki transclusion.
* (bug 22903) Revdelete log entries now show in the user preferred language.
* (bug 22905) Correctly handle <abbr> followed by ISBN.
* (bug 22940) Namespace aliases pointing to main namespace don't work.
* (bug 15810) Blocked admins can no longer block/unblock other users.
* (bug 22876) Avoid possible PHP Notice if $wgDefaultUserOptions is not
  correctly set.
* (bug 14952) Page titles are renormalized after html entities are removed so
  that links with non-NFC character references work correctly.
* (bug 22991) wgUserGroups JavaScript variable now reports * group for
  anonymous users instead of null.
* (bug 22627) Remove PHP notice when deleting a page only hidden users edited.
* (bug 21520) Anonymous previews now also gives a warning about not being
  logged in (anonpreviewwarning).
* (bug 22935) image/x-ms-bmp mime type added for BMP files.
* (bug 23024) Special:ListFiles now escapes file names correctly.
* (bug 22867) "View source" tab is now only displayed if there's source text.
* (bug 19393) Feeds now format dates in user language rather than content
  language.
* (bug 22852) "Served in" comment is now the time used to cache a single page
  when using rebuildFileCache.php
* (bug 22496) Viewing diff of a redirect page without specifying "oldid".
  parameter no longer makes the page displayed as being the redirect target.
* (bug 22918) Feed cache keys now use $wgRenderHashAppend.
* (bug 21916) Last-Modified header is now correct when outputting cached feed.
* (bug 20049) Fixed PHP notice in search highlighter that occurs in some cases.
* (bug 23017) Special:Disambiguations now list pages in content namespaces
  rather than only main namespace.
* (bug 23063) $wgMaxAnimatedGifArea is checked against the total size of all.
  frames, and $wgMaxImageArea against the size of the first frame, rather than
  the other way around.  Both now default to 12.5 megapixels.  Also, images
  exceeding $wgMaxImageArea can still be embedded at original size.
* (bug 23078) "All public logs" option on Special:Log is now always the first
  item.
* (bug 16817) Group names in user rights log are now singular and in lowercase.
* Special:Preferences no longer crashes if the wiki default date formatting
  style is not valid for the user's interface language.
* (bug 23167) Check the watch checkbox by default if the watchcreations
  preference is set.
* Maintenance script cleanupTitles is now able to fix titles stored
  in a negative namespace (which is invalid).
* (bug 19858) Removed obsolete <big> in interface messages.
* (bug 21456) "Bad title" error when showing non-local interwiki pages no longer
  displays incorrect tabs.
* (bug 23190) Improved math representation for text browsers.
* (bug 22015) Improved upload-by-url error handling and error display.
* (bug 17941) $wgMaxUploadSize is now honored by all upload sources.
* (bug 23080) New usernames now limited to 235 bytes so that custom skin files
  work.
* (bug 23075) Correct MediaTransformError default width in gallery.
* (bug 16487) The Anonymous user account used on Postgres is no longer
  displayed on Special:Listusers.
* (bug 23313) Move watchlisthidepatrolled above token in watchlist preferences
  to enhance preference grouping.
* (bug 23298) Interwiki links with prefix only in log summaries now link to the
  correct link.
* (bug 23284) Times are now rounded correctly.
* (bug 23375) Added ogv, oga, spx as extensions for ogg files.
* (bug 18408) All required permissions for uploading (upload, edit, create).
  are now checked when loading Special:Upload. Toolbar link for Special:Upload
  is no longer shown if the user does not have the required permissions.
* (bug 23397) texvc in html mode renders \sim as &tilde; not &sim;
* (bug 23241) License selector should be disabled during upload of a new
  version.
* (bug 23240) Add ID to namespace selector form on Special:Watchlist.
* The pipe | character in urls is now escaped.
* (bug 23422) mp3 files can now be moved.
* (bug 23448) MediaWiki:Summary-preview is now displayed instead of
  MediaWiki:Subject-preview when previewing summary.
* (bug 23426) The {{REVISIONMONTH}} variable is now zero-padded and added
  new variable {{REVISIONMONTH1}} when unpadded version is needed.
* Special:Userrights didn't recognize user as changing his/her own rights if
  user did not capitalize first letter of username.
* (bug 23507) Add styles for printing wikitables.
* (bug 19586) Avoid JS errors in mwsuggest when using old browsers such
  as Opera 8.
* (bug 23563) Old skins now support $wgUploadNavigationUrl and take into
  account upload rights.
* (bug 1347) Render \phi in math using images, in order to create consistent
  and correct render results.
* (bug 16573) Render \epsilon in math using images, in order to create
  consistent and correct render results.
* (bug 22541) Support image redirects when using ForeignAPIRepo.
* (bug 22967) Make edit summary length cut-off behave correctly for multibyte
  characters.
* (bug 8689) Long numeric lines no longer kill the parser.
* (bug 23740) Article::doRedirect() now use $extraQuery parameter correctly if
  the $noRedir parameter is set to true.
* (bug 23688) Correct mime types for Office 2007 OpenXML documents.
* (bug 23787) Corrected $wgDefaultSkin's comment in DefaultSettings.php.
* (bug 23797) Xml::input() now allows '0' for the value parameter.
* (bug 23747) Make sure that on History pages, the RevDel button is not
  accidentally activated when hitting enter.
* (bug 23845) Special:ListFiles now uses correct file names without underscores.
* Ask for permanent login in Special:Preferences only if $wgCookieExpiration > 0.
* (bug 16356) Repair dumpInterwiki.inc to use proper normalization.
* (bug 24006) deleteArchivedRevisions.php maintenance script now longer throws
  a fatal error.
* (bug 23465) Don't ignore the predefined destination filename on
  Special:Upload after following a red link.
* (bug 23642) Recognize mime types of MS OpenXML documents.
* (bug 22784) Normalise underscores and spaces in autocomments.
* (bug 19910) Headings of the form ===+\s+ are now displayed as valid headings.
* (bug 24022) Only check file extensions on the uploadpage when needed.
* (bug 24076) Recognize Office 2003 files with OpenXML trailers.
* (bug 24244) Updated comments in DefaultSettings.php to reflect.
  Image: --> File: namespace rename.
* Make wfTimestamp recognize negative unix timestamp values.
* (bug 24401) SimpleSearch: No button/text indicating 'Search' if image is
  disabled.
* (bug 23293) Do not show change tags when Special:RecentChanges(linked) or
  Special:Newpages is transcluded into another page as it messes up the page.
* (bug 24517) LocalFile::newFromKey() and OldLocalFile::newFromKey() no longer
  throw fatal errors.
* (bug 23380) Uploaded files that are larger than allowed by PHP now show a
  useful error message.
* Uploading to a protected title will allow the user to choose a new name
  instead of showing an error page.
* (bug 24425) Use Database::replace instead of delete/insert in
  SqlBagOStuff::set to avoid query errors about duplicate keynames.
* (bug 15470) First letters of filenames are always capitalized by upload JS.
* (bug 21215) NoLocalSettings.php doesn't tolerate rewrite rules.
* (bug 21052) Fix link color for stubs in NewPages.
* (bug 24714) Usage of {{#dateformat: }} in wikis without $wgUseDynamicDates no
  longer pollutes the parser cache.
* (bug 17031) Correct which characters the parser allows in tag attributes (a
  letter, colon or underscore followed by 0 or more letters, numbers, colons,
  underscores, hyphens, and/or periods).
* Save 200 useless queries on each category page view.
* Shell commands will now work on Linux in filesystems mounted noexec.
* (bug 24804) Corrected commafying in Polish and Ukrainian.
* "Difference between pages" is now displayed instead of "Difference between
  revisions" on diffs when appropriate.
* (bug 23703) ForeignAPIRepo fails on findBySha1() when using a 1.14 install as
  a repository due to missing 'name' attribute from the API list=allimages.
* (bug 24898) MediaWiki uses /tmp even if a vHost-specific tempdir is set, also
  make wfTempDir() return a sane value for Windows on worst-case.
* (bug 24824) Support ImageMagick 6.5.6-2+ JPEG decoder size hint, to reduce
  memory usage when such an ImageMagick is used for scaling.
* Disable multithreaded behavior in recent ImageMagick, to avoid a deadlock
  when a resource limit such as $wgMaxShellMemory is hit.
* (bug 24981) Allow extensions to access SpecialUpload variables again.
* (bug 20744) Wiki forgets about an uploaded file.
* (bug 17913) Don't show "older edit" when no older edit available.
* (bug 6204) TOC not properly rendered when using $wgMaxTocLevel.
* (bug 24977) The accesskey in history page now lead directly to the diff.
  instead of alternating focus between the two buttons.
* (bug 24987) Special:ListUsers does not take external groups into account.
* (bug 20633) update.php has mixed language output.
* SQLite system table names are now never prefixed.
* (bug 25292) SkinSubPageSubtitle hook now passes the Skin object as second
  parameter.
* (bug 25167) Correctly load JS fixes for IE6 (fixing a regression in 1.16).
* (bug 25367) wfShellExec() is more explicit when failing due to disabled
  passthru().
* (bug 25462) Fix double-escaping for section edit link tooltips.
* action=raw was removed for Special:Statistics. This information is still
  available via the API.
* (bug 23934) Groups defined in $wgRevokePermissions but not in
  $wgGroupPermissions now appear on Special:ListGroupRights.
* (bug 23923) Special:Prefixindex no longer shows results if nothing was
  requested.
* (bug 22308) Search now finds text in default main page immediately after setup.
* (bug 25697) Make sure empty lines render in diff view.
* Use an actual minus sign in diff views, instead of a hyphen.
* (bug 23732) Clarified "n links" message on Special:MostLinkedFiles.
* (bug 23731) Clarified "n links" message on Special:MostLinkedTemplates.
* (bug 25642) A exception is now thrown instead of a fatal error when using
  $wgSMTP without PEAR mail package.
* (bug 19633) When possible, Upscale small SVGs when creating thumbnails.
* (bug 11013) Database driver detection needs rewriting for robustness.
* (bug 13409) Installer prompts could use clarification--now has help boxes.
* (bug 16902) Installer spews warnings when exec() and dl() are not available.
* (bug 19129) Only show MyISAM/InnoDB when supported.
* (bug 17762) Only show other e-mail options when e-mail is globally enabled.
* Cache multiple sizes of InstantCommons thumbnails.
* (bug 25488) Disallowing anonymous users to read pages no longer throws error
  on discussion pages with vector as default skin.
* (bug 24833) Files name in includes/diff/ are now less confusing.
* (bug 25713) SpecialPage::resolveAlias() now normalise spaces to underscores.
* (bug 25829) Special:Mypage and Special:Mytalk now forward oldid, diff and dir
  parameters.
* (bug 25175) HTML file cache now honor $wgCacheDirectory if
  $wgFileCacheDirectory is not set.
* (bug 13353) Diff3 version checks were too strict, did not detect working diff3.
* (bug 25843) Links to special pages using link= attribute on images are now.
  normalised like normal links to special pages.
* (bug 21364) External links using link= attribute on images now respect
  $wgExternalLinkTarget.
* (bug 17789) Added a note to the total views on Special:Statistics saying that
  is doesn't count non-existing pages and special pages.
* (bug 17996) HTTP redirects are now combined when requesting a special page.
* (bug 19944) Link on image thumbnails no longer link to "Media:" namespace in
  some cases.
* (bug 25670) wfFindFile() now checks the namespace of the given title, only
  "File" and "Media" are allowed now.
* (bug 25872) Rename the HttpRequest class to MWHttpRequest to avoid conflict
  with php extension that defines same class.
* (bug 20591) There's now a different message on Special:MovePage when
  $wgFixDoubleRedirects is set to false.
* Fixed PHP warnings when updating a broken MySQL database.
* (bug 26023) Corrected deleteBacth.php's documentation.
* (bug 25451) Improved datetime representation in 32 bit php >= 5.2.
* Show "skin does not exist error" only when the skin is inputted in the wrong
  case.
* (bug 26164) Potential html injection when the database server isn't available.
* (bug 26160) Upload description set by extensions are not propagated.
* (bug 9675) generateSitemap.php now takes an --urlpath parameter to allow
  absolute URLs in the sitemap index (as required e.g. by Google).
* Partial workaround for bug 6220: at least make files on shared repositories
  show up as (struck-out) bluelinks instead of redlinks on Special:WantedFiles.
* rebuildFileCache.php no longer creates inappropriate cache files for redirects.
* (bug 25512) Subcategory list should not include category prefix for members.
* (bug 10871) Javascript and CSS pages in MediaWiki namespace are no longer
  treated as wikitext on preview.
* Page existence is now not revealed (in the colour of the tabs) to users who
  cannot read the page in question.
* (bug 22753) Output from update.php is more clear when things changed, entries
  indicating nothing changed are now all prefixed by "..."
* (bug 16019) $wgArticlePath = "/$1" no longer breaks API edit/watch actions.
* (bug 18372) File types blacklisted by $wgFileBlacklist will no longer be shown as
  "Permitted file types" on the upload form.
* (bug 26540) Fixed wrong call to applyPatch in MysqlUpdater.
* (bug 26034) Make the "View / Read" tab in content_navigation style tabs remain
  selected when the action is "purge".
* (bug 26733) Wrap initial table creation in transaction.
* (bug 26208) Mark directionality of some interlanguage links.
* (bug 26716) Provide link to instructions for external editor related preferences.
* (bug 26961) Hide anon edits in watchlist preference now actually works.
* (bug 1379) Installer directory conflicts with some hosts' configuration panel.
* (bug 27781) Installer does not warn about 5.1.x. Added a compatibility function
  for array_key_exists().
* Fix XML well-formedness on a few pages when $wgHtml5 is true (the default).
* (bug 28069) MediaWiki fails streaming files when mod_deflate and ob_gzhandler
  are also set.
* (bug 26223) Concurrently moving an article to different titles leaks a
  redirect revision with no page.
* (bug 15641) Fixed permissions checks in Special:Import which allowed users
  without the 'import' permission to import pages from configured import sources.
* (bug 26449) Keep underlines from headings outside of tables and thumbs by
  adding overflow:hidden to h1,h2,h3,h4,h5,h6 (also fixes editsection bunching).
* (bug 26708) Remove background-color:white from tables in Monobook and Vector.
* (bug 26781) {{PAGENAME}} and related parser functions escape their output better.
* (bug 26716) Provide link to instructions for external editor related preferences
  and add a comment to the ini control file explaining what is going on.
* (bug 28422) Remove color:black from tables in Monobook and Vector. And add it
  to table.wikitable instead.
* (bug 27560) Search queries no longer fail in walloon language.
* (bug 27700) The upload protection can now also be set for files that do not
  exist.
* (bug 28034) uploading file to local wiki when file exists on shared repository
  (commons) gives spurious info in the warning message.
* Usernames get lost when selecting different sorts on Special:listfiles.
* (bug 28166) UploadBase assumes that 'edit' and 'upload' rights are not per
  page restrictions.
* (bug 28242) Make redirects generated by urls containing a local interwiki
  prefix be a 301 instead of a 302.
* (bug 28568) Entries in the iwlinks table are now removed on page deletion.
* (bug 28306) Fix exposure of suppressed usernames in ForeignDBRepo.
* (bug 28444) Fix regression: edit-on-doubleclick retains revision id again.
* UtfNormal::cleanUp on an invalid utf-8 sequence no longer returns false if
  intl installed.
* (bug 26729) Category pages should return 404 if they do not exist and have no
  members.
* (bug 28214) When page not found, sends malformed HTTP/1.x instead of HTTP/1.1
  in header of response.
* (bug 27634) TOC title appears in wrong language.
* (bug 27761) Fix regression: pages with Esperanto titles containing convertible
  character sequences became unreachable.
* (bug 27508) SVGMetadataExtractor takes too much resources on huge svgs.
* (bug 27465) SVG thumbnail generation.
* (bug 27467) preload can leave UNIQ.
* (bug 27539) Allow attributes beginning with a digit in wiktext tag parameters.
* (bug 27328) using relative paths in CSS imports in MediaWiki:Common.css broken
  in 1.17.
* (bug 27333) Fix repetitive last-seen time queries on page history.
* (bug 26250, bug 23817) Fix wfObjectToArray() to descend into arrays; fixes
  processing of JSON return values for ForeignAPIRepo when native json module
  not present.
* (bug 25675) Fix search suggestions for Special: pages with spaces.
* (bug 25571) Xml::encodeJsVar now passes floats natively instead of converting
  to strings.
* (bug 27338) Gallery in 1.17 breaks for audio/video + ogghandler.
* (bug 27302) Don't append the current timestamp for user/site modules when no
  user/site JS/CSS is present.
* (bug 27016) dumpTextPass.php now consider the "output" parameter.
* (bug 22606) don't send the "someone registred an account" message when setting
  email address (i.e. old one empty) in user preferences.
* (bug 26458) Section edit links appear on pages that user does not have right
  to edit.
* (bug 28611) Don't die in SqlBagOStuff::incr() if there's a race condition.
* (bug 16886) Sister projects box moves down the extract of the first result
  in IE 7.
* (bug 17398) Fixed "link" parameter in image links with "thumb" or "frame"
  parameter.

=== API changes in 1.17 ===

* BREAKING CHANGE: action=patrol now requires POST.
* BREAKING CHANGE: patrol token is no longer the same as edit token.
* BREAKING CHANGE: Session keys returned by ApiUpload are now strings instead
  of integers.
* BREAKING CHANGE: (bug 25303) Fix API parameter integer validation to actually
  enforce validation on the input values in addition to giving a warning.
  Also add flag to enforce (die) if integer out of range.
* (bug 24650) Fix API to work with categorylinks changes.
* action=parse now correctly returns an error for nonexistent pages.
* (bug 27201) Special:WhatLinksHere output no longer contains duplicate IDs.
* (bug 26560) On allusers if limit < total number of users, last user gets
  duplicated.
* (bug 27715) imageinfo didn't respect revdelete.
* (bug 27479) API error when using both prop=pageprops and
  prop=info&inprop=displaytitle.
* (bug 27862) Useremail module didn't properly return success on success.
* (bug 27590) prop=imageinfo now allows querying the media type.
* (bug 27587) list=filearchive now outputs full title info.
* (bug 27897) list=allusers and list=users list hidden users.
* (bug 22738) Allow filtering by action type on query=logevent.
* (bug 22764) uselang parameter for action=parse.
* (bug 22944) API: watchlist options are inconsistent.
* (bug 22868) don't list infinite block expiry date as "now" in API logevents.
* (bug 22290) prop=revisions now outputs "comment" field even when comment.
  is empty, for consistency with list=recentchanges.
* (bug 19721) API action=help should have a way to just list for a specific
  module.
* (bug 23458) Add support for pageid parameter to action=parse requests.
* (bug 23460) Parse action should have a section option.
* (bug 21346) Make deleted images searchable by hash.
* (bug 23461) Normalise usage of parameter names in parameter descriptions.
* (bug 23548) Allow access of another users watchlist through watchlistraw
  using token and username.
* (bug 23524) Api Modules as followup to bug 14473 (Add iwlinks table to
  track inline interwiki link usage).
* Add pltitles and tltemplates to prop=links and prop=templates respectively,
  similar to prop=categories's clcategorie.
* (bug 23834) Invalid "thumbwidth" and "thumbheight" in "imageinfo" query when
  thumbnailing larger than original image.
* (bug 23835) Need "thumbmime" result in "imageinfo" query.
* (bug 23851) Repair diff for file redirect pages.
* (bug 24009) Include implicit groups in action=query&list=users&usprop=groups.
* (bug 24016) API: Handle parameters specified in simple string syntax
  ( 'paramname' => 'defaultval' ) correctly when outputting help.
* (bug 24089) Logevents causes PHP Notice if leprop=title isn't supplied.
* (bug 23473) Give description of properties on all modules.
* (bug 24136) unknownerror when adding new section without summary, but
  forceditsummary.
* (bug 22339) Added srwhat=nearmatch to list=search to get a "go" result.
* (bug 24303) Added new &servedby parameter to all actions which adds the
  hostname that served the request to the result. It is also added
  unconditionally on error.
* (bug 24185) Titles in the Media and Special namespace are now supported for
  title normalization in action=query. Special pages have their name resolved
  to the local alias.
* (bug 24296) Added converttitles parameter to convert titles to their
  canonical language variant.
* (bug 23936) Add "displaytitle" to query/info API.
* (bug 24485) Make iwbacklinks a generator, optionally display iwprefix and
  iwtitle.
* (bug 24564) Fix fatal errors when using list=deletedrevs, prop=revisions or
  one of the backlinks generators with limit=max.
* (bug 24656) API's parse module needs option to disable PP report.
* PARAM_REQUIRED parameter flag added. If this flag is set, and the end user
  does not set the parameter, the API will automatically throw an error.
* (bug 24665) When starttimestamp is not specified, fake it by setting it to
  NOW, not to the timestamp of the last edit.
* (bug 24677) axto= parameters added to allcategories, allimages, alllinks,
  allmessages, allpages, and allusers.
* (bug 24236) Add add, remove, add-self, remove-self tags to
  meta=siteinfo&siprop=usergroups.
* (bug 24484) Add prop=pageprops module.
* (bug 24330) Add &redirect parameter to ?action=edit.
* (bug 24722) For list=allusers&auprop=blockinfo, only show blockedby and
  blockreason if the user is actually blocked.
* Add format=dump and format=dumpfm, outputs results in PHP's var_dump() format.
* For required string parameters, if '' is provided, this is now classed as
  missing.
* (bug 24724) list=allusers is out by 1 (shows total users - 1).
* (bug 24166) API error when using rvprop=tags.
* Introduced "asynchronous download" mode for upload-by-url. Requires
  $wgAllowAsyncCopyUploads to be true.
* sinumberingroup correctly gives size of 'user' group, and omits size of
  implicit groups rather than showing 0.
* (bug 25248) API: paraminfo errors with certain modules.
* (bug 24792) API help for action=purge sometimes wrongly stated whether a
  POST request was needed due to cache pollution.
* Added iiprop=parsedcomment to prop=imageinfo, similar to prop=revisions.
* Added rvparse to parse revisions. For performance reasons if this option is
  used, rvlimit is enforced to 1.
* (bug 25748) If a action=parse request provides an oldid that is actually the
  current revision id, try the parser cache, and save it to it if necessary.
* (bug 25463) Export header should not be shown if no pages were requested, to
  reduce confusion.
* (bug 25648) API discovery information has been added as RSD link in page.
  <head> and by providing an API module action=rsd. Added hook
  ApiRsdServiceApis for extensions to add their own service to the services
  list.
* The HTML of diff output markers has changed. Hyphens are now minus signs,
  empty markers are now filled with non-breaking-space characters.
* (bug 25741) Add more data to list=search's srprop.
* (bug 25760) counter property still reported by the API when
  $wgDisableCounters enabled.
* (bug 25987) prop=info&inprop=watched now also works for missing pages.
* (bug 26006) prop=langlinks now allows obtaining full URL.
* (bug 26075) ApiDelete.php now calls correctly ArticleDelete hook.
* (bug 26089) add block expiration to blockinfo.
* (bug 26125) prop=imageinfo&iiprop=size now returns the page count if the
  file is a multi-page file.
* (bug 10268) Added linktodiffs parameter on action=feedwatchlist.
* (bug 26219) Show API limits for multi values in description.
* (bug 28070) Fix watchlist RSS for databases that store timestamps in a
  real timestamp field.
* (bug 27722) list=filearchive now supports revdel.

=== Language support changes in 1.17 ===

MediaWiki supports over 330 languages. Many localizations are updated regularly.

The following languages were added:

* Moroccan Spoken Arabic (ary)
* Banjar (bjn)
* Kabardian (kdb)
* Kabardian (Cyrillic) (kbd-cyrl)
* Latgalian (ltg)
* Minangkabau (min)
* Dutch (informal) (nl-informal)
* Rusyn (rue)

Other significant changes to MediaWiki's language support:

* Fiji Hindi (Devangari script) was removed.
* Removed deprecated language code "dk" (Danish), use "da" instead.
* Link trail added for sl and sh.
* (bug 27633) Add characters to linkTrail for Portuguese (pt and pt-br).
* (bug 23156) Commafy and search normalization updated for Belarusian
  (Taraškievica).
* (bug 23283) Native name for Old English -> Ænglisc.
* (bug 23364) Native name for Azerbaijani -> Azərbaycanca.
* (bug 24593) Native name for Sorani now uses only Arabic script.
* (bug 24628) Generic translations for NS_USER/NS_USER_TALK for Esperanto.
* (bug 24917) Polish as fallback for Kashubia.
* (bug 24794) Tatar link trail updated.
* Esperanto date format corrected.
* (bug 28159) Change interwiki name of language kbd to Къэбэрдеибзэ /
  Qabardjajəbza.
* (bug 28184) Namespaces for the Latgalian Wikipedia.
* (bug 25010) Bashkir-language interwikis: linktext change from Башҡорт
  to Башҡортса.
* (bug 26395) Change name of Cornish language to Kernowek.

=== Other changes in 1.17 ===

* DatabaseFunctions.php that was needed for compatibility with pre-1.3
  extensions has been removed.
* XmlFunctions.php has been removed. Use the Xml or Html classes as appropriate.
* The FailFunction "error handling" method has now been removed
* Sysops now have the "suppressredirect" right by default
* Removed $wgRemoteUploads. It was not well supported and superseded by
  $wgUploadNavigationUrl.
* (bug 26253) $wgPostCommitUpdateList has been removed
* The PHPUnit test suite has been removed from this release due to serious issues
  which should be resolved by the 1.18 release.
* Oracle DB now uses the __destruct fuction to commit/close connection as it
  doesn't commit on close if transation is triggered in OCI.

== MediaWiki 1.16 ==

=== Configuration changes in 1.16 ===

* (bug 18222) $wgMinimalPasswordLength default is now 1
* $wgSessionHandler can be used to configure session.save_handler
* $wgLocalFileRepo/$wgForeignFileRepos now have a 'fileMode' parameter to
  be used when uploading/moving files
* (bug 18761) $wgHiddenPrefs is a new array for specifying preferences not
  to be shown to users
* $wgAllowRealName and $wgAllowUserSkin were deprecated in favor of
  $wgHiddenPrefs[] = 'realname', but the former are still retained
  for backwards-compatibility
* (bug 9257) $wgRCMaxAge now defaults to three months
* $wgDevelopmentWarnings can be set to true to show warnings about deprecated
  functions and other potential errors when developing.
* Subpages are now enabled in the MediaWiki namespace by default.  This is
  mainly a cosmetic change, and does not in any way affect the MessageCache,
  which was already effectively treating the namespace as if it had subpages.
* Oracle: maintenance/ora/user.sql script for creating DB user on oracle with
  appropriate privileges. Creating this user with web-install page requires
  oci8.privileged_connect set to On in php.ini.
* Removed UserrightsChangeableGroups hook introduced in 1.14
* Added $wgCacheDirectory, to replace $wgFileCacheDirectory,
  $wgLocalMessageCache, and any other local caches which need a place to put
  files.
* $wgFileCacheDirectory is no longer set to anything by default, and so either
  needs to be set explicitly, or $wgCacheDirectory needs to be set instead.
* $wgLocalMessageCache has been removed. Instead, set $wgUseLocalMessageCache
  to true
* Removed $wgEnableSerializedMessages and $wgCheckSerialized. Similar
  functionality is now available via $wgLocalisationCacheConf.
* $wgMessageCache->addMessages() is deprecated. Messages added via this
  interface will not appear in Special:AllMessages.
* $wgRegisterInternalExternals can be used to record external links pointing
  to same server
* (bug 19907) $wgCrossSiteAJAXdomains and $wgCrossSiteAJAXdomainExceptions added
  to control which external domains may access the API via cross-site AJAX.
* $wgMaintenanceScripts for extensions to add their scripts to the default list
* $wgMemoryLimit has been added, default value '50M'
* $wgExtraRandompageSQL is deprecated, the SpecialRandomGetRandomTitle hook
  should be used instead
* (bug 20489) $wgIllegalFileChars added to override the default list of illegal
  characters in file names.
* (bug 19646) $wgImgAuthDetails added  to display reason access to uploaded file
  was denied to users(img_auth only)
* (bug 19646) $wgImgAuthPublicTest added to test to see if img_auth set up
  correctly (img_auth only)
* $wgUploadMaintenance added to disable file deletions and restorations during
  maintenance
* $wgCapitalLinkOverrides added to configure per-namespace capitalization
* (bug 21172) $wgSorbsUrl can now be an array with multiple DNSBL and renamed
  to $wgDnsBlacklistUrls (backward compatibility kept)
* $wgEnableHtmlDiff has been removed
* (bug 3340) $wgBlockCIDRLimit added (default: 16) to configure the low end of
  CIDR ranges for blocking
* $wgUseInstantCommons added for quick and easy enabling of Commons as a remote
  file repository
* $wgDBAhandler added to choose a DBA handler when using CACHE_DBA
* $wgPreviewOnOpenNamespaces for extensions that create namespaces that behave
  similarly to the category namespace.
* $wgEnableSorbs renamed to $wgDnsBlacklistUrls ($wgEnableSorbs kept for
  backward compatibility)
* $wgUploadNavigationUrl now also affects images inline images that do not
  exist. In that case the URL will get (?|&)wpDestFile=<filename> appended to
  it as appropriate.
* If $wgLocaltimezone is null, use the server's timezone as the default for
  signatures. This was always the behavior documented in DefaultSettings.php
  but has not been the actual behavior for some time: instead, UTC was used
  by default.
* Added $wgExtensionAssetsPath, to decouple assets serving from $wgScriptPath.
  If not specified it will default to $wgScriptPath/extensions
* Added $wgCountTotalSearchHits to make search UI display total number of hits
  with some search engines.
* Added $wgAdvertisedFeedTypes to decide what feed types (RSS, Atom, both, or
  neither) MediaWiki advertises.  Default is array( 'atom' ), so RSS is no
  longer advertised by default (but it still works).
* Added $wgMemCachedTimeout, controls how long to wait for data from the
  memcached servers.
* New configuration variables $wgDebugTimestamps and $wgDebugPrintHttpHeaders
  for controlling debug output.
* New $wgBlockDisablesLogin when set to true disallows blocked users from
  logging in.
* (bug 8790) Metadata edition ($wgUseMetadataEdit) has been moved to a separate
  extension "MetadataEdit".

=== New features in 1.16 ===

* Add CSS defintion of the 'wikitable' class to shared.css
* (bug 17163) Added MediaWiki:Talkpageheader which will be displayed when
  viewing talk pages
* Superfluous border="0" removed from images
* Added new hook 'MessageCacheReplace' into MessageCache.php. For instance
  to allow extensions to update caches in similar way as MediaWiki invalidates
  a cached MonoBook sidebar
* Special:AllPages: Move hardcoded styles from code to CSS
* (bug 18529) New hook: SoftwareInfo for adding information about the software
  to Special:Version
* Added $wgExtPGAlteredFields to allow extensions to easily alter the data
  type of columns when using the Postgres backend.
* (bug 16950) Show move log when viewing/creating a deleted page
* (bug 18242) Show the Subversion revision number per extensions in
  Special:Version
* (bug 18420) Missing file revisions are handled gracefully now
* (bug 9219) Auth plugins can control editing RealName/Email/Nick preferences
* (bug 18466) Add note or warning when overruling a move (semi-)protection
* (bug 18342) insertTags works in edit summary box
* (bug 18411) The upload form also checks post_max_size
* Watchlist now has a specialized <div> tag that contains a unique class for
  each page
* Added Minguo calendar support for the Taiwan Chinese language
* Database: unionQueries function to be used for UNION sql construction, so
  it can be overloaded on DB abstraction level for DB specific functionality
* (bug 18849) Implement Japanese and North Korean calendars
* (bug 5755) Introduce {{CURRENTMONTH1}} and {{LOCALMONTH1}} to display the
  month number without the leading zero
* (bug 13456) categoriespagetext supports PLURAL
* (bug 18860) Blocks of IPs affecting registered users can now block email
* (bug 17093) Date and time are separate parameters in Special:BlockList
* (bug 11484) Added ISO speed rating to default collapsed EXIF metadata view
* (bug 14866) Messages 'recentchangeslinked-toolbox' and
  'recentchangeslinked-toolbox' were added to allow more fine grained
  customisation of the user interface
* DISPLAYTITLE now accepts a limited amount of wiki markup (the single-quote
  items)
* Special:Search now could search terms in all variant-forms. ONLY apply on
  wikis enabled LanguageConverter.
* Add autopromote condition APCOND_BLOCKED to autopromote blocked users to
  various user groups.
* Add $wgRevokePermissions as a means of restricting a group's rights. The
  syntax is identical to $wgGroupPermissions, but users in these groups will
  have these rights stripped from them.
* Added a PHP port of CDB (constant database), for improved local caching when
  the DBA extension is not available.
* Introduced a new system for localisation caching. The system is based around
  fast fetches of individual messages, minimising memory overhead and startup
  time in the typical case. The database backend will be used by default, but
  set $wgCacheDirectory to get a faster CDB-based implementation.
* Expanded the number of variables which can be set in the extension messages
  files.
* Added a feature to allow per-article process pool size control for the parsing
  task, to limit resource usage when the cache for a heavily-viewed article is
  invalidated. Requires an external daemon.
* (bug 19576) Moved the id attribues from the anchors accompanying section
  headers to the <span class="mw-headline"> elements within the section headers,
  removing the redundant anchor elements.
* Parser::setFunctionTagHook now can be used to add a new tag which is parsed at
  preprocesor level.
* Added $wgShowArchiveThumbnails, allowing sysadmins to disable thumbnail
  display for old versions of images.
* In watchlists and Special:RecentChanges, the difference in page size now
  appears in dark green if bytes were added and dark red if bytes were removed.
* Added FSRepo configuration properties thumbUrl and thumbDir, to allow the
  thumbnails to be stored in a separate location to the source images.
* If config/ directory is not executable, the command to make it executable
  now asks the user to cd to the correct directory
* Add experimental new external authentication framework, ExternalAuth
* (bug 18768) Remove AdminSettings requirements. Maintenance environment
  will still load it if it exists, but it's not required for anything
* (bug 19900) The "listgrouprights-key" message is now wrapped in a div with
  class "mw-listgrouprights-key"
* (bug 471) Allow RSS feeds for watchlist, using an opt-in security token
* (bug 10812) Interwiki links can have names and descriptions, fetched from
  message 'interwiki-desc-PREFIX', not really used anywhere yet though
* (bug 9691) Add type (signup or login) parameter to
  AuthPlugin::ModifyUITemplate()
* (bug 14454) "Member of group(s)" in Special:Preferences causes language
  difficulties
* (bug 16697) Unicode combining characters are difficult to edit in some
  browsers
* Parser test supports uploading results to remote CodeReview instance
* (bug 20013) Added CSS class "mw-version-ext-version" is wrapped on the
  extension version in Special:Version
* (bug 20014) Added CSS class "mw-listgrouprights-right-name" is wrapped on the
  right name in Special:ListGroupRights
* (bug 12920) New CoreParserFunction {{nse:...}} as an url-friendly equivalent
  to {{ns:...}}
* (bug 16322) Allow maintenance scripts to accept DB user/pass over input or
  params
* (bug 18566) Maintenance script to un/protect pages
* (bug 671) The HTML <abbr> tag is now permitted.
* RecentChanges now has a legend to explain what the Nmb! flags mean, and the
  flags have tooltips.
* (bug 15209) New hook BeforeInitialize called after everything has been setup
  but before Mediawiki::performRequestForTitle()
* wgMainPageTitle variable now available to JavaScript code to identify the main
  page link, so it doesn't have to be extracted from the link URLs.
* (bug 16836) Display preview of signature in user preferences and describe its
  use
* The default output format is now HTML 5 instead of XHTML 1.0 Transitional.
  This can be disabled by setting $wgHtml5 = false;.  Specific features enabled
  if HTML 5 is used:
** Some extra inputs will be autofocused, in supporting browsers.
** The summary attribute has been removed from tables of contents.  summary is
   obsolete in HTML 5 and wasn't useful here anyway.
** Unnecessary type="" attribute removed for CSS and JS.
** If $wgWellFormedXml is set to false, some bytes will be shaved off of HTML
   output by omitting some things like quotation marks where HTML 5 allows.
** (bug 16921) maxlength enabled for page move comments
* The description message in $wgExtensionCredits can be an array with parameters
* New hook SpecialRandomGetRandomTitle allows extensions to modify the selection
  criteria used by Special:Random and subclasses, or substitute a custom result,
  deprecating the $wgExtraRandompageSQL config variable
* (bug 20318) Distinct CSS classes for ISBN/RFC/PMID special links added
* (bug 20404) Custom fields in the user creation form template can now have
  detail labels in prefsectiontip divs.
* MakeSysop and MakeBot are now aliases for Special:UserRights
* IndexPager->mLimitsShown can now be an associative array of limit => text-to-
  display-in-limit-form.
* (bug 18880) LogEventsList::showLogExtract() can now take a string-by-reference
  and add its HTML to it, rather than having to go straight to $wgOut.
* Added $wgShowDBErrorBacktrace, to allow users to easily gather backtraces for
  database connection and query errors.
* Show change block / unblock link on Special:Contributions if user is blocked
* Display note on Special:Contributions if the user is blocked, and provide an
  excerpt from the block log.
* (bug 19646) New hook: ImgAuthBeforeStream for tests and functionality before
  file is streamed to user, but only when using img_auth
* Note on non-existing user and user talk pages if user does not exist
* New hook ShowMissingArticle so extensions can modify the output for
  non-existent pages.
* Admins could disable some variants using $wgDisabledVariants now. ONLY apply
  on wikis enabled LanguageConverter.
* (bug 16310) Credits page now lists IP addresses rather than saying the number
  of anonymous users that edited the page
* New permission 'sendemail' added. Default right for all registered users. Can
  for example be used to prevent new accounts from sending spam.
* (bug 16979) Tracking categories for __INDEX__ and __NOINDEX__
* Two new hooks, ConfirmEmailComplete and InvalidateEmailComplete, which are
  called after a user's email has been successfully confirmed or invalidated.
* (bug 19741) Moved the XCF files out of the main MediaWiki distribution, for
  a smaller subversion checkout.
* (bug 13750) First letter capitalization can now be a per-namespace setting
* (bug 21073) "User does not exist" message no longer displayed on sub-sub-pages
  of existing users
* (bug 21095) Tracking categories produced by the parser (expensive parser
  function limit exceeded, __NOINDEX__ tracking, etc) can now be disabled by
  setting the  system message ([[MediaWiki:expensive-parserfunction-category]]
   etc) to "-".
* Added maintenance script sqlite.php for SQLite-specific maintenance tasks.
* Rewrote Special:Upload to allow easier extension.
* Upload errors that can be solved by changing the filename now do not require
  reuploading.
* Added $wgRateLimitsExcludedIPs, to allow specific IPs to be whitelisted from
  rate limits.
* (bug 21222) When $wgUseTeX is not enabled, <math> is no longer registered with
  the parser so extensions are free to implement their own <math> tag
* (bug 21047) Wrap 'cannotdelete' into a div with the generic 'error' class and
  an own 'mw-error-cannotdelete' class
* New hook AbortNewAccountAuto, called before account creation from AuthPlugin-
  or ExtUser-driven requests.
* (bug 3480) The warning saying that the page has a history when deleting it now
  contains the number of revisions in the history
* $wgStylePath and $wgLogo are now set in the default LocalSettings.php file.
* (bug 20186) Allow filtering history for revision deletion.
* New hook OtherBlockLogLink, called in Special:IPBlockList and Special:Block
  to show links to block logs of other blocking extensions, i.e. GlobalBlocking
* Added search capabilities to SQLite backend
* rebuildtextindex.php maintenance script now supports databases other than
  MySQL
* upgrade1_5.php now requires to be run --update option to prevent confusion
* (bug 17662) Customizable default preload/editintro for new sections in the
  respective addsection-preload and addsection-editintro messages
* Added maintenance script checkSyntax.php that checks for PHP syntax errors
  and common coding mistakes
* Updated Unicode normalization tables
* (bug 21604) Spellcheck attribute for editsummary
* New wgCategories JavaScript global variable for userscripts.
* (bug 20717) Added checkboxes to hide users with bot and/or sysop group
  membership in SpecialActiveusers
* Allow \pagecolor and \definecolor in texvc
* $wgTexvcBackgroundColor contains background color for texvc call
* (bug 21574) Redirects can now have "303 See Other" HTTP status
* EditPage refactored to allow extensions to derive new edit modes much easier.
* (bug 21826) Subsections of Special:Version now also have anchors
* (bug 19791) Add URL of file source as comment to thumbs (for ImageMagick)
* (bug 21946) Sorted wikitables do not properly handle minus signs
* (bug 18885) Red links for media files do not support shared repositories
* Added $wgFixArabicUnicode, to convert deprecated presentation forms in
  Arabic text to their modern equivalents, and $wgFixMalayalamUnicode, to
  convert ZWJ-based chillu sequences in Malayalam text to their Unicode 5.1
  equivalents.
* (bug 22051) Returing false in SpecialContributionsBeforeMainOutput hook now
  stops normal output
* Send new password e-mail in users preference language
* LanguageConverter now support nested using of manual convert syntax like
  "-{-{}-}-"
* Upload license preview now uses the API instead of action=ajax
* (bug 7346) Add <guid> to RSS to avoid duplicates
* (bug 19996) Added new hooks for Special:Search, which allow to further
  restrict/expand it.
* (bug 21936) When a revision has been patrolled, there's now a link back to the
  article
* (bug 22315) SpecialRecentChangesQuery hook now pass $query_options and checks
  the return value
* Separate unit test suites under t/ and tests/ were merged and moved to
  maintenance/tests/.
* importImages.php maintenance script can now use the original uploader and
comment from another wiki.
* Support for Turck MMCache was removed
* (bug 14592) Warn users when they try to move their user page that their
  account will not be renamed
* Show block log on non-existing user (talk) pages of currently blocked users

=== Bug fixes in 1.16 ===

* (bug 18031) Make namespace selector on Special:Export remember the previous
  selection
* The svn-version version numbers on Special:Version have been removed
* (bug 17374) Special:Export no longer exports two copies of the same page
* (bug 18190) Proper parsing in MediaWiki:Sharedupload message
* (bug 17617) HTML cleanup for ImagePage
* (bug 17964) namespaceDupes.php no longer fails on an empty interwiki table
* Improved error handling for image moving
* (bug 17974) On Special:SpecialPages, restricted special pages are now marked
  with <strong> tags, helps with text-based browsers
* (bug 18259) Special:DeletedContributions now also uses
  MediaWiki:Sp-contributions-logs for the link to Special:Log
* Don't add empty title="" attributes to links to anchors on the current page
* (bug 18291) rebuildrecentchanges.php failed to add deletion log entries
* (bug 18304) rebuildrecentchanges.php got size changes wrong
* (bug 18170) Fixed a PHP warning in Parser::preSaveTransform() in PHP 5.3
* (bug 18289) Database connection error page now returns correct HTML
* "successbox", "errorbox" and related CSS classes are now available in all
  skins
* (bug 18316) Removed superfluous name="fulltext" from Special:Search
* (bug 18331) MediaWiki:Undelete-revision can now have wikitext
* The "noautoblock" flag is no longer displayed in the block log when blocking
  an IP address
* (bug 18009) $wgHooks and $wgExtensionFunctions now support closures
* (bug 17948) Maintenance scripts now exit(0) or exit(1) as appropriate
* (bug 18377) Time in Enhanced ChangesList lacking localisation
* (bug 12998) Allow <sup>, <sub>, etc. in DISPLAYTITLE
* (bug 1553) Lowercase navigation headings in German
* (bug 7830) Pending transactions failed to commit on loginToUse() error
* (bug 11613) session.save_handler being over-ridden
* (bug 11381) session.save_handler being set twice (causes error)
* (bug 17835) ForeignAPIRepo throwing error on first page load for file
* (bug 18115) ForeignAPIRepo cache isn't working
* Fixed a bug caused by LanguageConverter.php, which brings an abnormal '}-'
  after some parsed math syntax.
* (bug 18441) rebuildrecentchanges.inc no longer ignores $wgLogRestrictions
* (bug 18317) Bolded selections in 1 | 3 | etc days on RecentChanges now use
  <strong> instead of hardcoded styles
* (bug 18449) Fixed items number per column on category pages when the total is
  divisible by 3
* (bug 18121) maintenance/deleteArchivedRevisions.php no longer deletes
  revisions when --delete is not passed
* (bug 13172) GPS coordinates in image Exif data are now actually displayed
* Overhaul of preferences system, includes the following bug fixes:
** (bug 5363) Changes to default preferences now impact registered users.
** (bug 14806) Hook to enable putting preferences in existing tabs.
** (bug 17191) Registration date now listed on preferences page.
** The user_properties table (now used for storing preferences) has been added
   to $wgSharedTables.
** Note that this change will break some extensions which have not been adapted
   for it.
* (bug 17020) Adding fallback encodings for Traditional and Simplified Chinese
  languages while the the text is typed as URLs.
* (bug 17614) Prev / Next links are not shown if all results are shown
* (bug 18207) Strange spacing before [[irc:...]] links
* Removed float from the user login form in RTL interface - caused display
  problems in FF2
* (bug 15008) Redirect images are now subject to Bad image list rules
* (bug 6802) profileinfo.php now also work on other database servers than MySQL
* (bug 16925) Diffs no longer fail when $wgExternalDiffEngine is set to
  'wikidiff' or 'wikidiff2' but extension is not installed
* (bug 18326) Chmod errors in file repos have been hidden
* (bug 18718) Comma after a } create a error in IE
* (bug 18716) Removed redundant class in Modern skin CSS for category links and
  tweaked spacing.
* (bug 18656) Use proper directory separators in wfMkdirParents()
* (bug 18549) Make Special:Blockip respect $wgEnableUserEmail and
  $wgSysopEmailBans
* (bug 16912) Tooltips on images with link= disappear
* (bug 18389) Localise numbers in EXIF data
* (bug 18522) Wrap MediaWiki:Protect-cascadeon in a div for identification
* (bug 18438) Tweak HTML for preview bar for consistency and accessibility
* (bug 18432) Updated documentation for dumpBackup.php
* Fix array logic in Sanitizer::removeHTMLtags so that it doesn't strip good
  tags that were redundantly defined.
* (bug 14118) SpecialPage::getTitleFor does not return a localised name
* (bug 18698) Renaming non entry point maintenance scripts from .inc.php to
  .inc
* Deprecated methods Title::getInterwikiLink, Title::userCanCreate(),
  Title::userCanEdit() and Title::userCanMove() have been removed
* Only show upload links on file description if $wgEnableUploads = true
  and user can upload
* Don't say "You need to log in to upload/move", because it's possible that
  uploading/moving is disabled for registered users as well (e.g. only sysops)
* (bug 18943) Handle invalid titles gracefully at Special:Mostlinked
* (bug 8873) Enable variant conversion in text on 'alt' and 'title' attributes
* (bug 10837) Introducing the StubUserVariant class to determine the variant
  variable instead of using this to overrules the user language preference.
* (bug 19014) If user had deletedhistory right, but not undeleted right, then
  show "view" instead of "view/restore" on logs.
* (bug 19017) TOC level calculation error in an odd case
* (bug 18999) CSS update for RTL interwiki links
* (bug 18925) history.js removes class names of list elements on initialization
* Multiple whitespace in TOC anchors is now stripped, for consistency with the
  link from the edit comment
* (bug 19112) Preferences now respects $wgUseExternalEditor
* (bug 18173) MediaWiki now fails when unable to determine a client IP
* (bug 19170) Special:Version should follow the content language direction
* (bug 19160) maintenance/purgeOldText.inc is now compatible with PostgreSQL
* Fixed performance regression in "bad image list" feature
* Show user preference 'Use live preview' if $wgLivePreview is enabled only
* (bug 17014) Blocked users can no longer use Special:UserRights unless they
  can add/remove *all* groups (have 'userrights' permission).
* (bug 19294) Always show Sp-contributions-footer(-anon)
* Attempts to restrict reading of pages while anonymous viewing is allowed
  via extensions not using the userCan hook and via $wgRevokePermissions now
  work.
* (bug 8445) Multiple-character search terms are now handled properly for
  Chinese
* (bug 19450) Use formatNum for "Number of edits" in Special:Preferences
* (bug 11242) Check for MySQL storage engines during installation now checks
  whether the engines are actually available
* (bug 19390) Omit the "printable version" link on the printable version
* (bug 18394) img_auth.php now respects userCan
* (bug 19509) Uploading to a file named '0' previously treated it as null input
   and attempted to upload with the source name. Now warns about not having an
   extension (since 0.ext is perfectly valid)
* (bug 19468) Enotif preferences are now only displayed when they are turned on
* (bug 19442) Show/hide options on watchlist only work once
* (bug 19602) PubMed Magic links now use updated NIH url
* (bug 19637) externallinks have links to self
* Don't load Opera 9.5 RTL fixes for Opera 9.6
* Remove five-year-old KHTMLFixes.css, which is unlikely to be relevant anymore
  and was causing problems.
* Removed repetition of URIs in the title attributes of external links.
* (bug 19693) User name is now escaped in "Contributions for ..." link on
  Special:BlockIP
* (bug 19571) Override buildConcat for SQLite.
* Log in and log out links no longer return to page view when clicked from
  history view, edit page, or something similar
* (bug 19513) RTL fixes for new Search UI
* (bug 16497) Special:Allmessages is paginated
* (bug 18708) CSS plainlinks class now available to all skins
* (bug 19590) Database error messages no longer have "MySQL" hardcoded as the
  database type
* (bug 19759) successbox on Special:Preferences now correctly aligned on
  standard, nostalgia and cologneblue skin
* (bug 19814) interwiki links from file links ([[File:Foo.jpg|link=de:Test]])
  are no longer recorded in the pagelinks table
* (bug 19784) date option "ISO 8601" produced illegal id
* (bug 19761) Removed autogenerated <meta keywords> tag with link data.
  Keyword set was not useful, and is ignored by modern search engines anway.
* (bug 19827) Special:SpecialPages title is "Upload file
* (bug 19355) Added .xhtml, .xht to upload file extension blacklist
* (bug 19287) Workaround for lag on history page in Firefox 3.5
* (bug 19564) Updated docs/hooks.txt
* (bug 18751) Fix for buggage in profiling setup for some extensions on PHP 5.1
* (bug 17139) ts_resortTable inconsistent trimming makes date sorting fragile
* (bug 19445) Change oldimage table to use ON UPDATE CASCADE for FK to image
  table.
* (bug 14080) Short notation links to subpages didn't work in edit summaries
* (bug 17374) Special:Export no longer exports multiple copies of pages
* (bug 19818) Edits to user CSS/JS subpages can now be marked as patrolled by
  users who can't edit them
* (bug 19839) Comments in log items are no more double escaped
* (bug 18161) Fix inconsistent separators in watchlist link toolbars with
  "enhanced recent changes"
* (bug 16877) Moving a page over a redirect no longer leaves an orphan entry in
  the recentchanges table
* (bug 16009) Limit selection forms based on Pager now links to the correct page
  when using long urls
* The display of the language list on the preferences is more comply with the
  BCP 47 standards.
* (bug 19849) Custom X-Vary-Options header now disabled unless $wgUseXVO is set
* (bug 19301) Duplicates entries in $wgAddGroups, $wgRemoveGroups,
  $wgGroupsAddToSelf and $wgGroupsRemoveFromSelf are no more displayed on
  Special:ListGroupRights
* (bug 18799) Special:Userlogin now handles correctly the returnto parameter
  to not link back to Special:Userlogout when user's language isn't the same as
  content's language
* (bug 19479) Show proper error message when unable to connect to PostgreSQL
  database with username/password in MediaWiki's setup
* (bugs 18407, 18409) Special:Upload is now listed on Special:Specialpages only
  if uploads are enabled and the user can access it
* (bug 17988) Spaces before [[Category:]] links are no longer ignored
* (bug 19957) All known-failing tests now marked disabled; added --run-disabled
  option to parser test suite to run disabled tests if desired.
* (bug 16311) Make recent change flags (n/m/b) <abbr>s instead of <span>s
* (bug 15680) Split the edit tip message of user CSS/JS subpage into
  "usercssyoucanpreview" and "userjsyoucanpreview" respectively.
* (bug 12110) Split the rights for editing users' CSS/JS subpage from
  "editusercssjs" into "editusercss" and edituserjs" respectively.
* (bug 19394) RecentChanges feed URLs for log items with no revisions
  (eg Newuser, Userrights) are no longer broken
* (bug 17395) Remote file descriptions use user language ($wgLang), not wiki
  language ($wgContLang)
* (bug 11867) Lock error on redirect table when running orphans.php
* (bug 18930) initStats.php now refreshes active users count
* (bug 18699) Using the nosummary URL option no longer triggers the "You have
  not provided a summary" warning for those who activated it in their
  preferences
* (bug 18855) commandLine.inc and Maintenance.php are now properly included
  using the full path
* (bug 18497) Fixed broken style sheets in Opera fullscreen mode
* (bug 16084) Default memory limit has be increased to 50M, see $wgMemoryLimit
* (bug 17864/19519) Added proper input normalization in Special:UserRights
* (bug 20086) Add Hook to add extra statistics at the end of Special:Statistics
* (bug 19289) importDump.php can now handle bzip2 and 7zip
* (bug 20131) Fixed a PHP notice for users having the "rollback" right on
  Special:RecentChangesLinked
* Do not transform EXIF fields with pure text to avoid results like
  foo,bar@example,com
* (bug 20176) Fix login/logout links in skin CologneBlue
* (bug 20203) "Powered by Mediawiki" now has height/width on image tag
* (bug 20273) Fix broken output when no pages are found in the content
  namespaces
* (bug 20265) Make AncientPages and UnusedFiles work on SQLite
* Fixed XSS vulnerability for Internet Explorer clients (only pre-release
  versions of MediaWiki were affected).
* (bug 14817) Moving a page to a subpage of itself moves it twice
* (bug 20289) $wgMaximumMovedPages should only count pages actually moved
* (bug 15248) Non-breaking spaces and certain other Unicode space characters
  are now normalized to ordinary spaces in titles; if your wiki has existing
  titles with such characters, run cleanupTitles.php and/or cleanupImages.php
* (bug 11143) Links containing invalid UTF-8 percent-code sequences are now
  cleanly disabled instead of breaking parsing entirely on PHP 5.2.
* (bug 20296) Fixed an PHP warning in Language::getMagic() in PHP 5.3
* (bug 20358) Unprotect tab was missing accesskey; now same as protect tab.
* (bug 20317) Cleaned up default main page link accesskey settings
* (bug 20362) Special:Statistics now produces valid HTML when view counters are
  enabled
* (bug 19857) maintenance/deleteRevision.php on last revision no longer breaks
  target page
* (bug 20365) Page name with with c/g/h/j/s/u + x are now correctly handled in
  Special:MovePage with Esperanto as content language
* (bug 20364) Fixed regression in GIF metadata loading
* (bug 20299) MediaWiki:Move-subpages and MediaWiki:Move-talk-subpages can now
  use wikitext
* (bug 15475) DatabaseBase::setFlag(), DatabaseBase::clearFlag() and
  DatabaseBase::getFlag() now have documentation
* (bug 19966) MediaWiki:License-header is now used for the licensing header in
  the file description page instead of MediaWiki:License
* (bug 20380) Links to history/deleted edits at the top of
  Special:RevisionDelete are no more displayed when when doing log suppression
* (bug 8143) Localised parser function names are now correctly case insensitive
  if they contain non-ASCII characters
* (bug 19055) maintenance/rebuildrecentchanges.php now purges
  Special:Recentchanges's RSS and Atom feed cache
* The installer will now try to bypass PHP's max_execution_time
* (bug 20260) SQLite no longer tries to automatically create the database at
  execution time, this now happens only at install time; if it is not available
  at script execution, it now throws an exception
* Fixed EditFilterMerged hook so the hookError parameter serves a purpose
  (analogous to EditFilter hook)
* (bug 2257) Tag extensions can expand template parameters provided to the tag,
  by using a new parameter added to the recursiveTagParse function
* (bug 14900) __INDEX__ and __NOINDEX__ no longer override site config set in
  $wgArticleRobotPolicies.
* (bug 20466) Hidden categories are no more displayed when printing
* (bug 20446) When changing user rights with User@remotewiki and remotewiki is
  the local wiki, the user is now treated as the local user
* (bug 20494) OutputPage::getArticleBodyOnly() no longer requires an useless
  argument
* (bug 20136) Protection form JavaScript now synchronizes the expiry boxes on
  any change, in addition to onkeyup.
* Don't link to "edit this page" on MediaWiki:Noarticletext if user is not
  allowed to create page. Done via new message
  MediaWiki:Noarticletext-nopermission
* Improved compatibility between the Vector skin and addPortletLink() from
  wikibits.js: empty portlets are now present but hidden, adding an element to a
  portlet unhides it
* (bug 19531) addPortletLink() now wraps inserted labels in a <span> element to
  be compatible with the CSS for the Vector skin
* (bug 20578) Wrong localized image metadata - duplicated string?
* (bug 20556) Stub threshold's "other" <input> in Special:Preferences now has a
  correct type="text" parameter
* (bug 482) Don't include TOC in the printable version if it has been hidden
* Adjust the time according to the user configuration on Special:Revisiondelete
* (bug 20624) Installation no longer allows "qqq" as the chosen language
* (bug 20634) The installer-created database user will now have all rights on
  the database so that upgrades will go more smoothly.
* (bug 18180) Special:Export ignores limit, dir, offset parameters
* User::getBlockedStatus() works for all kinds of user objects and doesn't
  assume the user object is equal to the current-user object ($wgUser)
* (bug 20517) Cancel link from edit page now returns to the old version when
  editing an old version
* (bug 16902) Installer no longer shows warnings when exec() has been disabled
  by disable_functions
* (bug 20726) Title::getLatestRevID's documentation now says that the function
  returns false if the page doesn't exist
* (bug 20751) ForeignApiRepo now urldecodes filenames when saving to local cache
* (bug 20730) Fix to Special:Version ViewVC link for branch checkouts
* (bug 20353) wfShellExec() was adding extra quotes on Windows Vista, causing
  command line scripts to fail
* (bug 20702) Parser functions can now be used correctly in
  MediaWiki:Missing-article
* (bug 14117) "redirected from" is now also shown on foreign file redirects
* (bug 17747) Only display thumbnail column in file history if the image can
  be rendered.
* (bug 3421) Live preview no longer breaks user CSS/JS previews
* (bug 11264) The file logo on a file description page for documents (PDF, ...)
  now links to the file rather than the file description page
* Password fields built with HTMLForm now still have the type="password"
  attribute if $wgHtml5=false.
* (bug 20836) Preload now works for MediaWiki namespace
* (bug 20885) Search box no longer suggests unavailable special pages
* (bug 20948) "Create this page" on Special:Search is no longer displayed when
  searching for special pages
* (bug 20524) Hideuser: Show nice error when trying to block hidden user without
  hideuser right
* (bug 21026) Fixed file redirects on shared repos on non-English client wikis
* (bug 21030) Fixed schema choices from being overwritten by defining unique
  field names per driver.
* (bug 21115) wgCanonicalSpecialPageName javascript variable is now always
  false on non-special pages
* (bug 21113) "Other statistics" header on Special:Statistics is no more
  displayed when there isn't any entry in it
* (bug 21114) Special:Contributions no longer shows diff links for new
  revisions
* (bug 21116) MediaWiki:Templatesused, MediaWiki:Templatesusedpreview and
  MediaWiki:Templatesusedsection now support plural
* (bug 21079) There is no more line wrapping between label and field in
  Special:Log
* (bug 20256) Fixed SQL errors on Special:Recentchanges and
  Special:Recentchangeslinked on SQLite backend
* (bug 20880) Fixed updater failure on SQLite backend
* (bug 21182) Fixed invalid HTML in Special:Listgrouprights
* (bug 20242) Installer no longer promts for user credentials for SQLite
  databases
* (bug 20911) Installer failed to create a SQLite database
* (bug 20847) Deprecated deprecated akeytt() removed in wikibits.js leaving
  dummy
* (bug 21161) Changing $wgCacheEpoch now always invalidates file cache
* (bug 20268) Fixed row count estimation on SQLite backend
* (bug 20275) Fixed LIKE queries on SQLite backend
* (bug 21234) Moving subpages of titles containing \\ now works properly
* (bug 21006) maintenance/updateArticleCount.php now works again on PostgreSQL
* (bug 19319) Add activeusers-intro message at top of SpecialActiveUsers page
* (bug 21255) Fixed hostname construction for DNSBL checking
* (bug 18019) Users are now warned when moving a file to a name in use on a
  shared repository and only users with the 'reupload-shared' permission can
  complete the move.
* (bug 18909) Add missing Postgres INSERT SELECT wrapper
* User::isValidPassword now only returns boolean results,
  User::getPasswordValidity can be used to get an error message string
* The error message shown in Special:ChangePassword now parses wiki markup
* (bug 19859) Removed experimental HTMLDiff feature
* Removed section edit links in edit conflict form
* Allow SpecialActiveusers to work on non-MySQL databases
* (bug 6579) Fixed protecting images from uploading only
* (bug 18609) Search index was empty for some pages
* (bug 13453) rebuildrecentchanges maintenance script works on PG again
* (bug 16583) Reduce false positives when checking for PHP (on upload, etc.)
* (bug 20112) Bitrotted tests in the t/ directory were failing.
* (bug 21470) MediaWiki:Sp-contributions-explain is now wrapped in a <p> with
  id "mw-sp-contributions-explain"
* (bug 19159) Fixed \overleftrightarrow in texvc
* (bug 19391) Fix caching for Recent ChangesFeed.
* (bug 21455) Fixed "Watch this page" checkbox appearing on some special pages
  even to non-logged in users
* (bug 21551) Rewrote the Squid purge HTTP client to provide a more robust and
  general implementation of HTTP, allowing it to purge non-Squid caches such as
  Varnish.
* Fixed corruption of long UDP debug log messages by using socket_sendto()
  instead of fsockopen() with fwrite().
* (bug 16884) Fixed feed links in sidebar not complying with URL parameters
  of the displayed page
* (bug 21403) memcached class renamed to MWMemecached to avoid conflict with
  PHP's memcached extension
* (bug 21650) Both calls to SkinTemplateTabs hook are now compatible
* (bug 21672) Add missing Accept-Language to both Vary and XVO headers
* (bug 21679) "Edit block reasons" link at the bottom of Special:Blockip is now
  only displayed to the users that have "editinterface" right
* (bug 21740) Attempting to protect a page that doesn't exist (salting) returns
  "unknown error"
* (bug 18762) both redirects and links get fixed one after another if
  redirects-only switch is not present
* (bug 20159) thumbnails rerendered if older that $wgThumbnailEpoch
* Fixed a bug which in some situations causes the job queue to grow forever,
  due to an infinite loop of job requeues.
* (bug 21523) File that can have multiple pages (djvu, pdf, ...) no longer have
  the page selector when they have only one page
* (bug 21559) "logempty" message is now wrapped in a div with class
  "mw-warning-logempty" when used in log extract
* (bug 20549) Parser tests were broken on SQLite backend
* (bug 21776) Interwiki urls like http://en.wikibooks.org/wiki/cs: should give
  a redirect instead of a baderror.
* (bug 21803) Special:MyContributions now keeps the query string parameters
* Redirecting special pages now keep query string paramters set to "0" (e.g.
  for namespace)
* (bug 20765) Special:ListGroupRights no longer misses addables and removables
  groups if there are duplicate entries
* (bug 21814) Message shown when rolling back an edit with a deleted username
  now shows '(username deleted)' instead of broken user tool links
* (bug 21536) Fixed JavaScript error on Special:Search caused by an incorrect ID
* (bug 21535) RecentChanges RSS feed now always recognises the namespace filter,
  previously it sometimes didn't due to caching.
* (bug 20388) ProfilerSimpleText no longer outputs comment on action=raw
* refreshLinks.php now purges orphaned redirect table rows
* (bug 2971) Swap links of hist & diff location on Special:Contributions for
  consistency with RC/WL
* (bug 21986) Special page names were are now capitalized by content language
* If two log type have the same description, they're now both displayed in the
  type selector on Special:Log
* (bug 20115) Special:Userlogin title says "Log in / create account" even if the
  user can't create an account
* (bug 2658) Don't attempt to set the TZ environment variable.
* (bug 9794) User rights log entries for foreign user now links to the foreign
  user's page if possible
* (bug 14717) Don't load nonexistent CSS fix files for non-Monobook skins
* (bug 22034) Use wfClientAcceptsGzip() in wfGzipHandler instead of
  reimplementing it.
* (bug 19226) First line renders differently on many UI messages.
* (bug 21303) Comments are no longer stripped from MediaWiki:Common.js and
  skin-specific JS pages
* (bug 5061) Use the more precise thumbcaption thumbimage and thumbinner classes
  for image divs.
* (bug 22096) IE50Fixes.css and IE55Fixes.css have been dropped from the Monobook
  and Chick skins
* Fixed bug involving unclosed "-{" markup in the language converter
* (bug 21870) No longer include Google logo from an external server on wiki error.
* (bug 22181) Do not truncate if the ellipsis actually make the string longer
* (bug 16039) Text disappearing after a bad image
* (bug 18784) Internal links like [[File:Foo|caption]] should read 'caption',
  not 'File:Foo' when Foo is not an image
* (bug 21518) Special:UserRights no longer displays the user name box for users
  that can only change their rights
* (bug 21593) Special:UserRights now lists automatic groups membership
* (bug 22364) Setting $wgUseExternalEditor to false no longer hides the reupload
  link from file pages
* Fix bug introduced in MediaWiki 1.12: The author field in
  $wgExtensionCredits is no longer sorted with sort() but rather used
  as it appears in extensions as was the case before r30117 where it
  was unintentionally sorted along with other fields.
* (bug 19334) Textarea no longer jumps when editing longer articles in IE8
* Truncate summary of page moves in revision comment field to avoid broken
  multibyte characters
* (bug 22540) ForeignApiRepos no longer try to store thumbnails that don't exist
* (bug 22551) Special:Resetpass now has a "Cancel" button that sends the user to
  the page set in the &returnto parameter.
* (bug 19194) Search box in Modern skin doesn't focus with Safari/Chrome
* (bug 17790) Users instantly logged off on HughesNet
* (bug 21549) Make foreign key constraints DEFERRABLE INITIALLY DEFERRED
  when using Postgres as the database backend.

== API changes in 1.16 ==

* Added uiprop=changeablegroups to meta=userinfo
* Added usprop=gender to list=users
* (bug 18311) action=purge now works for images too
* Add parentid to prop=revisions output
* (bug 17832) action=delete returns 'unknownerror' instead of 'permissiondenied'
  when the user is blocked
* (bug 18546) Added timestamp of new revision to action=edit output
* (bug 18554) Also list hidden revisions in list=usercontribs for privileged
  users
* (bug 13049) "API must be accessed from the primary script entry point" error
* (bug 16422) Don't display help for format=jsonfm unless specifically requested
* Added PHP and database version to meta=siteinfo output
* (bug 18533) Add readonly message to meta=siteinfo output
* (bug 18518) Add clprop=hidden to prop=categories
* (bug 18710) Fixed internal error with empty parameter in action=paraminfo
* (bug 18709) Missing descriptions for some parameters in action=paraminfo
  output
* (bug 18731) Show correct SVN links for extension modules in api.php?version
* (bug 18730) Add version information to action=paraminfo output
* (bug 18743) Add ucprop=size to list=usercontribs
* (bug 18749) Add generator flag to action=paraminfo output
* Make action=block respect $wgEnableUserEmail and $wgSysopEmailBans
* Made deleting file description pages without files possible
* (bug 18773) Add content flag to siprop=namespaces output
* (bug 18785) Add siprop=languages to meta=siteinfo
* (bug 14200) Added user and excludeuser parameters to list=watchlist and
  list=recentchanges
* Added index, fromtitle and byteoffset fields to action=parse&prop=sections
  output
* (bug 19313) action=rollback returns wrong revid on master/slave setups
* (bug 19323) action=parse doesn't return section tree on pages with Cite
  warnings
* (bug 18720) Add anchor field to action=parse&prop=sections output
* (bug 19423) The initial file description page used caption in user lang
  rather than UI lang
* (bug 17809) Add number of users in user groups to meta=siteinfo
* (bug 18533) Add readonly reason to readonly exception
* (bug 19528) Added XSLT parameter to API queries in format=xml
* (bug 19040) Fix prependtext and appendtext in combination with section
  parameter in action=edit
* (bug 19090) Added watchlist parameter, deprecated watch and unwatch
  parameter in action=edit
* Added fields to list=search output: size, wordcount, timestamp, snippet
* Where supported by backend, list=search adds a 'searchinfo' element with
  optional info: 'totalhits' count and 'suggestion' alternate query term
* (bug 19907) $wgCrossSiteAJAXdomains added to allow specified (or all)
  external domains to access api.php via AJAX, if the browser supports the
  Access-Control-Allow-Origin HTTP header
* (bug 19999) Made metadata and properties of search results optional. Added
  srprop and srinfo.
* (bug 20700) Add amprop=default to meta=allmessages to list default value for
  customized messages
* Don't parse magic words in meta=allmessages, output messages unparsed
* (bug 21105) list=usercontribs can now list contribs for User:0
* (bug 21085) list=deletedrevs no longer returns only one revision when
  drcontinue param is passed
* (bug 21106) Deprecated parameters now tagged in action=paraminfo
* (bug 19004) Added support for tags
* (bug 21083) list=allusers no longer returns current timestamp for users
  without registration date
* (bug 20967) action=edit allows creation of invalid titles
* (bug 19523) Add inprop=watched to prop=info
* (bug 21589) API: Separate summary and initial page text for uploads
* (bug 21817) list=usercontribs returns empty result for empty ucuser
* (bug 21441) meta=userinfo&uiprop=options no longer returns default options
  for logged-in users under certain circumstances
* (bug 21945) Add chomp control in YAML
* Expand the thumburl to an absolute url to make it consistent with url and
  descriptionurl
* (bug 20233) ApiLogin::execute() doesn't handle LoginForm :: RESET_PASS
* (bug 22061) API: add prop=headitems to action=parse
* (bug 22240) API: include time in siteinfo
* (bug 22241) Quick edit is still using the deprecated watch parameter (API: Setting default for watch/unwatch wrongly set)
* (bug 22245) blfilterredirect=nonredirects in blredirect mode wrongly filtering
* (bug 22248) Output extension URLs in meta=siteinfo&siprop=extensions
* Support key-params arrays in 'descriptionmsg' in meta=siteinfo&siprop=extensions
* (bug 21922) YAML output should quote asterisk when used as key
* (bug 22297) safesubst: to allow substitution without breaking transclusion
* (bug 18758) API read of watchlist's wl_notificationtimestamp
* (bug 20809) Expose EditFormPreloadText via the API
* (bug 18427) Comment (edit summary) parser option for API
* (bug 18608) API should provide list of CSS styles to apply to rendered output
* (bug 18771) List possible errors in action=paraminfo

=== Languages updated in 1.16 ===

MediaWiki supports over 300 languages. Many localisations are updated
regularly. Below only new and removed languages are listed, as well as
changes to languages because of Bugzilla reports.

* Capiznon (cps) (new)
* North Frisian (frr) (new)
* Kirmanjki (kiu) (new)
* Komi-Permyak (koi) (new)
* Karachay-Balkar (krc) (new)
* Hill Mari (mrj) (new)
* Prussian (prg) (new)
* Romagnol (rgn) (new)
* Lower Silesian (sli) (new)
* Picard (pcd) (new)
* Uyghur (Arabic script) (ug-arab) (new)
* Upper Franconian (vmf) (new)
* Votic (vot) (new)
* Eastern Yiddish (ydd) (removed)
* Iriga Bicolano (bto) (removed)
* Ladin (lld) (removed)
* Laz (lzz) (removed)
* Palembang (plm) (removed)
* Megleno-Romanian (Greek script) (ruq-grek) (removed)
* Tamazight (tzm) (removed)
* Laz (lzz) (new)

* (bug 18474) Sorani (ckb - Central Kurdish) (renamed from ku-arab)
* Add PLURAL function for Scots Gaelic (gd)
* Add Estonian letters äöõšüž to linktrail (et)
* (bug 18776) Native name of Burmese language (my)
* (bug 18806) Use correct unicode characters in spelling of native Chuvash
  (Чӑвашла)
* (bug 18864) Updated autonym for Zhuang language
* (bug 18308) Updated date formatting in Occitan (oc)
* (bug 19080) Added ăâîşţșțĂÂÎŞŢȘȚ to Romanion (ro) linktrail
* (bug 19286) Correct commafying function in Polish (pl)
* (bug 19441) Updated date formatting for Lithuanian
* (bug 19630) Added ÄäÇçĞğŇňÖöŞşÜüÝýŽž to Turkmen (tk) linktrail
* (bug 19949) New linktrail for Greek (el)
* (bug 19809) Korean (North Korea) (ko-kp) (new)
* (bug 19968) Fixed "Project talk" namespace name for Maltese (mt)
* (bug 21168) Added áâãàéêçíóôõúü to Portuguese (pt) linktrail
* (bug 21596) Change interwiki link for Kurdish (ku)
* (bug 23767) PHP warning/error when REQUEST_URI returns blank (IIS issue).

== MediaWiki 1.15 ==

=== Configuration changes in 1.15 ===

* Added $wgNewPasswordExpiry, to specify an expiry time (in seconds) to
  temporary passwords
* Added $wgUseTwoButtonsSearchForm to choose the Search form behavior/look
* Added $wgNoFollowDomainExceptions to allow exempting particular domain names
  from rel="nofollow" on external links
* (bug 12970) Brought back $wgUseImageResize.
* Added $wgRedirectOnLogin to allow specifying a specifc page to redirect users
  to upon logging in (ex: "Main Page")
* Add $wgExportFromNamespaces for enabling/disabling the "export all from
  namespace" option (disabled by default)

=== New features in 1.15 ===

* (bug 2242) Add an expiry time to temporary passwords
* (bug 9947) Add PROTECTIONLEVEL parser function to return the protection level
  for the current page for a given action
* (bug 17002) Add &minor= and &summary= as parameters in the url when editing,
  to automatically add a summary or a minor edit.
* (bug 16852) padleft and padright now accept multiletter pad characters
* When using 'UserCreateForm' hook to add new checkboxes into
  Special:UserLogin/signup, the messages can now contain HTML to allow
  hyperlinking to the site's Terms of Service page, for example
* Add new hook 'UserLoadFromDatabase' that is called while loading a user
  from the database.
* (bug 17045) Options on the block form are prefilled with the options of the
  existing block when modifying an existing block.
* (bug 17055) "(show/hide)" links to Special:RevisionDelete now use a CSS class
  rather than hardcoded HTML tags
* Added new hook 'WantedPages::getSQL' into SpecialWantedpages.php to allow
  extensions to alter the SQL query which is used to get the list of wanted
  pages
* (bugs 16957/16969) Add show/hide to preferences for RC patrol options on
  specialpages
* (bug 11443) Auto-noindex user/user talk pages for blocked user
* (bug 11644) Add $wgMaxRedirects variable to control how many redirects are
  recursed through until the "destination" page is reached.
* Add $wgInvalidRedirectTargets variable to prevent redirects to certain
  special pages.
* Use HTML5 rel attributes for some links, where appropriate
* Added optional alternative Search form look - Go button & Advanced search
  link instead of Go button & Search button
* (bug 2314) Add links to user custom CSS and JS to Special:Preferences
* More helpful error message on raw page access if PHP_SELF isn't set
* (bug 13040) Gender switch in user preferences
* (bug 13040) {{GENDER:}} magic word for interface messages
* (bug 3301) Optionally sort user list according to account creation time
* Remote description pages for foreign file repos are now fetched in the
  content language.
* (bug 17180) If $wgUseFileCache is enabled, $wgShowIPinHeader is automatically
  set to false.
* (bug 16604) Mark non-patrolled edits in feeds with "!"
* (bug 16604) Show title/rev in IRC for patrol log
* (bug 16854) Whether a page is being parsed as a preview or section preview
  can now be determined and set with ParserOptions.
* Wrap message 'confirmemail_pending' into a div with CSS classes "error" and
  "mw-confirmemail-pending"
* (bug 8249) The magic words for namespaces and pagenames can now be used as
  parser functions to return the desired namespace or normalized title/title
  part for a given title.
* (bug 17110) Styled #mw-data-after-content in cologneblue.css to match the
  rest of the font
* (bug 7556) Time zone names in signatures lack i18n
* (bug 3311) Automatic category redirects
* (bug 17236) Suppress 'watch user page link' for IP range blocks
* Wrap message 'searchresulttext' (Special:Search) into a div with
  class "mw-searchresult"
* (bug 15283) Interwiki imports can now fetch included templates
* Treat svn:// URLs as external links by default
* New function to convert namespace text for display (only applies on wiki with
  LanguageConverter class)
* (bug 17379) Contributions-title is now parsed for magic words.
* Preprocessor output now cached in memcached.
* (bug 14468) Lines in classic RecentChanges and Watchlist have classes
  "mw-line-odd" and "mw-line-even" to make styling using css possible.
* (bug 17311) Add a note beside the gender selection menu to tell users that
  this information will be public
* Localize time zone regions in Special:Preferences
* Add NUMBEROFACTIVEUSERS magic word, which is like NUMBEROFUSERS, but uses
  the active users data from site_stats.
* Add a <link rel="canonical"> tag on redirected page views
* Replace hardcoded '...' as indication of a truncation with the
  'ellipsis' message
* Wrap warning message 'editinginterface' into a div with class
  'mw-editinginterface'
* (bug 17497) Oasis opendocument added to mime.types
* Remove the link to Special:FileDuplicateSearch from the "file history" section
  of image description pages as the list of duplicated files is shown in the
  next section anyway.
* Added $wgRateLimitsExcludedIPs, to allow specific IPs to be whitelisted from
  rate limits.
* (bug 14981) Shared repositories can now have display names, located at
  Mediawiki:Shared-repo-name-REPONAME, where REPONAME is the name in
  $wgForeignFileRepos
* Special:ListUsers: Sort list of usergroups by alphabet
* (bug 16762) Special:Movepage now shows a list of subpages when possible
* (bug 17585) Hide legend on Special:Specialpages from non-privileged users
* Added $wgUseTagFilter to control enabling of filter-by-change-tag
* (bug 17291) MediaWiki:Nocontribs now has an optional $1 parameter for the
  username
* Wrap special page summary message '$specialPageName-summary' into a div
  with class 'mw-specialpage-summary'
* $wgSummarySpamRegex added to handle edit summary spam. This is used *instead*
  of $wgSpamRegex for edit summary checks. Text checks still use $wgSpamRegex.
* New function to convert content text to specified language (only applies on wiki with
  LanguageConverter class)
* (bug 17844) Redirect users to a specific page when they log in, see
  $wgRedirectOnLogin
* Added a link to Special:UserRights on Special:Contributions for privileged users
* (bug 10336) Added new magic word {{REVISIONUSER}}, which displays the editor
  of the displayed revision's author user name
* LinkerMakeExternalLink now has an $attribs parameter for link attributes and
  a $linkType parameter for the type of external link being made
* (bug 17785) Dynamic dates surrounded with a <span> tag, fixing sortable tables with
  dynamic dates.
* (bug 4582) Provide preference-based autoformatting of unlinked dates with the dateformat
  parser function.
* (bug 17886) Special:Export now allows you to export a whole namespace (limited to 5000 pages)
* (bug 17714) Limited TIFF upload support now built in if 'tif' extension is
  enabled. Image width and height are now recognized, and when using ImageMagick,
  optional flattening to PNG or JPEG for inline display can be enabled by setting
  $wgTiffThumbnailType
* Renamed two input IDs on Special:Log from 'page' and 'user' to 'mw-log-page' and
  'mw-log-user', respectively
* Added $wgInvalidUsernameCharacters to disallow certain characters in
  usernames during registration (such as "@")
* Added $wgUserrightsInterwikiDelimiter to allow changing the delimiter
  used in Special:UserRights to denote the user should be searched for
  on a different database
* Add a class if 'missingsummary' is triggered to allow styling of the summary
  line
* Title attributes are now always blank on framed and thumbnailed images, and default to blank
  on inline images instead of defaulting to the image's filename. Additionally, the alt
  attribute now defaults to the filename on framed and thumbnailed images if no caption or alt
  attribute is specified.

=== Bug fixes in 1.15 ===
* (bug 16968) Special:Upload no longer throws useless warnings.
* (bug 17000) Special:RevisionDelete now checks if the database is locked
  before trying to delete the edit.
* (bug 16852) padleft and padright now handle multibyte characters correctly
* (bug 17010) maintenance/namespaceDupes.php now add the suffix recursively if
  the destination page exists
* (bug 17035) Special:Upload now fails gracefully if PHP's file_uploads has
  been disabled
* Fixing the caching issue by using -{T|xxx}- syntax (only applies on wiki with
  LanguageConverter class)
* Improving the efficiency by using -{A|xxx}- syntax (only applies on wiki with
  LanguageConverter class)
* (bug 17054) Added more descriptive errors in Special:RevisionDelete
* (bug 11527) Diff on page with one revision shows "Next" link to same diff
* (bug 8065) Fix summary forcing for new pages
* (bug 10569) redirects to Special:Mypage and Special:Mytalk are no longer
  allowed by default. Change $wgInvalidRedirectTargets to re-enable.
* (bug 3043) Feed links of given page are now preceded by standard feed icon
* (bug 17150) escapeLike now escapes literal \ properly
* Inconsistent use of sysop, admin, administrator in system messages changed
  to 'administrator'
* (bug 14423) Check block flag validity for block logging
* DB transaction and slave-lag avoidance tweaks for Email Notifications
* (bug 17104) Removed [Mark as patrolled] link for already patrolled revisions
* (bug 17106) Added 'redirect=no' and 'mw-redirect' class to redirects at
  "user contributions"
* Rollback links on new pages removed from "user contributions"
* (bug 15811) Re-upload form tweaks: license fields removed, destination locked,
  comment label uses better message
* Whole HTML validation ($wgValidateAllHtml) now works with external tidy
* Parser tests no longer fail when $wgExternalLinkTarget is set in
  LocalSettings
* (bug 15391) catch DBQueryErrors on external storage insertion. This avoids
  error messages on save were the edit in fact is saved.
* (bug 17184) Remove duplicate "z" accesskey in MonoBook
* Parser tests no longer fail when $wgAlwaysUseTidy is set in LocalSettings.php
* Removed redundant dupe warnings on reupload for the same title. Dupe warnings
  for identical files at different titles are still given.
* Add 'change tagging' facility, where changes can be tagged internally with
  certain designations, which are displayed on various summaries of changes,
  and the entries can be styled with CSS.
* (bug 17207) Fix regression breaking category page display on PHP 5.1
* Categoryfinder utility class no longer fails on invalid input or gives wrong
  results for category names that include pseudo-namespaces
* (bug 17252) Galician numbering format
* (bug 17146) Fix for UTF-8 and short word search for some possible MySQL
  configs
* (bug 7480) Internationalize database error message
* (bug 16555) Number of links to mediawiki.org scaled back on post-installation
* (bug 14938) Removing a section no longer leaves excess whitespace
* (bug 17304) Fixed fatal error when thumbnails couldn't be generated for file
  history
* (bug 17283) Remove double URL escaping in show/hide links for log entries
  and RevisionDeleteForm::__construct
* (bug 17105) Numeric table sorting broken
* (bug 17231) Transcluding special pages on wikis using language conversion no
  longer affects the page title
* (bug 6702) Default system messages updated/improved
* (bug 17190) User ID on preference page no longer has delimeters
* (bug 17341) "Powered by MediaWiki" should be on the left on RTL wikis
* (bug 17404) "userrights-interwiki" right was missing in User::$mCoreRights
* (bug 7509) Separation strings should be configurable
* (bug 17420) Send the correct content type from action=raw when the HTML file
  cache is enabled.
* (bug 12746) Do not allow new password e-mails when wiki is in read-only mode
* (bug 17478) Fixed a PHP Strict standards error in
  maintenance/cleanupWatchlist.php
* (bug 17488) RSS/Atom links in left toolbar are now localized in classic skin
* (bug 17472) use print <<<EOF in maintenance/importTextFile.php
* Special:PrefixIndex: Move table styling to shared.css, add CSS IDs to tables
  use correct message 'allpagesprefix' for input form label, replace _ with ' '
  in next page link
* (bug 17506) Exceptions within exceptions now respect $wgShowExceptionDetails
* Fixed excessive job queue utilisation
* File dupe messages for remote repos are now shown only once.
* (bug 14980) Messages 'shareduploadwiki' and 'shareduploadwiki-desc' are now
  used as a parameter in 'sharedupload' for easier styling and customization.
* (bug 17482) Formatting error in Special:Preferences#Misc (Opera)
* (bug 17556) <link> parameters in Special:Contributions feeds (RSS and Atom)
  now point to the actual contributors' feed.
* ForeignApiRepos now fetch MIME types, rather than trying to figure it locally
* Special:Import: Do not show input field for import depth if
  $wgExportMaxLinkDepth == 0
* (bug 17570) $wgMaxRedirects is now correctly respected when following
  redirects (was previously one more than $wgMaxRedirects)
* (bug 16335) __NONEWSECTIONLINK__ magic word to suppress new section link.
* (bug 17581) Wrong index name in PostgreSQL's updater: was rc_timestamp_nobot,
  changed to rc_timestamp_bot
* (bug 17437) Fixed incorrect link to web-based installer
* (bug 17538) Use shorter URLs in <link> elements
* (bug 13778) Hidden input added to the search form so that using the Enter key
  on IE will do a fulltext search like clicking the button does
* (bug 1061) CSS-added icons next to links display through the text and makes
  it unreadable in RTL
* Special:Wantedtemplates now works on PostgreSQL
* (bug 14414) maintenance/updateSpecialPages.php no longer throws error with
  PostgreSQL
* (bug 17546) Correct Tongan language native name is "lea faka-Tonga"
* (bug 17621) Special:WantedFiles has no link to Special:Whatlinkshere
* (bug 17460) Client ecoding is now correctly set for PostgreSQL
* (bug 17648) Prevent floats from intruding into edit area in previews if no
  toolbar present
* (bug 17692) Added (list of members) link to 'user' in Special:Listgrouprights
* (bug 17707) Show file destination as plain text if &wpForReUpload=1
* (bug 10172) Moved setting of "changed since last visit" flags out of the job
  queue
* (bug 17761) "show/hide" link in page history in now works for the first
  displayed revision if it's not the current one
* (bug 17722) Fix regression where users are unable to change temporary passwords
* (bug 17799) Special:Random no longer throws a database error when a non-
  namespace is given, silently falls back to NS_MAIN
* (bug 17751) The message for bad titles in WantedPages is now localized
* (bug 17860) Moving a page in the "MediaWiki" namespace using SuppressRedirect
  no longer corrupts the message cache
* (bug 17900) Fixed User Groups interface log display after saving groups.
* (bug 17897) Fixed string offset error in <pre> tags
* (bug 17778) MediaWiki:Catseparator can now have HTML entities
* (bug 17676) Error on Special:ListFiles when using Postgres
* Special:Export doesn't use raw SQL queries anymore
* (bug 14771) Thumbnail links to individual DjVu pages have two no longer have
  two "page" parameters
* (bug 17972) Special:FileDuplicateSearch form now works correctly on wikis that
  don't use PathInfo or short urls
* (bug 17990) trackback.php now has a trackback.php5 alias and works with
  $wgScriptExtension
* (bug 14990) Parser tests works again with PostgreSQL
* (bug 11487) Special:Protectedpages doesn't list protections with pr_expiry
  IS NULL
* (bug 18018) Deleting a file redirect leaves behind a malfunctioning redirect
* (bug 17537) Disable bad zlib.output_compression output on HTTP 304 responses
* (bug 11213) [edit] section links in printable version no longer appear when you cut-and-paste article text
* (bug 17405) "Did you mean" to mirror Go/Search behavior of original request
* (bug 18116) 'edittools' is now output identically on edit and upload pages
* (bug 17241) The diffonly URI parameter should cascade to "Next edit" and "Previous edit" diff links
* (bug 16823) 'Sidebar search form should not use Special:Search view URL as target'
* (bug 16343) Non-existing, but in use, category pages can be "go" match hits
* Fixed a CSS validation issue which allowed external images to be included
  into wikis where that is disallowed by configuration.
* Fixed a data leakage vulnerability for private wikis using img_auth.php or
  similar image access authentication schemes. Check user permissions before
  streaming out scaled images from thumb.php.

== API changes in 1.15 ==
* (bug 16858) Revamped list=deletedrevs to make listing deleted contributions
  and listing all deleted pages possible
* (bug 16844) Added clcategories parameter to prop=categories
* (bug 17025) Add "fileextension" parameter to meta=siteinfo&siprop=
* (bug 17048) Show the 'new' flag in list=usercontribs for the revision that
  created the page, even if it's not the top revision
* (bug 17069) Added ucshow=patrolled|!patrolled to list=usercontribs
* action=delete respects $wgDeleteRevisionsLimit and the bigdelete user right
* (bug 15949) Add undo functionality to action=edit
* (bug 16483) Kill filesort in ApiQueryBacklinks caused by missing parentheses.
  Building query properly now using makeList()
* (bug 17182) Fix pretty printer so URLs with parentheses in them are
  autolinked correctly
* (bug 17224) Added siprop=rightsinfo to meta=siteinfo
* (bug 17239) Added prop=displaytitle to action=parse
* (bug 17317) Added watch parameter to action=protect
* (bug 17007) Added export and exportnowrap parameters to action=query
* (bug 17326) BREAKING CHANGE: Changed output format for iiprop=metadata
* (bug 17355) Added auwitheditsonly parameter to list=allusers
* (bug 17007) Added action=import
* BREAKING CHANGE: Removed rctitles parameter from list=recentchanges because
  of performance concerns
* Listing (semi-)deleted revisions and log entries as well in prop=revisions
  and list=logevents
* (bug 11430) BREAKING CHANGE: Modules may return fewer results than the
  limit and still set a query-continue in some cases
* (bug 17357) Added movesubpages parameter to action=move
* (bug 17433) Added bot flag to list=watchlist&wlprop=flags output
* (bug 16740) Added list=protectedtitles
* Added mainmodule and pagesetmodule parameters to action=paraminfo
* (bug 17502) meta=siteinfo&siprop=namespacealiases no longer lists namespace
  aliases already listed in siprop=namespaces
* (bug 17529) rvend ignored when rvstartid is specified
* (bug 17626) Added uiprop=email to list=userinfo
* (bug 13209) Added rvdiffto parameter to prop=revisions
* Manual language conversion improve: Now we can include both ";" and ":" in
  conversion rules
* (bug 17795) Don't report views count on meta=siteinfo if $wgDisableCounters
  is set
* (bug 17774) Don't hide read-restricted modules like action=query from users
  without read rights, but throw an error when they try to use them.
* Don't hide write modules when $wgEnableWriteAPI is false, but throw an error
  when someone tries to use them
* BREAKING CHANGE: action=purge requires write rights and, for anonymous users,
  a POST request
* (bug 18099) Using appendtext to edit a non-existent page causes an interface
  message to be included in the page text
* Fixed the circular template inclusion check, was broken when the loop
  involved redirects. Without this, infinite recursion within the parser is
  possible.
* (bug 18601) generator=backlinks returns invalid continue parameter
* (bug 18597) Internal error with empty generator= parameter
* (bug 18617) Add xml:space="preserve" attribute to relevant tags in XML output
* (bug 17611) Provide a sensible error message on install when the SQLite data
  directory is wrong.

=== Languages updated in 1.15 ===

MediaWiki supports over 300 languages. Many localisations are updated
regularly. Below only new and removed languages are listed, as well as
changes to languages because of Bugzilla reports.

* Austrian German (de-at) (new)
* Swiss Standard German (de-ch) (new)
* Simplified Gan Chinese (gan-hans) (new)
* Traditional Gan Chinese (gan-hant) (new)
* Literary Chinese (lzh) (new)
* Uyghur (Latin script) (ug-latn) (renamed from 'ug')
* Veps (vep) (new)
* Võro (vro) (renamed from fiu-vro)
* (bug 17151) Add magic word alias for #redirect for Vietnamese
* (bug 17288) Messages improved for default language (English)
* (bug 12937) Update native name for Afar
* (bug 16909) 'histlegend' now reuses messages instead of copying them
* (bug 17832) action=delete returns 'unknownerror' instead of 'permissiondenied' when
  the user is blocked
* Traditional/Simplified Gan Chinese conversion support

== MediaWiki 1.14 ==

=== Configuration changes in 1.14 ===

* $wgExemptFromUserRobotsControl is an array of namespaces to be exempt from
  the effect of the new __INDEX__/__NOINDEX__ magic words.  (Default: null, ex-
  empt all content namespaces.)
* $wgForwardSearchUrl has been removed entirely. Documented setting since 1.4
  has been $wgSearchForwardUrl.
* (bug 15080) $wgOverrideSiteFeed has been added. Setting either
  $wgSiteFeed['rss'] or 'atom' to a URL will override the default Recent
  Changes feed that appears on all pages.
* $wgSQLiteDataDirMode has been introduced as the default directory mode for
  SQLite data directories on creation. Note that this setting is separate from
  $wgDirectoryMode, which applies to all normal dirs created by MediaWiki.
* $wgGroupsAddToSelf and $wgGroupsRemoveFromSelf now work more like
  $wgAddGroups and $wgRemoveGroups, where the user must belong to a specified
  group in order to add or remove those groups from themselves.
  Backwards compatibility is maintained.
* $wgRestrictDisplayTitle controls if the use of the {{DISPLAYTITLE}} magic
  word is restricted to titles equivalent to the actual page title. This
  is true per default, but can be set to false to allow any title.
* $wgSpamRegex may now be an array of multiple regular expressions.
* $wgAjaxSearch has been removed; use $wgEnableMWSuggest instead.
* Editing the MediaWiki namespace is now unconditionally restricted to people
  with the editinterface right, configuring this in $wgNamespaceProtection
  is not required.
* $wgAllowExternalImagesFrom may now be an array of multiple strings.
* Introduced $wgEnableImageWhitelist to toggle the on-wiki external image
  whitelist on or off.
* Added $wgRenderHashAppend to append some string to the parser cache and the
  sitenotice cache keys.
* $wgRCChangedSizeThreshold is now a positive integer by default,
* (bug 16006) $wgEnableWriteAPI is now true by default. Authorized can perform
  write actions using the API.
* Added $wgRC2UDPInterwikiPrefix which adds an interwiki prefix
  ($wgLocalInterwiki) onto the page names in the UDP feed.
* Added $wgAllowUserSkin to let the wiki's owner disable user selectable skins
  on the wiki. If it's set to false, then the skin used will *always* be
  $wgDefaultSkin.
* Added $wgEnotifUseRealName, which allows UserMailer to send out e-mails based
  on the user's real name if one is set. Defaults to false (use the username)
* Removed the 'apiThumbCacheDir' option from $wgForeignFileRepos (only used in
  ForeignAPIRepo)
* (bug 44) Image namespace and accompanying talk namespace renamed to File.
  For backward compatibility purposes, Image still works. External tools may
  need to be updated.
* The constants NS_FILE and NS_FILE_TALK can now be used instead of NS_IMAGE and
  NS_IMAGE_TALK.  The old constants are retained as aliases for compatibility,
  and should still be used in code meant to be compatible with v1.13 or older.
* MediaWiki can be forced to use private IPs forwarded by a proxy server by
  using $wgUsePrivateIPs.
* The 'BeforeWatchlist' hook has been removed due to internal changes in
  Special:Watchlist. 'SpecialWatchlistQuery' should now be used by extensions
  to customize the watchlist database query.

=== Migrated extensions ===
The following extensions are migrated into MediaWiki 1.14:

* Special:DeletedContributions to show deleted user contributions (was
  extension DeletedContributions)
* Special:Log/newusers recording new users (was extension Newuserlog)
* Special:LinkSearch to search for external links (was extension LinkSearch)
* RenderHash
* NoMoveUserPages
* UniversalEditButton

=== New features in 1.14 ===

* New URL syntaxes for Special:ListUsers - 'Special:ListUsers/USER' and
  'Special:ListUsers/GROUP/USER', in addition to the older syntax
  'Special:ListUsers/GROUP' where GROUP is a valid group name.
* Configurable per-namespace and per-page notices for the edit form,
  respectively MediaWiki:Editnotice-# where # is the namespace number, and
  MediaWiki:Editnotice-#-PAGENAME where # is the page's namespace number and
  PAGENAME is the page name minus the namespace prefix.
* (bug 8068) New __INDEX__ and __NOINDEX__ magic words allow user control of
  search engine indexing on a per-article basis.
* Handheld stylesheet options
* Added 'DoEditSectionLink' hook as a cleaner unified version of the old
  'EditSectionLink' and 'EditSectionLinkForOther' hooks.  Note that the
  'EditSectionLinkForOther' hook has been removed, but 'EditSectionLink' is
  run in all cases instead, so extensions using the old hooks should still work
  if they ran roughly the same code for both hooks (as is almost certain).
* Signature (~~~~) "cleaning", i.e. template removal, can be disabled with
  $wgCleanSignatures=false
* Extensions can use the SkinBuildSidebar hook to modify the content of the
  sidebar and add custom portlets to it
* Added 'MakeGlobalVariablesScript' hook for extensions to be able to add vari-
  ables into into the output of Skin::makeVariablesScript
* (bug 13846) Added $wgAddGroups and $wgRemoveGroups display on
  Special:ListGroupRights
* (bug 14377) Add a date selector to history pages
* (bug 15007) New 'pagetitle-view-mainpage' message allows the HTML <title> of
  the main page to be customized
* Added $wgDisableTitleConversion to disabling the conversion for all pages on
  the wiki
* Added 'noconvertlink' toggle that can be set per user preferences, also
  added 'convertlink=no|yes' on GET requests whether have the link titles
  being converted or not
* (bug 14921) Special:Contributions/: add user name to <title>
  Patch by Emufarmers
* Unescape more "safe" characters when producing URLs, for added prettiness
* Introduced a new hook 'SkinAfterContent' that allows extensions to add text
  after the page content and article metadata. Updated all skins and skin
  templates to work with that hook.
* (bug 14929) removeUnusedAccounts.php now supports 'ignore-touched' and
  'ignore-groups'. Patch by Louperivois
* (bug 15127) Work around minor display glitch in Opera.
* By default, reject file uploads that look like ZIP files, to avoid the
  so-called GIFAR vulnerability.
* (bug 15141) Give ability to only list protected pages with the cascading
  option enabled on Special:ProtectedPages
* (bug 15157) Special:Watchlist has the same options as Special:Watchlist:
  Show/Hide logged in users, Show/Hide anonymous, Invert namespace selection
* Added hook 'UserrightsChangeableGroups' to allow modification of what
  groups may be added or removed via the Special:UserRights interface.
* HTML entities like &nbsp; now work (are not escaped) in edit summaries.
* (bug 13815) In the comment for page moves, use the colon-separator message
  instead of a hardcoded colon.
* Allow <gallery> to accept image names without an Image: prefix
* Add tooltips to rollback and undo links
* BMP images are now displayed as PNG
* (bug 13471) Added NUMBERINGROUP magic word
* (bug 11884) Now support Flash EXIF attribute
* Show thumbnails in the file history list, patch by User:Agbad
* Added support of piped wikilinks using double-width brackets
* Added an on-wiki external image whitelist. Items in this whitelist are
  treated as regular expression fragments to match for when possibly
  displaying an external image inline.
* (bugs 15405, 15436) Sort more currency types correctly in sortable tables
* (bug 15422) Sort more different types of numbers in sortable tables
* (bug 2889) MediaWiki:Print.css applies to the printable version
* Category counts (e.g. from {{PAGESINCATEGORY:}}) should be more accurate for
  small categories
* After logging in, automatically redirect to wherever you logged in from
* (bug 5619) Break messages used in Special:Statistics down further
* (bug 11029) Add link to Special:Listusers?group=sysop etc at
  Special:Statistics
* (bug 15514) Setting $wgRightsText without $wgRightsUrl now produces a
  plaintext copyright notice. Patch by Juliano F. Ravasi.
* (bug 15551) Deletion log excerpt is now shown whenever a user vists a
  deleted page, even if they are unable to edit it.
* Added Wantedfiles special pages, allowing users to find image links with no
  image.
* (bug 12650) It is now possible to set different expiration times for
  different restriction types on the protection form.
* (bug 8440) Allow preventing blocked users from editing their talk pages
* Improved upload file type detection for OpenDocument formats
* Added the ability to set the target attribute on external links with
  $wgExternalLinkTarget
* api.php now sends "Retry-After" and "X-Database-Lag" HTTP headers if the
  maxlag check fails, just like index.php does
* Added "link" parameter to image links, to allow images to link to an
  arbitrary title or URL. This should replace inaccessible and incomplete
  solutions such as CSS-based overlays and ImageMap.
* (bug 368) Don't use caption for alt attribute; allow manual specification
  using new "alt=" parameter for images
* (bug 44) The {{ns:}} core parser function now also accepts localized
  namespace names and aliases; also, its output now uses spaces instead of
  underscores to match the behavior of the {{NAMESPACE}} magic word
* Added the ability to display user edit counts in Special:ListUsers. Off by
  default, enabled with $wgEdititis = true (named after the medical condition
  marked by unhealthy obsession with edit counts).
* Added a file cache to the parser to improve page rendering time on pages with
  several uses of the same image.
* (bug 1250) Users can still use "show preview" and "show changes" even if the
  wiki is set to read-only mode.
* Added a call to the 'UnwatchArticleComplete' hook to the watchlist editor.
  This should make it so that ALL user-accessible methods of removing a page
  from a watchlist lead to this hook being called (it was previously only
  called from within Article.php
* Maximum execution time for shell processes on linux is now configured with
  $wgMaxShellTime (180 seconds by default)
* (bug 1306) 'Email user' link no longer shown on user page when emailing
  is not available due to lack of confirmed address or disabled preference
* Special:Wanted templates special page added to display missing templates
  linked from articles
* Make search matches bold only, not red as well
* (bug 10080) Blocks can be modified without unblocking first
* (bug 15820) Special:BlockIP shows a notice if the user being blocked is
  already directly blocked
* (bug 13710) Allow to force "watch this" checkbox via URL using parameter
  "watchthis"
* (bug 15125) Add Public Domain to default options when installing. Patch by
  Nathan Larson.
* Set a special temporary directory for ImageMagick with $wgImageMagickTempDir
* (bug 16113) Show/hide for redirects in Special:NewPages
* (bug 15903) Upload link was added to Nostalgia skin
* (bug 15761) Add user toggle to omit diff after rollback
* Added the BitmapHandler_ClientOnly media handler, which allows server-side
  image scaling to be completely disabled for specific media types, via the
  $wgMediaHandlers configuration variable.
* New 'AbortDiffCache' hook can be used to cancel the caching of a diff
* (bug 15835) Added Content-Style-Type meta tag
* (bug 11027)  Add parameter to MW:Randompage-nopages so that user can see the
  namespace.
* Add id="mw-user-domain-section" to <tr> tag in Userlogin.php template so that
  admins with a single domain can hide the domain section using CSS
* Dropped old Paser_OldPP class. Only new parser with preprocessor is used.
* Moved password reset form from Special:Preferences to Special:ResetPass
* Added Special:ChangePassword as a special page alias for Special:ResetPass
* Added complimentary function for addHandler() called removeHandler() for removing events
* Improved security of file uploads for IE clients, using a reverse-engineered
  algorithm very similar to IE's content detection algorithm.
* Cascading protection no longer requires that both edit and move are restricted
  to sysop, just edit=sysop is enough
* (bug 2391) A warning is now shown for invalid ISBN numbers on Special:Booksources.
* Installer has been updated to reflect the release of the GFDL 1.3. The URL for 1.2
  has been updated, and the 1.3 URL has been given. 1.2 is still Wikipedia-compatible.
  RightsCode was changed from 'gfdl' to 'gfdl1_2', so we can now support 1.2 as well
  as 1.3 (gfdl1_3).
* (bug 16293) PD URL was changed to the CreativeCommons site on PD (which auto-detects
  your language) instead of Wikipedia.
* (bug 16635) The "view and edit watchlist" page (Special:Watchlist/edit) now
  includes a table of contents
* File objects returned by wfFindFile() are now cached by default
* (bug 7492) Rights can now be assigned to specific IP addresses and ranges by
  using $wgAutopromote (new defines: APCOND_ISIP and APCOND_IPINRANGE)
* Add a 'change block' link to Special:IPBlockList and Special:Log
* (bug 16459) Use native getElementsByClassName where possible, for better
  performance in modern browsers
* Enable \cancel and \cancelto in texvc (recompile required)
* Added 'UserCryptPassword' and 'UserComparePasswords' hooks to allow extensions to implement
  their own password hashing methods.
* (bug 16760) Add CSS-class to action links of Special:Log
* (bug 505) Time zones can now be specified by location in user preferences,
  avoiding the need to manually update for DST. Patch by Brad Jorsch.
* (bug 2585) HTTP 404 return code is now given for a page view if the page
  does not exist, allowing spiders and link checkers to detect broken links.
* Special:Log: Add 'change protection' link for unprotected pages too
* Special:Log: Add log type specific CSS classes 'mw-logline-$logtype' to
  'li' elements
* (bug 16754) Making arbitrary rows of sortable tables sticky:
  |- class="unsortable"
* Show subversion too even if a "normal" version number is available
* (bug 16121) Add a note that a page move was without creating a redirect in the
  move log
* Image moving is now enabled for sysops by default
* Make "Did you mean" search feature more noticeable
* (bug 16720) Transcluded Special:NewPages processes "/username="

=== Bug fixes in 1.14 ===

* (bug 14907) DatabasePostgres::fieldType now defined.
* (bug 14659) Passing the default limit param to Special:Recentchanges no more
  falls back to the user option
* (bug 14954) Fix regression in Modern and Simple skins
* Recursion loop check added to Categoryfinder class
* Fixed few performance troubles of large job queue processing
* Not setting various parameters in Foreign Repos now fails more gracefully
* (bug 2333) Redirects are properly rendered when previewing an edit.
* (bug 14972) Use localized alias of Special:Search on all search forms
* (bug 11035) Special:Search should have descriptive <title>
* Special pages are now not subject to special handling for "self-links"
* (bug 15053) Syntactically incorrect redirects with another link in them
  no longer redirect to the second link
* (bug 15049) Fix for CheckUser extension's log search: usernames containing
  a "-" were incorrectly turned into bogus IP range searches.
  Patch by Max Semenik.
* (bug 15055) Talk page notifications no longer attempt to send mail when
  user's e-mail address is invalid or unconfirmed
* (bug 12370) Add throttle on password attempts. Defaults to max 5 attempts in
  5 minutes.
* (bug 15016) 'Templates used on this page' list in view source should be
  wrapped in a div with class "templatesUsed"
* (bug 14868) Setting $wgFeedDiffCutoff to 0 now disables generation of the
  diff entirely, not just the display of it.
* (bug 6387) Introduced new setting $wgCategoryPrefixedDefaultSortkey which
  allows having the unprefixed page title as the default category sortkey
* (bug 15079) Add class="ns-talk" / "ns-subject" to <body>. Also added
  ns-special to special pages.
* (bug 15052) Skins should add their name as a class in <body>
* (bug 14165, bug 14294) Wikimedia specific configuration in convertGrammar()
  for several languages was removed. The settings have been put in extension
  WikimediaMessages. Patch for Czech by Danny B.
* (bug 15101) Displaying only bots edits in Special:Recentchanges now works
  again
* (bug 13770) Fixed incorrect detection of PHP's DOM module
* (bug 14790) Export of category pages when using Category: prefix now actually
  gives results
* Avoid recursive crazy expansions in section edit comments for pages which
  contain '/*' in the title
* Fix excessive memory usage when parsing pages with lots of links
* $wgSpamRegex now matches the edit summary and page move descriptions in
  addition to body text.
* Navigation links to images available from a shared repository (like Commons)
  from their local talk pages no longer appear as redlinks
* Action=purge on ForeignApiFiles now works (purges their thumbnails and
  description pages).
* (bug 15303) Title conversion for templates wasn't working in some cases.
* (bug 15264) Underscores in Special:Search/Foo_bar parameters were taken
  literally; now converting them to spaces per expectation.
* (bug 15342) "Invert" checkbox now works correctly when selecting main
  namespace in Special:Watchlist
* (bug 15172) 'Go' button of Special:Recentchanges now on the same line as the
  last input element (like Special:Watchlist too)
* (bug 15351) Fix fatal error for invalid section fragments in autocomments
* Fixed intermittent deadlock errors involving objectcache table queries.
  Use a separate database connection for the objectcache table to avoid
  long-lasting locks on that table.
* Respect file restrictions in the file history list
* (bug 15399) Odd/even classes on sortable tables' rows could be slow for large
  tables, and have been disabled by default.
* (bug 15482) Special:Recentchangeslinked has no longer two submit buttons
* (bug 15292) New message notification for unregistred users now works again
* (bug 14398) mwsuggest.js: Let width of container be configurable
* (bug 15543) Only include user touched timestamp to generated CSS
* (bug 15497) Removed encoding attribute from <?xml ?> tag
* (bug 12284) Special:Preferences now sets a returnto parameter on the link to
  Special:UserLogin. Patch by Marooned.
* Fixed the HTTP accept language string detection length in
  LanguageConverter.php, instead of the fixed length language codes.
* Special:RecentChangesLinked no longer shows outgoing links for nonexistent
  pages even if there are broken link records with source article id 0 in the
  database
* (bug 15598) Special:Newpages default limit uses user preference for
  recentchanges limit instead of hardcoded 50.
* (bug 15617) $wgFeedClassesOutputPage::getHeadLinks() respects $wgFeedClasses,
  instead of hardcoding rss and atom. Patch by Juliano F. Ravasi.
* (bug 14638) Special:Blockip now provides a link to the block log if the user
  has been blocked more than 10 times. Patch by Matt Johnston.
* (bug 12678) Skins don't show Upload link if the user isn't allowed to upload.
* Fixed incorrect usage of DB_LAST in Special:Export. Deprecated DB_LAST.
* (bug 15642) Blocked sysops can no longer block other users
* Http::request() now respects $wgHTTPtimeout when not using cURL
* (bug 15158) Userinvalidcssjstitle not shown on preview
* (bug 15196) Free external links should be numbered in a localised manner
* (bug 15388) Title of Special:PrefixIndex
* Links with no title but a curid parameter now use the curid to pick a page
* (bug 10323) Special:Undelete should have "inverse selection" button
* (bug 15831) Modern skin RTL support is bugous
* (bug 15869) Nostalgia skin does not show page title in printable mode
* (bug 15795) Special:Userrights is now listed on Special:SpecialPages when the
  user can only change his rights
* (bug 15846) Categories "leak" from older revisions in certain circumstances
* (bug 15928) Special pages dropdown should be inline in non-MonoBook skins
* (bug 14178) Some uses of UserLoadFromSession hook cause segfault
* (bug 15925) Postitive bytes added on recentchanges and watchlists are now
  bolded if above the threshold, previously it only worked for negatives
* Specify apple-touch-icon before favicon in HTML head section to make the
  Konqueror browser correctly use the latter
* (bug 15717) Set $separatorTransformTable for language 'eu'
* (bug 15605) Enabled $datePreferences for language 'hr'. Added standard date
  preferences.
* (bug 13701) {{NUMBEROFVIEWS}} magic word to show number of total views.
* (bug 5101) Image from Commons doesn't show up when searched in Wikipedia
  search box
* (bug 14609) User's namespaces to be searched default not updated after adding
  new namespace
* Purge form uses valid XHTML
* (bug 12764) Special:LonelyPages shows transcluded pages
* (bug 16073) Enhanced RecentChanges uses onclick handler with better fallback
  if JavaScript is disabled
* (bug 4253) Recentchanges IRC messages no longer include title in diff URLs
* Allow '0' to be an accesskey.
* (bug 8063) Use language-dependent sorting in client-side sortable tables
* (bug 16160) Suggestions box should be resized from left for RTL wikis
* (bug 11533) Fixed insane slowdown when in read-only mode for long periods
  of time with CACHE_NONE (default objectcache table configuration).
* Trying to set two different default category sort keys for one page now
  produces a warning
* (bug 16143) Fix redirect loop on special pages starting with lower case
  letters
* (bug 15737) Fix notices while expanding using PPCustomFrame
* (bug 15544) Non-index entry points cause the "Wiki not set up" message to
  have corrupt URLs
* (bug 5101) Image from Commons doesn't show up when searched in Wikipedia
  search box
* (bug 4362) [[MediaWiki:History copyright]] no more used with most recent
  revision when passing oldid parameter in the url
* (bug 16265) When caching thumbs with the ForeignApiRepo, we now use the same
  filename as the remote site.
* (bug 8345) Don't autosummarize where a redirect was left unchanged
* Made thumb caching in ForeignApiFile objects integrated with normal thumb
  path naming (/thumbs/hash/file), retired 'apiThumbCacheDir' as a result.
* (bug 5530) Consistency between character encoding in {{PAGENAMEE}},
  {{SUBPAGENAMEE}} and {{FULLPAGENAMEE}}
* Safer handling of non-MediaWiki exceptions -- now obeys our settings for
  formatting and path exposure.
* Less verbose errors from profileinfo.php when not configured
* Blacklist redirects via Special:Filepath, hard to use.
* Improved input validation on Special:Import form
* Add a .htaccess to deleted images directory for additional protection
  against exposure of deleted files with known SHA-1 hashes on default
  installations.
* Improved scripting safety heuristics for IE 5/6 content-type detection.
* Improved scripting safety heuristics on SVG uploads.
* (bug 11728) Unify layout of enhanced watchlist/recent changes
* (bug 8702) Properly update stats when running nukePage maintenance script
* (bug 7726) Searches for words less than 4 characters now work without
  requiring customization of MySQL server settings
* Honour unchecked "Leave a redirect behind" for moved subpages
* (bug 16440) Broken 0-byte math renderings are now deleted and re-rendered
  when page is re-parsed.
* (bug 6100) Unicode BiDi embedding/override characters (U+202A - U+202E) are
  now automatically removed from titles; these characters can accidentally end
  up in copy-and-pasted titles, and, by overriding normal bidirectional text
  handling, can lead to annoying behavior such as text rendering backwards
* Fixed minor bug where the memcached value for how many accounts an IP had
  created that day would be increased even if $wgAccountCreationThrottle was
  hit. This meant if an IP hit the throttle and then the throttle was raised
  later that day, the IP still couldn't create another account, because it
  had marked them as having created another account, when their last account
  creation had actually failed.
* (bug 12647) Allow autogenerated edit summary messages to be blanked with '-'
* (bug 16026) 'Revision-info' and 'revision-info-current' both accept wiki
  markup now.
* (bug 16529) Fix for search suggestions with some third-party JS libraries
* (bug 13342) importScript() generates more consistent URI encoding
* (bug 16577) When a blocked user tries to rollback a page, the block message
  is now only displayed once
* (bug 14268) SVG image sizes now extracted with proper XML parser
* (bug 14365) RepoGroup::findFiles() no longer crashes if passed an invalid
  title via the API
* (bug 4253, bug 16586) Revision ID is now given instead of title in URLs for
  new pages in the recent changes IRC feed
* Ugly tooltips in Special:Statistics were phased out in favor of more direct
  information. Went ahead and rewrote SpecialStatistics to subclass SpecialPage
* (bug 5506) Links to files on foreign repositories are now shown consistently
  as bluelinks e.g. in logs and edit summaries
* (bug 16623) Add missing </p> tag in Special:LockDB
* (bug 15849) Special:Movepage now throws a more specific error when trying to
  move a title to an interwiki target
* (bug 16638) 8-bit URL fallback encoding now set on additional languages using
  Arabic script (Persian, Urdu, Sindhi, Punjabi)
* (bug 16656) cleanupTitles and friends should now work in load-balanced
  DB environments when $wgDBserver isn't set.
* (bug 3691) Aspect ratio from viewBox attribute is now preserved for SVG
  images which do not specify width and height attributes.
* (bug 15027) Internet domain names and IP addresses can now be indexed and
  searched sensibly with the default MySQL search backend.
* (bug 11733) Fixed parameter validation in importTextFile.php
* (bug 16712) Special:NewFiles updated to use "newer"/"older" paging messages
  for clarity over "previous/next"
* (bug 16612) Fixed "noprint" class for Modern skin print style
* Section anchors now have an "id" attribute as well as a "name" attribute,
  even when Tidy is not used
* (bug 16026) revision-info, revision-info-current, cannotdelete,
  redirectedfrom, historywarning and difference messages now use Wiki text
  rather than raw HTML markup
* (bug 13835) Fix rendering of {{filepath:Wiki.png|nowiki}}
* (bug 16772) Special:Upload now correctly rejects files with spaces in the
  file extension (e.g. Foo. jpg).
* Image moving over an existing file no longer throws a database error
* (bug 16786) Restored "redundant" links recently removed from Classic sidebar
* (bug 16850) $wgActionPaths can have query strings now, previously, this broke
  local URLs
* (bug 16376) Mention in deleteBatch.php and moveBatch.php maintenance scripts
  that STDIN can be used for page list
* (bug 16560) Special:Random returns a page from ContentNamespaces, and no
  longer from NS_MAIN

=== API changes in 1.14 ===

* Registration time of users registered before the DB field was created is now
  shown as empty instead of the current time.
* API search now falls back to fulltext search by default when using Lucene
  or other engine which doesn't support a separate title search function.
  This means you can use API search on Wikipedia without explicitly adding
  &srwhat=text to the query.
* Added iiprop=bitdepth to imageinfo and aiprop=bitdepth to allimages
* (bug 14713) API-specific permissions (such as 'writeapi' and 'apihighlimits'
  are now listed on action=help
* (bug 15044) Added requestid parameter to api.php to facilitate distinguishing
  between requests
* (bug 15048) Added limit field for multivalue parameters to action=paraminfo
  output.
* When the limit on multivalue parameters is exceeded, a warning is issued
* list=search doesn't list missing pages any more
* (bug 15178) Added clshow to prop=categories to allow filtering for hidden/
  non-hidden categories
* (bug 15228) Combining revids= and redirects now throws a warning instead of
  an error, and still resolves redirects generated by the generator.
* list={backlinks,embeddedin,imageusage} now return arrays with keys 0, 1, 2,
  etc. (AKA lists) instead of arrays with pageIDs as keys (AKA hash tables)
  for consistency with other list modules.
* Added action=watch
* (bug 15275) apprefix and related parameters ignore spaces at the end
* action=edit no longer throws unknown error 228  when trying to create an
  empty section with section=new
* Database replication lag doesn't cause all action=edit requests to return the
  nochange flag any more
* (bug 15392) ApiFormatBase::formatHTML now uses $wgUrlProtocols.
* (bug 15444) action=edit returns "Unknown error: ``AS_END''" where it should
  return just "Unknown error"
* (bug 15448) YAML output returns empty values instead of 0
* (bug 15445) Added action=patrol
* (bug 15466) Added action=purge
* (bug 15486) action=block ignores autoblock parameter
* (bug 15492) added rcprop=loginfo to list=recentchanges
* (bug 15527) action=rollback can now revert anonymous editors
* (bug 15535) prop=info&inprop=protection doesn't list pre-1.10 protections
  if the page is also protected otherwise (1.10+ style or cascading)
* list=random now has rnredirect parameter, to get random redirects.
* Added APIAfterExecute, APIQueryAfterExecute and APIQueryGeneratorAfterExecute
  hooks which allow for extending core modules in a cleaner way
* action=protect checks for invalid protection types and levels
* (bug 15673) Added indentation to format=wddxfm output and improved built-in
  WDDX formatter to resemble PHP's more
* (bug 15706) Empty values for apprtype and apprlevel are now silently ignored
  rather than causing an exception
* Added uiprop=preferencestoken to meta=userinfo
* (bug 15609) Add inprop=url and inprop=readable to prop=info
* Add ApiDisabled and ApiQueryDisabled classes so individual modules can
  be disabled in LocalSettings.php
* (bug 15653) Add prop=duplicatefiles
* (bug 15768) Add list=watchlistraw
* (bug 15647) action=edit with basetimestamp fails if the page has been deleted
  and undeleted since the last edit
* (bug 15785) Allow for different expiry times for different protections in
  action=protect
* Added allowsduplicates attribute to action=paraminfo output
* (bug 15767) apfilterlanglinks returns duplicate results
* (bug 15845) Added pageid/fromid parameter to action=delete/move, making
  manipulation of legacy pages with invalid titles possible
* (bug 15881) Empty or invalid parameters cause database errors
* The maxage and smaxage parameters are now properly validated
* (bug 15945) list=recentchanges doesn't check $wgUseRCPatrol, $wgUseNPPatrol
  and patrolmarks right
* (bug 15985) acfrom and aifrom parameters didn't work when sorting in
  descending order.
* (bug 15995) Add cmstartsortkey and cmendsortkey parameters to
  list=categorymembers
* (bug 16017) list=categorymembers sets invalid continue parameters for
  sortkeys containing pipes
* (bug 16018) Added uccontinue parameter to list=usercontribs so paging
  works properly when multiple users are queried or a userprefix is used
* (bug 16047) Added activeusers attribute to meta=siteinfo&siprop=statistics
  output
* Added redirect resolution to action=parse
* (bug 16074) rvprop=content combined with a generator with a high limit causes
  an error
* (bug 16105) Image metadata attributes containing spaces result in invalid XML
* (bug 16126) Added siprop=magicwords to meta=siteinfo
* (bug 16159) Added wlshow=patrolled|!patrolled to list=watchlist
* (bug 16225) Titles like Talk:Talk:Foo broke apfrom and friends
* meta=siteinfo&siprop=interwikimap no longer throws an exception for empty
  sifilter parameter.
* (bug 12760) meta=userinfo&uiprop=ratelimits doesn't list group-specific rate
  limits
* (bug 16398) meta=userinfo&uiprop=rights lists some rights twice in some cases
* (bug 16408) Added rvgeneratexml to prop=revisions
* (bug 16421) Made list=logevents's leuser accept user names with underscores
  instead of spaces
* (bug 16516) Made rvsection=T-2 work
* (bug 16526) Added usprop=emailable to list=users
* (bug 16548) list=search threw errors with an invalid error code
* (bug 16515) Added pst and onlypst parameters to action=parse
* (bug 16541) Added block expiry timestamp to list=logevents output
* (bug 16613) action=protect doesn't tell when &cascade was set but cascading
  protection wasn't allowed
* (bug 16626) action=delete now correctly handles empty "reason" param
* (bug 15579) clshow considers all categories !hidden
* (bug 16647) list=allcategories, prop=categories don't return "hidden"
  property for hidden categories
* New siprop parameter of 'extensions' to list all installed extensions
* (bug 16672) Include canonical namespace name in
  meta=siteinfo&siprop=namespaces.
* (bug 16726) siprop=namespacealiases should also list localized aliases
* (bug 16730) Added apprfiltercascade parameter to list=allpages to filter
  cascade-protected pages

=== Languages updated in 1.14 ===

MediaWiki supports over 300 languages. Many localisations are updated
regularly. Below only new and removed languages are listed.

* Bakhtiari (bqi) (new)
* Fiji Hindi (Devanagari script) (hif-deva) (new)
* Krio (kri) (new)
* Lezghian (lez) (new)
* Laz (lzz) (new)
* Eastern Mari (mhr) (new)
* Niuean (niu) (new)
* Oromo (om) (new)
* Plautdietsch (pdt) (new)
* Western Punjabi (pnb) (new)
* Tarantino (roa-tara) (new)
* Serbo-Croatian (sh) (new)
* Tulu (tcy) (new)


== MediaWiki 1.13 ==

== Changes since 1.13.2 ==

David Remahl of Apple's Product Security team has identified a number of
security issues in previous releases of MediaWiki. Subsequent analysis by the
MediaWiki development team expanded the scope of these vulnerabilities. The
issues with a significant impact are as follows:

* An XSS vulnerability affecting all MediaWiki installations between 1.13.0 and
  1.13.2. [CVE-2008-5249]
* A local script injection vulnerability affecting Internet Explorer clients for
  all MediaWiki installations with uploads enabled. [CVE-2008-5250]
* A local script injection vulnerability affecting clients with SVG scripting
  capability (such as Firefox 1.5+), for all MediaWiki installations with SVG
  uploads enabled. [CVE-2008-5250]
* A CSRF vulnerability affecting the Special:Import feature, for all MediaWiki
  installations since the feature was introduced in 1.3.0. [CVE-2008-5252]

XSS (cross-site scripting) vulnerabilities allow an attacker to steal an
authorised user's login session, and to act as that user on the wiki. The
authorised user must visit a web page controlled by the attacker in order to
activate the attack. Intranet wikis are vulnerable if the attacker can
determine the intranet URL.

Local script injection vulnerabilities are like XSS vulnerabilities, except
that the attacker must have an account on the local wiki, and there is no
external site involved. The attacker uploads a script to the wiki, which another
user is tricked into executing, with the effect that the attacker is able to act
as the privileged user.

CSRF vulnerabilities allow an attacker to act as an authorised user on the wiki,
but unlike an XSS vulnerability, the attacker can only act as the user in a
specific and restricted way. The present CSRF vulnerability allows pages to be
edited, with forged revision histories. Like an XSS vulnerability, the
authorised user must visit the malicious web page to activate the attack.

These four vulnerabilities are all fixed in this release.

David Remahl also reminded us of some security-related configuration issues:

* By default, MediaWiki stores a backup of deleted images in the images/deleted
  directory. If you do not want these images to be publically accessible, make
  sure this directory is not accessible from the web. MediaWiki takes some steps
  to avoid leaking these images, but these measures are not perfect.
* Set display_errors=off in your php.ini to avoid path disclosure via PHP fatal
  errors. This is the default on most shared web hosts.
* Enabling MediaWiki's debugging features, such as $wgShowExceptionDetails, may
  lead to path disclosure.

Other changes in this release:

* Avoid fatal error in profileinfo.php when not configured.
* Add a .htaccess to deleted images directory for additional protection against
  exposure of deleted files with known SHA-1 hashes on default installations.
* Avoid streaming uploaded files to the user via index.php. This allows
  security-conscious users to serve uploaded files via a different domain, and
  thus client-side scripts executed from that domain cannot access the login
  cookies. Affects Special:Undelete, img_auth.php and thumb.php.
* When streaming files via index.php, use the MIME type detected from the
  file extension, not from the data. This reduces the XSS attack surface.
* Blacklist redirects via Special:Filepath. Such redirects exacerbate any
  XSS vulnerabilities involving uploads of files containing scripts.
* Internationalisation updates.

== Changes since 1.13.1 ==

* Security: Work around misconfiguration by requiring strict comparisons for
  in_array in User::isAllowed().
* (bug 14944) Added $wgShellLocale for configuration of an appropriate locale
  to use for LC_CTYPE during shell invocation. For servers that don't have
  en_US.utf8. Also added locale detection during install.
* Localisation updates
* Security: Fixed XSS vulnerability in useskin parameter.

== Changes since 1.13.0 ==

* (bug 15460) Fixed intermittent deadlock errors and poor concurrent
  performance for installations without memcached.
* (bug 13770) Fixed DOM module detection for installations with both dom
  and domxml.
* (bug 15148) Fixed Special:BlockIP for PostgreSQL
* Fixed SQLite support for non-memcached installations
* Localisation updates, Achinese (ace) added.

== Changes since 1.13.0rc2 ==

* (bug 13770) Fixed incorrect detection of PHP's DOM module
* Fix regression from r37834: accesskey tooltip hint should be given for the
  minor edit and watch labels on the edit page.
* Updated Chinese simplified/traditional conversion tables

== Changes since 1.13.0rc1 ==

* $wgForwardSearchUrl has been removed entirely. Documented setting since 1.4
  has been $wgSearchForwardUrl.
* (bug 14907) DatabasePostgres::fieldType now defined.
* (bug 14966) Fix SearchEngineDummy class for silently non-functional search
  on Sqlite instead of horribly fatal error breaky one.
* (bug 14987) Only fix double redirects on page move when the checkbox is
  checked
* (bug 13376) Use $wgPasswordSender, not $wgEmergencyContact, as return
  address for page update notification mails.
* API: Registration time of users registered before the DB field was created is now
  shown as empty instead of the current time.
* (bug 14904): fragments were lost when redirects were fixed.
* Added magic word __STATICREDIRECT__ to suppress the redirect fixer
* (bug 15035) Revert English linkTrail to /^([a-z]+)(.*)$/sD, as it was before
  r36253. Multiple reports of breakage due to old (pre-5.0) PCRE libraries,
  both bundled with PHP and packaged with distros such as RHEL.
* (bug 14944) Shell invocation of external programs such as ImageMagick convert
  was broken in PHP 5.2.6, if the server had a non-UTF-8 locale.


=== Configuration changes in 1.13 ===

* New option $wgFeed can be set false to turn off syndication feeds
* (bug 5745) Special:Whatlinkshere now shows up to $wgMaxRedirectLinksRetrieved
  links through each redirect instead of hardcoded 500
* Set $wgUploadSizeWarning to false by default
* Added $wgLBFactoryConf, for generic configuration of multi-master wiki farms
* Removed $wgAlternateMaster, use $wgLBFactoryConf
* (bug 13562) Misspelled option $wgUserNotifedOnAllChanges changed to
  $wgUserNotifiedOnAllChanges
* (bug 12860) New option $wgSitemapNamespaces allows sitemaps to be generated
  for only some namespaces
* Removed the emailconfirmed implicit group by default. To re-add it, use:
    $wgAutopromote['emailconfirmed'] = APCOND_EMAILCONFIRMED;
  in your LocalSettings.php.
* (bug 2396) New shared database configuration variables. $wgSharedPrefix allows
  you to use a shared database with a different prefix. Or you can now use a local
  database and use prefixes to separate wiki and the shared tables. And the new
  $wgSharedTables variable allows you to specify a list of tables to share.
* Automatic edit summaries can be disabled with $wgUseAutomaticEditSummaries
* Duplicates of images are now shown on the image page
* $wgRCFilterByAge allows for the list of dates in recent changes special pages to
  be filtered to only those within the range of $wgRCMaxAge
* $wgRCLinkLimits and $wgRCLinkDays allow for customization of the list and limits
  displayed on the recent changes special pages
* The "createpage" permission is no longer required when uploading if the target
  image page already exists
* $wgMaximumMovedPages restricts the number of pages that can be moved at once
  (default 100) with the new subpage-move functionality of Special:Movepage
* Hooks display in Special:Version is now disabled by default, use
  $wgSpecialVersionShowHooks = true; to enable it.
* $wgActiveUserEditCount sets the number of edits that must be performed over
  a certain number of days to be considered active
* $wgActiveUserDays is that number of days
* $wgRateLimitsExcludedGroups has been deprecated in favor of
  $wgGroupPermissions[]['noratelimit']. The former still works, however.
* New $wgGroupPermissions option 'move-subpages' added to control bulk-moving
  subpages along with pages.  Assigned to 'user' and 'sysop' by default.
* New $wgRC2UDPOmitBots allows user to omit bot edits from UDP output.
  Default: false
* Removed $wgEnableCascadingProtection option. Disabling cascading protection
  is no longer possible.
* $wgMessageCacheType defines now the type of cache used by the MessageCache class,
  previously it was choosen based on $wgParserCacheType
* $wgExtensionAliasesFiles option to simplify adding aliases to special pages
  provided by extensions, in a similar way to $wgExtensionMessagesFiles
* Added $wgXMLMimeTypes, an array of XML mimetypes we can check for
  with MimeMagic.
* Added $wgDirectoryMode, which allows for setting the default CHMOD value when
  creating new directories.
* (bug 14843) $wgCookiePrefix can be set by LocalSettings now, false defaults
  current behavior.

=== New features in 1.13 ===

* __HIDDENCAT__ on a category page causes the category to be hidden on the
  article page
* Do not show edit permissions errors on a red link click, just redirect to the
  article. This is so that readers who don't know what a red link is are not
  confused when they are told they are range-blocked.
* Add a new hook ImageBeforeProduceHTML to allow extensions to modify wikitext
  image syntax output
* (bug 13100) Added 'preloadtitle' parameter to action=edit&section=new that
  pre-fills the section title field
* (bug 13112) Added Special:RelatedChanges alias to Special:RecentChangesLinked
* (bug 13130) Moved edit token and autosummary fields above edit tools to
  reduce broken form submissions
* Add --old-redirects-only option to maintenance/refreshLinks.php, to add old
  redirects to the redirect table
* Add links to page and file deletion forms to edit predefined delete reasons
* (bug 13269) Added MediaWiki:Uploadfooter to the bottom of Special:Upload
* (bug 2815) Search results for media now use thumbnail instead of text extract
* When a page doesn't exist, the tab should say "create", not "edit"
* (bug 12882) Added a span with class "patrollink" around "Mark as patrolled"
  link on diffs
* Magic word formatnum can now take raw suffix to undo formatting
* Add updatelog table to reliably permit updates that don't change the schema
* Add category table to allow better tracking of category membership counts
** (bug 1212) Give correct membership counts on the pages of large categories
** Use category table for more efficient display of Special:Categories
* (bug 1459) Search for duplicate files by hash: Special:FileDuplicateSearch
* (bug 9447) Added hooks for search result headings
* Image redirects are now enabled by default
* (bug 13450) Email confirmation can now be canceled before the expiration
* (bug 13490) Show upload/file size limit on upload form
* Redesign of Special:UserRights
* Make rev_deleted log entries more intelligible
* (bug 6943) Added PAGESINCATEGORY: magic word
* (bug 13604) Added Special:ListGroupRights
* (bug 6332, 8617) Added message 'mainpage-description' as duplicate of
  'mainpage' and added it to message 'sidebar'
* Automatically add old redirects to the redirect table when needed
* (bug 6934) Allow inclusions, links, redirects to be separately toggled on or
  off on Special:WhatLinksHere
* Cache image redirects
* (bug 10457) Organize Special:SpecialPages into sections
* Add a new hook EditPageBeforeConflictDiff to allow extensions like FCKeditor
  to modify the output for edit conflicts
* Add class="nested" for <fieldset>s so fieldsets inside fieldsets get
  a slightly less huge margin and padding
* (bug 13527) Use sitemaps.org format 0.9 instead of a Google-specific format
* Allow \C and \Q as TeX commands to match \R, \N, \Z
* On Special:UserRights, when you can add a group you can't remove or remove
  one you can't add, a notice is printed to warn you
* (bug 12698) Create PAGESIZE parser function, to return the size of a page
* Allow the "log in / create account" link in the toolbar to have different
  text from Special:UserLogin title (new message 'nav-login-createaccount')
* Say "log in / create account" if an anonymous user can create an account,
  otherwise just "log in", consistently across skins
* Special:Shortpages and Special:Longpages now returns pages in all content
  namespaces, not just NS_MAIN.
* (bug 889) Improve conflict-handling between shared upload repository
  and local one
* Update documentation links in auto-generated LocalSettings.php
* (bug 13584) The new hook SkinTemplateToolboxEnd was added.
* (bug 709) Cannot rename/move images and other media files [EXPERIMENTAL]
* Custom rollback summaries now accept the same arguments as the default message
* (bug 12542) Added hooks for expansion of Special:Listusers
* Drop-down AJAX search suggestions (turn on $wgEnableMWSuggest)
* More relevant search snippets (turn on $wgAdvancedSearchHighlighting)
* (bug 13950) Allow users to watch the user/talk pages of users they block.
* (bug 13970) Allow MonoBook-based skins to specify their own print stylesheet
* Show image links on Special:Whatlinkshere
* Use rel="start", "prev", "next" appropriately on Pager-based pages
* Add support for SQLite
* AutoAuthenticate hook renamed to UserLoadFromSession
* (bug 13232) importScript(), importStylesheet() funcs available to custom JS
* (bug 13095) Search by first letters or digits in [[Special:Categories]]
* Users moving a page can now move all subpages automatically as well
* (bug 14259) Localisation message for upload button on Special:Import is now
  'import-upload' instead of 'upload'
* Add information about user group membership to Special:Preferences
* (bug 14146) Wrap usage section on imagepages into <div>s.
* New layout for Special:Specialpages. Restricted pages are marked but not separated
  from other pages in their group.
* (bug 14263) Show a diff of the revert on rollback notification page.
* (bug 13434) Show a warning when hash identical files exist
* Sidebar is now cached for all languages
* The User class now contains a public function called isActiveEditor. Figures
  out if a user is active based on at least $wgActiveUserEditCount number of
  edits in the last $wgActiveUserDays days.
* SpecialSearchResults hook now passes results by reference, so they can be
  changed by extensions.
* Add a new hook LinkerMakeExternalLink to allow extensions to modify the output of
  external links.
* (bug 14132) Allow user to disable bot edits from being output to UDP.
* (bug 14328) jsMsg() within Wikibits now accepts a DOM object, not just a string
* (bug 14558) New system message (emailuserfooter) is now added to the footer of
  e-mails sent with Special:Emailuser
* Add support for Hijri (Islamic) calendar
* Add a new hook LinkerMakeExternalImage to allow extensions to modify the output
  of external (hotlinked) images.
* (bug 14604) Introduced the following features for the LanguageConverter:
  Multi-tag support, single conversion flag, remove conversion flag on a single
  page, description flag, variant name, multi-variant fallbacks.
* Add zh-mo and zh-my variants for the zh language
* (bugs 4832, 9481, 12890) Special:Recentchangeslinked now has all options that
  are in Special:Recentchanges
* Allow an $error message to be passed to ArticleDelete hook
* Allow extensions to modify the user creation form by calling addInputItem();
* Add meta generator tag to HTML output
* MediawikiPerformAction hook is now passed the Mediawiki object
* Added blank special page Special:BlankPage for benchmarking, etc.
* Foreign repo file descriptions and thumbnails are now cached.
* (bug 11732) Allow localisation of edit button images
* Allow the search box, toolbox and languages box in the Monobook sidebar to be
  moved around arbitrarily using special sections in [[MediaWiki:Sidebar]]:
  SEARCH, TOOLBOX and LANGUAGES
* Add a new hook NormalizeMessageKey to allow extensions to replace messages before
  the database is potentially queried
* (bug 9736) Redirects on Special:Fewestrevisions are now marked as such.
* New date/time formats in Cs localization according to ČSN and PČP.
* Special:Recentchangeslinked now includes changes to transcluded pages and
  displayed images; also, the "Show changes to pages linked" checkbox now works on
  category pages too, showing all links that are not categorizations
* (bug 4578) Automatically fix redirects broken by a page move

=== Bug fixes in 1.13 ===

* (bug 10677) Add link to the file description page on the shared repository
* (bug 13084) Increase size of source/destination filename fields in upload form
* (bug 13115) rebuildrecentchanges should print the current value of $wgRCMaxAge
* (bug 13140) Show parent categories in category namespace
* (bug 13149) Correctly format 'fileexists' message on Upload page
* Make the default filepageexists message accurate
* (bug 12988) $wgMinimalPasswordLength no longer breaks create user by email
* (bug 13022) Fix upload from URL on PHP 5.0.x
* (bug 13132) Unable to unprotect pages protected with earlier versions of MediaWiki
* (bug 12723) OpenSearch description name now uses more compact language code
  to avoid passing the length limit as often, is customizable per site via
  'opensearch-desc' message.
* (bug 13135) Special:Userrights now passes IDs through form submission
  to allow functionality on not-quite-right usernames
* (bug 12575) Prevent duplicate patrol log entries from being created
* (bug 13174) __HIDDENCAT__ now applies only to category pages
* (bug 13031) Add links to user pages in e-mail form
* (bug 13147) Description for categoriespagetext (used in Special:Categories) reworded
* (bug 11561) Fix fatal error when calling action=revert to non-image page
* (bug 12430) Fix call to private method LinkFilter::makeRegex fatal error in
  maintenance/cleanupSpam.php
* All skins should have the "mediawiki" class on the body element
* (bug 13019) Message cache for some extensions not loaded at time of editing
* (bug 13247) Prettified ISBN links
* maintenance/refreshLinks.php did not fix page_id 1 with the --new-only option
* (bug 13110) Don't show "Permission error" page if the edit is already rolled
  back when using rollback
* (bug 13012) Use content messages for block options when generating the
  recentchanges entry
* (bug 13274) Change links for messages to ucfirst
* (bug 13273) Un-hardcode some punctuation (add new messages colon-separator,
  autocomment-prefix)
* Parse MediaWiki message translations with a correct language setting on preview
* (bug 13281) Treat X-Forwarded-For, Client-ip and User-Agent headers as
  case-insensitive names.
* Adding the fix for lists in RTL wikis to more skins, and fixing the image toc
* (bug 8157) Remove redirects from Special:Unusedtemplates. Patch by WebBoy.
* (bug 10721) Duplicate section anchors with differing case now disambiguated
  for Internet Explorer's sake and standards compliance
* (bug 13298) Tighter limits on Special:Newpages limits when embedding
* Email subject in content language instead of sending user's UI language
* (bug 13251) Allow maintenance rebuild scripts to work with Postgres
* (bug 2084) Fixed incorrect regex to match redirects
* (bug 3131) Manually-specified upload destination filename is no longer
  overwritten by browsing for a file after you wrote it.
* (bug 7251) Sidebars generated by MediaWiki:Sidebar now have the class
  'generated-sidebar'.
* (bug 13265) Media handler is missing 'image/x-bmp'
* (bug 13407) MediaWiki:Powersearch is used in two places
* (bug 13403) Fix cache invalidation of history pages when old revisions change
* (bug 11563) Deprecated SearchMySQL4 class; merged code to SearchMySQL
* (bug 12801) Fix link in subtitle message in AJAX search
* (bug 13428) Fix regression in protection form layout HTML validity
* (bug 9403) Sanitize newlines from search term input
* (bug 13429) Separate date and time in message sp-newimages-showfrom
* (bug 13137) Allow setting 'editprotected' right separately from 'protect',
  so groups may optionally edit protected pages without having 'protect' perms
* Disallow deletion of big pages by means of moving a page to its title and
  using the "delete and move" option.
* (bug 13466, 13632) White space differences not shown in diffs
* (bug 1953) Search form now honors namespace selections more reliably
* (bug 12294) Namespace class renamed to MWNamespace for PHP 5.3 compatibility
* PHP 5.3 compatibility fix for wfRunHooks() called with no parameters
* (bug 6447) Trackbacks now work with transactional tables, if enabled
* (bug 6892, 7147) Trackback error handling, optional fields more robust
* (bug 6813) Don't break HTML validator when using trackbacks
* Fix for size checks on SVG images with global 'stroke-width' attribute
* (bug 11874) Inline CSS with !important no longer borken
* (bug 1600) Strip extra == section markup == in new-comment field
* (bug 11325) Wrapped page titles in MonoBook skin spaced more nicely
* (bug 12077) Fix HTML nesting for TOC
* (bug 344) Purge cache for talk/article pages when deleting the other tab
* (bug 13436) Treat image captions correctly when they include option keywords
  (like ending with "px" or starting with "upright")
* Trackback display formatting fixed
* Don't die when single-element arrays are passed to SQL query constructors
  that have an array index other than 0
* (bug 13522) Fix fatal error in Parser::extractTagsAndParams
* (bug 13532) Use proper timestamp call when reverting images
* (bug 13543) Updated FAQ link in the installer sidebar
* (bug 13540) Date format in confirmation e-mail now matches message language
* (bug 13554) PHP Notice in old pre-processor when list item is empty.
* (bug 13556) Don't show a blank form if no image is attached in Special:Upload
* (bug 13576) maintenance/rebuildrecentchanges.php fails
* (bug 13441) Allow Special:Recentchanges to show bots only
* (bug 13431) Show true message source in Special:Allmessages&ot=php / xml
* (bug 13463) Login successful page doesn't use user's preferred interface language
* (bug 13630) Fixed warnings for pass by reference at call time in
  Special:Revisiondelete when generating the log entry.
* (bug 12064) BeforePageDisplay hook is now called for all skins
* (bug 13624) Fix regression with manual thumb= parameter on images
* (bug 11039) Add missing labels on protection form
* (bug 13458) Preview/edit toolbar spacing now works consistently
* (bug 13433) Fix action=render on Image: pages
* (bug 13678) Fix CSS validation for Monobook
* (bug 13684) Links in Special:ListGroupRights should be in content language
* (bug 13690) Fix PHP notice on accessing some URLs
* Hide (undo) link if user isn't able to edit page
* Invalidate cache of pages that includes images via redirects on upload
* (bug 13705) Don't show rollback link in page history on incorrect revisions
* (bug 13708) Don't set "Search results" title when loading Special:Search
  without query
* (bug 13736) Don't show MediaWiki:Anontalkpagetext on non-existant IP addresses
* (bug 13728) Don't trim initial whitespace during section edits
* (bug 13727) Don't delete log entries from recentchanges on page deletion
* (bug 13752) Redirects to sections now work again
* (bug 13725) Upload form watch checkbox state set correctly with wpDestFile
* (bug 13756) Don't show the form and navigation links of Special:Newpages if
  the page is included
* When hiding things on WhatLinksHere, generated URLs should hide them too
* Properly escape search terms with regex chars so they appear highlighted in
  search results
* (bug 13768) pt_title field encoding fixed
* Do not display empty columns on Special:UserRights if all groups are
  changeable or all unchangeable
* Fix fatal error on calling PAGESINCATEGORY with invalid category name
* (bug 13793) Special:Whatlinkshere filters wrong - after paginating instead of before
* (bug 13796) Show links to parent pages even if some of them are missing
* (bug 13816) Filter by main namespace doesn't work on WhatLinksHere
* (bug 13822) Fatal error on some pages when calculating subpage subtitle
* (bug 13824) AJAX search suggestion now works with non-SkinTemplate skins
* Added 'application/x-dia-diagram' MediaWiki's known MIME types
* (bug 13866) skins/common/shared.css - invalid attribute fixing
* Hide edit section links on Special:Undelete
* (bug 13860) Fix "Justify paragraphs" option for Modern skin
* (bug 13168) accessibility links in Modern skin link to wrong anchor id
* (bug 13185) No line break after 'subpages' class in Modern skin
* (bug 13583) No "poweredby" in Modern skin
* (bug 13880) "Printable" link in Modern skin now formats as print mode
* (bug 13885) Bump default $wgSVGMaxSize from 1024 to 2048 pixels
* (bug 13891) Show categories box even if all categories are hidden and user has
  "show hidden categories" option on
* (bug 13915) Undefined variable $wltsfield in includes/SpecialWatchlist.php
* (bug 13913) Special:Whatlinkshere now has correct HTML markup
* (bug 13905) Blacklist Mac IE from HttpOnly cookies; it eats them sometimes
* (bug 13922) Fix bad HTML on empty Special:Prefixindex and Special:Allpages
* (bug 13924) Fix bad HTML on power search form
* (bug 13820) Fix updater for rev_parent_id population
* (bug 13925) Fix bad HTML on search results list
* (bug 13934) Fixing the link to GNU General Public License Version 2
* Show correct accesskey prefix for Firefox 3 beta (Alt-Shift-, not Alt-)
* (bug 13949) Special:PrefixIndex/AllPages paging links contain invalid XML
* (bug 13770) Use Preprocessor_Hash by default to avoid missing DOM module errors
* (bug 13982) Disable ccmeonemails preference when user-to-user mails disabled
* (bug 13615) Update case mappings and normalization to Unicode 5.1.0
  Note that case mappings will only be used if mbstring extension is not present.
* (bug 14044) Don't increment page view counters on views from bot users
* (bug 14042) Calling Database::limitResult() misplaced the comment in the log file
* (bug 14047) Fix regression in installer which hid DB-specific options
  Also makes SQLite path configurable in the installer.
* (bug 13546) Follow image redirects on image page
* (bug 12644) Template list on edit page now sorted on preview
* (bug 14058) Support pipe trick for namespaces and interwikis with "-"
* Message name filter on Special:Allmessages now case-insensitive
* (bug 13943) Fix image redirect behavior on image pages
* (bug 14093) Do 'sysop' => 'protect' magic in Title::isValidMoveOperation
* (bug 14063) Power search form missing <label> for redirects check
* (bug 14111) Similar filename warning links now lead to correct page
* (bug 14082) Fix for complex text input vs AJAX suggestions on some browsers
* (bug 13693) Categories sometimes claim to have a negative number of members
* (bug 1701) Korean Hangul syllables now broken down properly in Category lists
  even if the wiki's overall content language is not Korean
* (bug 12773) addOnloadHook() now calls functions immediately when scripts are
  loaded after the primary page completion, instead of dropping them
* (bug 14199) Fix deletion form for image redirect pages
* (bug 14220) Disabling $wgCheckFileExtensions now works without also
  disabling $wgStrictFileExtensions
* (bug 14241) Pages can no longer be protected to levels you are not in
* (bug 14296) Fix local name of ang: (Anglo-Saxon)
* (bug 4871) Hardcoded superscript in time zone preferences moved to message
* (bug 6957) E-mail confirmation links now using English special page name
  for better compatibility and keeping the links shorter. Avoids problem
  with corrupt links in Gmail on IE 6.
* (bug 14273) Fix for HTTP Accept header parsing with spaces as from Konqueror
* (bug 14312) Update LanguageKaa.php for handling transform issues with i to İ
  and I to ı
* (bug 13826) MediaWiki:Defaultns accepts Wikicode
* (bug 14324) Creating an account is again possible with $wgEmailConfirmToEdit
  set to true
* (bug 13034) Interwiki pages can now be reached using Go search button
* (bug 14362) Change interwiki names of Erzya and Moksha Wikipedias
* (bug 14370) When a grouppage-x message does not exist the entry on the
  ListGroupRights special page now links to the project namespace page for it,
  not the main namespace page.
* (bug 11659) Urldecode image names in galleries
* (bug 14258, 14368) Fix for subpage renames in replication environments
* (bug 14367) Failed block no longer adds phantom watchlist entry
* (bug 14385) "Move subpages" option no longer tries to move to invalid titles
* (bug 14386) Fix subpage namespace oddity when moving a talk page
* (bug 11771) Signup form now not shown if in read-only mode.
* (bug 12859) $wgRateLimitsExcludedGroups has been deprecated in favor of
  $wgGroupPermissions[]['noratelimit'].
* (Bug 13828) Split parameter $1 of MediaWiki:Missingarticle into $1 (=title)
  and $2 (=revision numbers)
* (bug 14401) Fix Safari access key tooltips for Windows and >3.1 Mac versions
* (bug 14432) Fix notice regression in Special:Newpages feed mode
* (bug 11951) EditPage::getEditToolbar() is now static.
* (bug 14392) Fix regression breaking table prefix in installer
* (bug 11084) $wgDBprefix replacement for updater SQL will now work for
  extension tables using uppercase letters or digits in their names.
* (bug 12311) Fix regression with lists at start of undeletion preview
* (bug 14496) Fix regression with parseinline on Special:Upload.
* We no longer just give up on a missing upload base directory; it's now
  created automatically if we have sufficient permissions!
* (bug 14479) MediaWiki:upload-maxfilesize should have a div id wrapper
* (bug 14497) Throw visible errors in installer scripts when SQL files
  fail due to database permission or other error
* (bug 14500) Site feed (Recentchanges) no longer shows up on the actual
  recent changes page.
* (bug 14511) MediaWiki:Delete-legend is no longer double escaped
* Generate correct section anchors for numeric headers
* (bug 14520) Don't load nonexistent CSS files for Chick/Myskin/Simple skins
* (bug 14551) Cancel upload no longer automatically suppresses warnings
* (bug 13878) Deprecate Article::getDB() in favor of direct wfGetDB() calls
* (bug 4977) Fix for possible squid purging errors when using HTTP purges
  and multiple servers
* (bug 14572) Redirects listed on file links on image pages no longer redirect.
* (bug 14537) Change interwiki name for Old Church Slavonic (cu)
* (bug 14583) Fix regression in recent changes "limit to certain categories."
* (bug 14515) HTML nesting cleanup on edit form
* (bug 14647) Removed unused 'townBox' CSS classes
* (bug 14687) OutputPage::addStyle() now adds type="text/css" like it should.
* OpenSearch cleanup; Firefox now sends you to the search page for empty
  searches instead of the domain root (which may not even be a wiki).
* (bug 3481) Pages moved shortly after creation are shown at their new title
  on Special:Newpages.
* (bug 12716) Trying to unprotect a title that isn't protected no longer
  generates a log entry.
* (bug 14088) Excessively long block expiry times are rejected as invalid,
  keeps the log page from being distorted.
* (bug 14708) Emulate INSERT...IGNORE with standard SQL for Postgres backend.
* (bug 14646) Fix some double-escaping of HTML in feed output
* (bug 14709) Fix login success message formatting when using cookie check
* (bug 14710) Remove "donate" link from default sidebar
* (bug 14745) Image moving works on sites that transform thumbnails via 404
* (bug 2186) Document.write() in wikibits caused failures when using
  application/xhtml+xml. The calls to this have been removed.
* (bug 14764) Fix regression in from Article::lastModified(), failed to work
  on non-mySQL schemas.
* (bug 14763) Child classes of Database (DatabasePostgres and DatabaseOracle)
  had stict standards issues with setFakeSlaveLag() and setFakeMaster().
* (bug 451) Improve the phrase mappings of the Chinese converter arrays.
* (bug 12487) Rights log is not fully internationalized
* (bug 10837) Language variants no longer override other languages than base
* (bug 14778) 'limit' parameter now applies to history feeds as well as
  history pages
* (bug 14845) Bug in prefs javascript: Calling an array item without checking
  its existance.
* Accesskeys for minor edit/watch checkboxes on edit now work in Firefox 3
* (bug 12384) Comments in maintenance/*php
* (bug 12441) ./maintenance/generateSitemap.php fix -fspath requiring
  a trailing slash.
* (bug 12568) configuration script now produce valid XHTML.
* The accesskey to edit a page is now disabled when editing the page, to pre-
  vent conflicts with Safari shortcuts.

=== API changes in 1.13 ===

* Fixing main page display in meta=siteinfo
* (bug 13128) Added patrolled flag to list=recentchanges
* Implemented {bl,ei,iu}redirect (lists links through redirects as well)
* (bug 13154) Introduced subpages flag to meta=siteinfo&siprop=namespaces
* (bug 13157) Added ucuserprefix parameter to list=usercontibs
* (bug 12394) Added rctitles parameter to list=recentchanges, making rcid
  retrieval easier
* (bug 13218) Fix inclusion of " character in hyperlinks
* Added watch and unwatch parameters to action=delete and action=move
* Added action=edit
* (bug 11401) Added xmldoublequote to xml formatter
* Added rvsection parameter to prop=revisions to allow fetching the content of
  a certain section only
* Introduced list=allimages
* (bug 13371) Build page set from image hashes
* Mark non-existent messages in meta=allmessages as missing
* (bug 13390) One invalid title no longer kills an entire API query
* (bug 13419) Fix gblredirect so it actually works
* (bug 13418) Disable eiredirect because it's useless
* (bug 13395) list=allcategories should use category table
* (bug 13442) Missing pages in prop=langlinks and prop=extlinks are now
  handled properly.
* (bug 13444) Add description to list=watchlist
* (bug 13482) Disabled search types handled properly
* Added inprop=talkid,subjectid to prop=info
* Added help text message that specifies whether a module is POST-only
* Added createonly parameter to action=edit
* Replaced $wgAPIUCUserPrefixMinLength by the more generic $wgAPIMaxDBRows
* (bug 11719) Remove trailing blanks in YAML output.
* (bug 13541) Added siprop=specialpagealiases to meta=siteinfo
* Added fallback8bitEncoding and readonly fields to
  meta=siteinfo&siprop=general output
* (bug 13544) Added prop=revid to action=parse
* (bug 13603) Added siprop=usergroups to meta=siteinfo
* Cleaned up redirect resolution
* Added possibility to obtain all external links through list=exturlusage
* (bug 13606) Added archivename to iiprop
* (bug 11633) Explicitly convert redirect titles to strings due to PHP's
  very weak typing on array keys.
* (bug 12136) Extend allowed characters in JSON callback to ][.'"_A-Za-z0-9
* (bug 11673) Return error 'unknown_action' in specified format
* (bug 13618) Added rcprop=redirect and rcshow=redirect to list=recentchanges
* (bug 13544) Added oldid parameter to action=parse to allow for parsing of old
  revisions
* (bug 13718) Return the proper continue parameter for cmsort=timestamp
* action=login now returns the correct waiting time in the details property
* (bug 13792) Broken titles are now silently skipped in search results.
* (bug 13819) exturlusage paging skipped an item
* Fixed handling of usernames containing spaces in list=block
* (bug 13836) Fixed fatal errors resulting from combining iiprop=metadata with
  format=xml
* (bug 13735) Added prop=categoryinfo module
* (bug 13945) Retrieve cascading protection sources via inprop=protection
* (bug 13965) Hardcoded 51 limit on titles is too limiting
* (bug 13993) apfrom doesn't work with apdir=descending
* (bug 14018) Introduced alcontinue to list=alllinks to improve paging
* (bug 14013) Added rcshow=patrolled to list=recentchanges
* (bug 14028) Added language attribute to interwiki map in meta=siteinfo
* (bug 14022) Added usprop=registration and auprop=blockinfo
* (bug 14021) Removed titles= support from list=backlinks (has been obsolete
  for ages)
* (bug 13829) Expose parse tree via action=expandtemplates
* (bug 13606) Allow deletion of images
* Added iiprop=mime and aiprop=metadata
* Handled unrecognized values for parameters more gracefully
* Handled requesting disallowed tokens more gracefully
* (bug 14140) URL-encoded page titles are now decoded in edit summaries
* (bug 14243) Only accept post requests in action=edit; patch by HardDisk
* action=block now returns an ISO8601 timestamp, like all other modules do
* Added md5 parameter to action=edit
* (bug 14335) Logging in to unified account using API not possible
* Added action=emailuser to send an email to a user
* (bug 14471) Use HTMLTidy and generate limit report in action=parse
* (bug 14459) Added prependtext and appendtext parameters to action=edit
* (bug 14526) Unescaped SQL in list=backlinks
* Added 'hidden' flag to list=allcategories and prop=categoryinfo output
* Added nocreate parameter to action=edit
* (bug 14402) Added maxage and smaxage parameters to api.php
* Added bkip parameter to list=blocks
* (bug 14651) apprefix and similar parameters are now canonicalized
* Added clprop=timestamp to prop=categories
* (bug 14678) API errors now respects $wgShowExceptionDetails and
  $wgShowSQLErrors
* (bug 14723) Added time zone and writing direction to meta=siteinfo
* Added APIQueryInfoTokens and APIQueryRevisionsTokens hooks so extensions
  can add their own tokens
* Added block and unblock tokens to prop=info as well
* Added paging (limit and continue parameters) to
  prop={links,templatelinks,langlinks,extlinks,categories,images}
* Added flag "top" to list=usercontribs if the user is the last contributor to
  the page
* list=exturlusage in "list all links" mode can now filter by protocol



== MediaWiki 1.12 ==

This is the Winter 2007 quarterly release.

MediaWiki is now using a "continuous integration" development model with
quarterly snapshot releases. The latest development code is always kept
"ready to run", and in fact runs our own sites on Wikipedia.

Release branches will continue to receive security updates for about a year
from first release, but nonessential bugfixes and feature developments
will be made on the development trunk and appear in the next quarterly release.

Those wishing to use the latest code instead of a branch release can obtain
it from source control: http://www.mediawiki.org/wiki/Download_from_SVN

=== Configuration changes in 1.12 ===
* Marking edits as bot edits with Special:Contributions?bot=1 now requires the
  markbotedit permission, rather than the rollback permission previously used.
  This permission is assigned by default to the sysop group.
* MediaWiki now checks if serialized files are out of date. New configuration
  variable $wgCheckSerialized can be set to false to enable old behavior (i.e.
  to not check and assume they are always up to date)
* The rollback permission can now be rate-limited using the normal mechanism.
* New configuration variable $wgExtraLanguageNames
* Behavior of $wgAddGroups and $wgRemoveGroups changed. New behavior:
* * Granting the userrights privilege allows arbitrary changing of rights.
* * Without the userrights privilege, a user will be able to add and/or
     remove the groups specified in $wgAddGroups and $wgRemoveGroups for
     any groups they are in.
* New permission userrights-interwiki for changing user rights on foreign wikis.
* $wgImplicitGroups for groups that are hidden from Special:Listusers, etc.
* $wgAutopromote: automatically promote users who match specified criteria
* $wgGroupsAddToSelf, $wgGroupsRemoveFromSelf: allow users to add or remove
  themselves from specified groups via Special:Userrights.
* When $wgUseTidy has been enabled, PHP's Tidy module is now used if it is
  present, in preference to an external Tidy executable which may or may not
  be present. To force use of external Tidy even when the PHP module is
  available, set $wgTidyInternal to false.


=== New features in 1.12 ===
* (bug 10735) Add a warning for non-descriptive filenames at Special:Upload
* Add {{filepath:}} parser function to get full path to an uploaded file,
  complementing {{fullurl:}} for pages.
* (bug 11136) If using Postgres, search path is explicitly set if wgDBmwschema
  is not set to 'mediawiki', allowing multiple mediawiki instances per user.
* (bug 11151) Add descriptive <title> to revision history page
* (bug 5412) Add feed links for the site to all pages
* (bug 11353) Add ability to retrieve raw section content via action=raw
* (bug 6909) Show relevant deletion log lines when uploading a previously
  deleted file
* On SkinTemplate based skins (like MonoBook), omit confusing "edit"/"view
  source" tab entirely if the page doesn't exist and the user isn't allowed to
  create it
* Clarify instructions given when an exception is thrown
* AuthPlugin added strictUserAuth() method to allow per-user override
  of the strict() authentication behavior.
* (bug 7872) Deleted revisions can now be viewed as diffs showing changes
  against the previous revision, whether currently deleted or live.
* Added tooltips for the "Go" and "Search" buttons
* (bug 11649) Show input form when Special:Whatlinkshere has no parameters
* isValidEmailAddr hook added to User method of that name, to allow, e.g., re-
  stricting e-mail addresses to a specific domain
* Removed "Clear" link in watchlist editor tools, as people were afraid to
  click it. Existing clear links will fall back to the raw editor, which is
  very easy to clear your watchlist with.
* (bug 1405) Add wgUseNPPatrol option to control patroling for new articles
  on Special:Newpages
* LogLine hook added to allow formatting custom entries in Special:Log.
* Support for Iranian calendar
* (bug 1401) Allow hiding logged-in users, bots and patrolled pages on
  Special:Newpages
* ChangesListInsertArticleLink hook added for adding extra article info to RC.
* MediaWikiPerformAction hook added for diverting control after the main
  globals have been set up but before any actions have been taken.
* BeforeWatchlist hook added for filtering or replacing watchlist.
* SkinTemplateTabAction hook added for altering the properties of tab links.
* OutputPage::getRedirect public method added.
* (bug 11848, 12506) Allow URL parameters 'section', 'editintro' and 'preload'
  in Special:Mypage and Special:Mytalk
* Add ot=raw to Special:Allmessages
* Support for Hebrew calendar
* Support for Hebrew numerals in dates and times
* (bug 11315) Signatures can be configured in [[MediaWiki:Signature]] and
  [[MediaWiki:Signature-anon]]
* Signatures for anonymous users link to Special:Contributions page rather than
  user page
* Added --override switch for disabled pages in updateSpecialPages.php
* Provide a unique message (ipb_blocked_as_range) if unblock of a single IP
  fails
  because it is part of a blocked range.
* (bug 3973) Use a separate message for the email content when an account is
  created by another user
* dumpTextPass.php can spawn fetchText.php as a subprocess, which should restart
  cleanly if database connections fail unpleasantly.
* (bug 12028) Add Special:Listbots as shortcut for Special:Listusers/bot
* (bug 9633) Add a predefined list of delete reasons to the deletion form
* Show a warning message when creating/editing a user (talk) page but the user
  does not exists
* (bug 8396) Ignore out-of-date serialised message caches
* (bug 12195) Undeleting pages now requires 'undelete' permission
* (bug 11810) Localize displayed semicolons
* (bug 11657) Support for Thai solar calendar
* (bug 943) RSS feed for Recentchangeslinked
* Introduced AbortMove hook
* (bug 2919) Protection of nonexistent pages with regular protection interface.
* Special:Upload now lists permitted/prohibited file extensions.
* Split ambiguous filetype-badtype message into two new messages,
  filetype-unwanted-type and filetype-banned-type.
* Added link to the old title in Special:Movepage
* On Special:Movepage, errors are now more noticeable.
* It is now possible to change rights on other local wikis without the MakeSysop
  extension
* Add HTML ID's mw-read-only-warning and mw-anon-edit-warning to warnings when
  editing to allow CSS styling.
* Parser now returns list of sections
* When a user is prohibited from creating a page, a title of "View source"
  makes no sense, and there should be no "Return to [[Page]]" link.
* (bug 12486) Protected titles now give a warning for privileged editors.
* (bug 9939) Special:Search now sets focus to search input box when no existing
  search is active
* For Special:Userrights, use GET instead of POST to search for users.
* Allow subpage syntax for Special:Userrights, i.e., Special:Userrights/Name.
* When submitting changes on Special:Userrights, show the full form again, not
  just the search box.
* Added exception hooks
* (bug 12574) Allow bots to specify whether an edit should be marked as a bot
  edit, via the parameter 'bot'. (Default: '1')
* (bug 12536) User should be able to get MediaWiki version from any page
* (bug 12622) A JavaScript constant to declare whether api.php is available
* Add caching to the AJAX search
* Add APCOND_INGROUPS
* Add DBA caching to installer
* (bug 12585) Added a bunch of parameters to the revertpage message
* Support redirects in image namespace
* (bug 10049) Prefix index search and namespaces in Special:Withoutinterwiki
* (bug 12668) Support for custom iPhone bookmark icon via $wgAppleTouchIcon
* Add option to include templates in Special:Export.
* (bug 12655) Added $wgUserEmailUseReplyTo config option to put sender
  address in Reply-To instead of From for user-to-user emails.
  This protects against SPF problems and privacy-leaking bounce messages
  when using mailers that set the envelope sender to the From header value.
* (bug 11897) Add alias [[Special:CreateAccount]] & [[Special:Userlogin/signup]]
  for Special:Userlogin?type=signup
* (bug 12214) Add a predefined list of delete reasons to the file deletion form
* Merged backends for OpenSearch suggestions and AJAX search.
  Both now accept namespace prefixes, handle 'Media:' and 'Special:' pages,
  and reject interwiki prefixes. PrefixSearch class centralizes this code,
  and the backend part can be overridden by the PrefixSearchBackend hook.
* (bug 10365) Localization of Special:Version
* When installing using Postgres, the Pl/Pgsql language is now checked for
  and installed when at the superuser level.
* The default robot policy for the entire wiki is now configurable via the
  $wgDefaultRobotPolicy setting.
* (bug 12239) Use different separators for autocomments
* (bug 12857) Patrol link on new pages should clear floats
* (bug 12968) Render redirect wikilinks in a redirect class for customization
  via user/site CSS.
* EditPageBeforeEditButtons hook added for altering the edit buttons below the edit box

=== Bug fixes in 1.12 ===

* Subpages are now indexed for searching properly when using PostgreSQL
* (bug 3846) Suppress warnings from, e.g. open_basedir when scanning for
  ImageMagick, diff3 et al. during installation [patch by Jan Reininghaus]
* (bug 7027) Shift handling of deletion permissions-checking to
  getUserPermissionsErrors.
* Login and signup forms are now more correct for right-to-left languages.
* (bug 5387) Block log items on RecentChanges don't make use of possible
  translations
* (bug 11211) Pass, as a parameter to the protectedpagetext interface
  message, the level of protection.
* (bug 9611) Supply the blocker and reason for the cantcreateaccounttext
  message.
* (bug 8759) Fixed bug where rollback was allowed on protected pages for wikis
  where rollback is given to non-sysops.
* (bug 8834) Split off permission for editing user JavaScript and CSS from
  editinterface to a new permission key editusercssjs.
* (bug 11266) Set fallback language for Fulfulde (ff) to French
* (bug 11179) Include image version deletion comment in public log
* Fixed notice when accessing special page without read permission and whitelist
  is not defined
* (bug 9252) Fix for tidy funkiness when using editintro mode
* (bug 4021) Fix for MySQL wildcard search
* (bug 10699) Fix for MySQL phrase search
* (bug 11321) Fix width of gallerybox when option "width=xxx" is used
* (bug 7890) Special:BrokenRedirects links deleted redirects to a non-existent
  page
* Fix initial statistics when installing: add correct values
* (bug 11342) Fix several 'returnto' links in permissions/error pages which
  linked to the main page instead of targetted page
* Strike the link to the redirect rather than using an asterisk in
  Special:Listredirects
* (bug 11355) Fix false positives in Safe Mode and other config detection
  when boolean settings are disabled with 'Off' via php_admin_value/php_value
* (bug 11292) Fixed unserialize errors with Postgres by creating special Blob
  object.
* (bug 11363) Make all metadata fields bytea when using Postgres.
* (bug 11331) Add buildConcat() and use CASE not IF for DB compatibility. Make
  oldimage cascade delete via image table for Postgres, change fa_storage_key
  TEXT.
* (bug 11438) Live Preview chops returned text
* Show the right message on account creation when the user is blocked
* (bug 11450) Fix creation of objectcache table on upgrade
* Fix namespace selection after submit of Special:Newpages
* Make input form of Special:Newpages nicer for RTL wikis
* (bug 11462) Fix typo in LanguageGetSpecialPageAliases hook name
* (bug 11474) Fix unintentional fall-through in math error handling
* (bug 11478) Fix undefined method call in file deletion interface
* (bug 278) Search results no longer highlight incorrect partial word matches
* Compatibility with incorrectly detected old-style DJVU mime types
* (bug 11560) Fix broken HTML output from weird link nesting in edit comments.
  Nested links (as in image caption text) still don't work _right_ but they're
  less wrong
* (bug 9718) Remove unnecessary css from main.css causing spacing issues on
  some browsers.
* (bug 11574) Add an interface message loginstart, which, similarly to loginend,
  appears just before the login form. Patch by MinuteElectron.
* Do not cache category pages if using 'from' or 'until'
* Created new hook getUserPermissionsErrors, to go with userCan changes.
* Diff pages did not properly display css/js pages.
* (bug 11620) Add call to User::isValidEmailAddr during accout creation.
* (bug 11629) If $wgEmailConfirmToEdit is true, require people to supply an
  email address when registering.
* (bug 11612) Days to show in recent changes cannot be larger than 7
* (bug 11131) Change filearchive width/height columns to int for Postgres
* Support plural in undeleted{revisions,revisions-files,files}
* (bug 11343) If the database is read-only, ensure that undelete fails.
* (bug 11690) Show revert link for page moves in Special:Log to allowed users
  only
* Initial-lowercase prefix checks in namespaceDupes.php now actually work.
* Fix regression in LinkBatch.php breaking PHP 5.0
* (bug 11452) wfMsgExt uses sometimes wrong language object for parsing magic
  words when called with options ''parsemag'' or ''content''.
* (bug 11727) Support plural in 'historysize' message
* (bug 11744) Incorrect return value from Title::getParentCategories()
* (bug 11762) Fix native language name of Akan (ak)
* (bug 11722) Fix inconsistent case in unprotect tabs
* (bug 11795) Be more paranoid about confirming accept-encoding header is
  present
* (bug 11809) Use formatNum() for more numbers
* (bug 11818) Fix native language name of Inuktitut (iu)
* Remove all commas when parsing float numbers in sorted tables
* Limit text field of deletion, protection and user rights changes reasons to
  255 characters (already restricted in the database)
* In the deletion default reasons, calculate how much text to get from the
  article text, rather than getting 150 characters (which may be too much)
* Add two messages for Special:Blockme which were used but undefined
* (bug 11921) Support plural in message number_of_watching_users_pageview
* If an IP address is blocked as part of a rangeblock, attempting to unblock
  the single IP should not unblock the entire range.
* (bug 6695) Fix native language name of Southern Sotho (Sesotho) (st)
* Make action=render follow redirects by default
* If restricted read access was enabled, whitelist didn't work with special
  pages which had spaces in theirs names
* If restricted read access was enabled, requests for non-existing special pages
  threw an exception
* Feeds for recent changes now provide correct URLs for the change, not just
  the page
* Check for if IP is blocked as part of a range when unblocking (see above bug-
  fix) was faulty. Now fixed.
* Fixed wpReason URL parameter to action=delete.
* Do not force a password for account creation by email
* Ensure that rate-limiting is applied to rollbacks.
* Make a better rate-limiting error message (i.e. a normal MW error,
  rather than an "Internal Server Error").
* Do not present an image bigger than the source when 'frameless' option is used
  (to be consistent with the 'thumb' option now)
* Support {{PLURAL}} for import log
* Make sure that the correct log entries are shown on Special:Userrights even
  for users with special characters in their names
* The number of watching users in watchlists was always reported as 1
* namespaceDupes.php no longer dies when coming across an illegal title
* (bug 12143) Do not show a link to patrol new pages for non existent pages
* (bug 12166) Fix XHTML validity for Special:Emailuser
* (bug 11346) Users who cannot edit a page can now no longer unprotect it.
* (bug 451) Add a generic Traditional / Simplified Chinese conversion table,
  instead of a Traditional conversion with Taiwan variant, and a Simplified
  conversion with China variant.
* (bug 12178) Fix wpReason parameter to action=delete, again.
* Graceful behavior for updateRestrictions.php if a page already has records
  in the page_restrictions matching its old page_restrictions field.
  May help with odd upgrade issues or race condition.
* (bug 11993) Remove contentsub "revision history"
* (bug 11952) Ensure we quote_ident() all schema names as needed
   inside of the DatabasePostgres.php file.
* (bug 12184) Exceptions now sent to stderr instead of stdout for command-line
  scripts, making for cleaner reporting during batch jobs. PHP errors will also
  be redirected in most cases on PHP 5.2.4 and later, switching 'display_errors'
  to 'stderr' at runtime.
* (bug 12148) Text highlight wasn't applied to cleanly deleted and added
  lines in diff output
* (bug 10166) Fix a PHP warning in Language::getMagic
* Only mark rollback edits as minor if the user can normally mark edits minor
* Escape page names in the move successful page (e.g. for pages with two
  apostrophes).
* (bug 12145) Add localized names of kk-variants
* (bug 12259) Localize the numbers in deleted pages on the sysop view
* Set proper page title for successful file deletion
* (bug 11221) Do not show 'Compare selected versions' button for a history page
  with one revision only
* (bug 12267) Set the default date format to Thai solar calender for the Thai
  language
* (bug 10184) Extensions' stylesheets and scripts should be loaded before
  user-customized ones (like Common.css, Common.js)
* (bug 12283) Special:Newpages forgets parameters
* (bug 12031) All namespaces doesn't work in Special:Newpages
* (bug 585) Only create searchindex replica table for parser tests if db is
  MySQL
* Allow --record option if parserTests.php to work when using Postgres
* (bug 12296) Simplify cache epoch in default LocalSettings.php
* (bug 12346) XML fix when body double-click and click handlers are present
* Fix regression -- missing feed links in sidebar on Special:Recentchanges
* (bug 12371) Handle more namespace case variants in namespaceDupes.php
* (bug 12380) Bot-friendly EditPage::spamPage
* (bug 8066) Spaces can't be entered in special page aliases
* Hide undo link if user can't edit article
* (bug 12416) Fix password setting for createAndPromote.php
* (bug 3097) Inconsistently usable titles containing HTML character entities
  are now forbidden. A run of cleanupTitles.php will fix up existing pages.
* (bug 12446) Permissions check fix for undelete link
* (bug 12451) AJAX title normalization tweaks
* When a user creating a page is not allowed to either create the page nor edit
  it, all applicable reasons are now shown.
* (bug 11428) Allow $wgScript inside $wgArticlePath when emulating PATH_INFO
  Fixes 'root'-style rewrite configurations
* (bug 12493) Removed hardcoded MAX_FILE_SIZE from Special:Import upload form
* (bug 12489) Special:Userrights listed in restricted section again
* (bug 12553) Fixed invalid XHTML in edit conflict screen
* (bug 12505) Fixed section=0 with action=raw
* (bug 12614) Do not log user rights change that didn't change anything
* (bug 12584) Don't reset cl_timestamp when auto-updating sort key on move
* (bug 12588) Fix selection in namespace selector on Special:Newpages
* Use only default options when generating RSS and Atom syndication links.
  This should help prevent infinite link loops that some software may follow,
  and will generally keep feed behavior cleaner.
* (bug 12608) Unifying the spelling of getDBkey() in the code.
* (bug 12611) Bot flag ignored in recent changes
* (bug 12617) Decimal and thousands separators for Romanian
* (bug 12567) Fix for misformatted read-only messages on edit, protect.
  Also added proper read-only checks to several special pages.
  Have removed read-only checks from the general user permission framework.
* Creating a site with a name containing '#' is no longer permitted, since the
  name will not work (but $wgSiteName is not checked if manually set).
* (bug 12695) Suppress dvips verbiage from web server error log
* (bug 12716) Unprotecting a non-protected page leaves a log entry
* Log username blocks with canonical form of name instead of input form
* (bug 11593, 12719) Fixes for overzealous invocation of thumb.php.
  Non-image handlers and full-size images may now decline it, fixing
  mystery failures when using $wgThumbnailScriptPath.
* (bug 12327) Comma in username no longer disrupts mail headers
* (bug 6436) Localization of Special:Import XML parser Error message(s).
* Security fix for API on MSIE
* (bug 12768) Database query syntax error in maintenance/storage/compressOld.inc
* (bug 12753) Empty captions in MediaWiki:Sidebar result in PHP errors
* (bug 12790) Page protection is not logged when edit-protection is used
  and move-protection is not
* (bug 12793) Fix for restricted namespaces/pages in Special:Export
* Fix for Special:Export so it doesn't ignore the page named '0'
* Don't display rollback link if the user doesn't have all required permissions
* The comment of a time-limited protection now contains the date in the default
  format
* (bug 12880) wfLoadExtensionMessages does not use $fallback from MessagesXx.php
* (bug 12885) Correction for Russian convertPlural function
* (bug 12768) Make DatabasePostgres->hasContraint() schema aware.
* (bug 12735) Truncate usernames in comments using mb_ functions.
* (bug 12892) Poor tab indexing on "delete file" form
* (bug 12660) When creating an account by e-mail, do not send the creator's IP
  address
* (bug 12931) Fix wrong global variable in SpecialVersion
* (bug 12919) Use 'deletedrevision' message as content when deleting an old file
  version
* (bug 12952) Using Nosuchusershort instead of Nosuchuser when account creation
  is disabled
* (bug 12869) Magnify icon alignment should be adjusted using linked CSS
* Fixing message cache updates for MediaWiki messages moves
* (bug 12815) Signature timestamps were always in UTC, even if the timezone code
  in parentheses after them claimed otherwise
* (bug 12732) Fix installer and searching to handle built-in tsearch2 for Postgres.
* (bug 12784) Change "bool" types to smallint to handle Postgres 8.3 strictness.
* (bug 12301) Allow maintenance/findhooks.php to search hooks in multiple directories.
* (bug 7681, 11559) Cookie values no longer override GET and POST variables.
* (bug 5262) Fully-qualified $wgStylePath no longer corrupted on XML feeds
* (bug 3269) Inaccessible titles ending in '/.' or '/..' now forbidden.
* (bug 12935, 12981) Fully-qualify archive URLs in delete, revert messages
* (bug 12938) Fix template expansion and 404 returns for action=raw with section
* (bug 11567) Fix error checking for PEAR::Mail. UserMailer::send() now returns
  true-or-WikiError, which seems to be the calling convention expected by half
  its callers already
* (bug 12846) IE rtl.css issue in RTL wikis special:Preferences when selecting an
  LTR user language
* (bug 13005) DISPLAYTITLE does not work on preview
* (bug 13004) Fix error on Postgres searches that return too many results.

== Parser changes in 1.12 ==

For help with migration to the MediaWiki 1.12 parser, please visit:

http://meta.wikimedia.org/wiki/Migration_to_the_new_preprocessor

The parser pass order has changed from

   * Extension tag strip and render
   * HTML normalisation and security
   * Template expansion
   * Main section...

to

   * Template and extension tag parse to intermediate representation
   * Template expansion and extension rendering
   * HTML normalisation and security
   * Main section...

The main effect of this for the user is that the rules for uncovered syntax
have changed.

Uncovered main-pass syntax, such as HTML tags, are now generally valid, whereas
previously in some cases they were escaped. For example, you could have "<ta" in
one template, and "ble>" in another template, and put them together to make a
valid <table> tag. Previously the result would have been "&lt;table&gt;".

Uncovered preprocessor syntax is generally not recognised. For example, if you
have "{{a" in Template:A and "b}}" in Template:B, then "{{a}}{{b}}" will be
converted to a literal "{{ab}}" rather than the contents of Template:Ab. This
was the case previously in HTML output mode, and is now uniformly the case in
the other modes as well. HTML-style comments uncovered by template expansion
will not be recognised by the preprocessor and hence will not prevent template
expansion within them, but they will be stripped by the following HTML security
pass.

Bug 5678 has been fixed. This has a number of user-visible effects related to
the removal of this double-parse. Please see the wiki page for examples.

Message transformation mode has been removed, and replaced with "preprocess"
mode. This means that some MediaWiki namespace messages may need to be updated,
especially ones which took advantage of the terribly counterintuitive behavior
of the former message mode.

The header identification routines for section edit and for numbering section
edit links have been merged. This removes a significant failure mode and fixes a
whole category of bugs (tracked by bug #4899). Wikitext headings uncovered by
template expansion will still be rendered into a heading tag, and will get an
entry in the TOC, but will not have a section edit link. HTML-style headings
will also not have a section edit link. Valid wikitext headings present in the
template source text will get a template section edit link. This is a major
break from previous behavior, but I believe the effects are almost entirely
beneficial.

The main motivation for making these changes was performance. The new two-pass
preprocessor can skip "dead branches" in template expansion, such as unfollowed
#switch cases and unused defaults for template arguments. This provides a
significant performance improvement in template-heavy test cases taken from
Wikipedia. Parser function hooks can participate in this performance improvement
by using the new SFH_OBJECT_ARGS flag during registration.

The pre-expand include size limit has been removed, since there's no efficient
way to calculate such a figure, and it would now be meaningless for performance
anyway. The "preprocessor node count" takes its place, with a generous default
limit.

The context in which XML-style extension tags are called has changed, so
extensions which make use of the parser state may need compatibility changes.

The new preprocessor syntax has been documented in Backus-Naur Form at:

http://www.mediawiki.org/wiki/Preprocessor_ABNF

The ExpandTemplates extension now has the ability to generate an XML parse
tree from wikitext source. This parse tree corresponds closely to the grammar
documented on that page.

=== API changes in 1.12 ===

Full API documentation is available at http://www.mediawiki.org/wiki/API

* (bug 11275) Enable descending sort in categorymembers
* (bug 11308) Allow the API to output the image metadata
* (bug 11296) Temporary fix for escaping of ampersands inside links in
  pretty-printed
  help document.
* (bug 11405) Expand templates implementation in the API
* (bug 11218) Add option to feedwatchlist to display multiple revisions for each
  page.
* (bug 11404) Provide name of exception caught in error code field of internal
  api error messages.
* (bug 11534) rvendid doesn't work
* Fixed rvlimit of the revisions query to only enforce the lower query limit if
  revision content is requested.
* Include svn revision number (if install is checked-out from svn) in siteinfo
  query.
* (bug 11173) Allow limited wikicode rendering via api.php
* (bug 11572) API should provide interface for expanding templates
* (bug 11569) Login should return the cookie prefix
* (bug 11632) Breaking change: Specify the type of a change in the recentchanges
  list as 'edit', 'new', 'log' instead of 0, 1, 2, respectively.
* Compatibility fix for PHP 5.0.x.
* Add rctype parameter to list=recentchanges that filters by type
* Add apprtype and apprlevel parameters to filter list=allpages by protection
  types and levels
* Add apdir parameter to enable listing all pages from Z to A
* (bug 11721) Use a different title for results than for the help page.
* (bug 11562) Added a user_registration parameter/field to the list=allusers
  query.
* (bug 11588) Preserve document structure for empty dataset in backlinks query.
* Outputting list of all user preferences rather than having to request them by
  name
* (bug 11206) api.php should honor maxlag
* Make prop=info check for restrictions in the old format too.
* Add apihighlimits permission, default for sysops and bots
* Add limit=max to use maximal limit
* Add action=parse to render parser output. Use it instead of action=render
  which has been removed
* Add rvtoken=rollback to prop=revisions
* Add meta=allmessages to get messages from site's messages cache.
* Use bold and italics highlighting only in API help
* Added action={block,delete,move,protect,rollback,unblock,undelete} and
  list={blocks,deletedrevs}
* Fixed sessionid attribute in action=login
* Standardized limits. Revisions and Deletedrevisions formerly using
  200 / 10000, now 500 / 5000, in line with other modules.
* Added list=allcategories module
* (bug 12321) API list=blocks reveals private data
* Fix output of wfSajaxSearch
* (bug 12413) meta=userinfo missing <query> tag
* Add list of sections to action=parse output
* Added action=logout
* Added cascade flag to prop=info&inprop=protections
* Added wlshow parameter to list=watchlist, similar to rcshow
  (list=recentchanges)
* Added support for image thumbnailing to prop=imageinfo
* action={login,block,delete,move,protect,rollback,unblock,undelete} now must be
  POSTed
* prop=imageinfo interface changed: iihistory replaced by iilimit, iistart and
  iiend parameters
* Added amlang parameter to meta=allmessages
* Added apfilterlanglinks parameter to list=allpages, replacing
  query.php?what=nolanglinks
* (bug 12718) Added action=paraminfo module that provides information about API
  modules and their parameters
* Added iiurlwidth and iiurlheight parameters to prop=imageinfo
* Added format=txt and format=dbg, imported from query.php
* Added uiprop=editcount to meta=userinfo
* Added list=users which fetches user information
* Added list=random which fetches a list of random pages
* Added page parameter to action=parse to facilitate parsing of existing pages
* Added uiprop=ratelimits to meta=userinfo
* Added siprop=namespacealiases to meta=siteinfo
* Made multiple values for ucuser possible in list=usercontribs
* (bug 12944) Added cmstart and cmend parameters to list=categorymembers
* Allow queries to have a where range that does not match the range field

== MediaWiki 1.11 ==

This is the Summer 2007 branch release of MediaWiki.

MediaWiki is now using a "continuous integration" development model with
quarterly snapshot releases. The latest development code is always kept
"ready to run", and in fact runs our own sites on Wikipedia.

Release branches will continue to receive security updates for about a year
from first release, but nonessential bugfixes and feature developments
will be made on the development trunk and appear in the next quarterly release.

Those wishing to use the latest code instead of a branch release can obtain
it from source control: http://www.mediawiki.org/wiki/Download_from_SVN

== Configuration changes since 1.10 ==

* $wgThumbUpright - Adjust width of upright images when parameter 'upright' is
  used
* $wgAddGroups, $wgRemoveGroups - Finer control over who can assign which
  usergroups
* $wgEnotifImpersonal, $wgEnotifUseJobQ - Bulk mail options for large sites
* $wgShowHostnames - Expose server host names through the API and HTML comments
* $wgSaveDeletedFiles has been removed, the feature is now enabled unconditionally

== New features since 1.10 ==

* (bug 8868) Separate "blocked" message for autoblocks
* Adding expiry of block to block messages
* Links to redirect pages in categories are wrapped in
  <span class="redirect-in-category"></span>
* Introduced 'ImageOpenShowImageInlineBefore' hook; see docs/hooks.txt for
  more information
* (bug 9628) Show warnings about slave lag on Special:Contributions,
  Special:Watchlist
* (bug 8818) Expose "wpDestFile" as parameter $1 to "uploaddisabledtext"
* Introducing new image keyword 'upright' and corresponding variable
  $wgThumbUpright. This allows better proportional view of upright images
  related to landscape images on a page without nailing the width of upright
  images to a fix value which makes views for anon unproportional and user
  preferences useless
* (bug 6072) Introducing 'border' keyword to the [[Image:]] syntax
* Introducing 'frameless' keyword to [[Image:]] syntax which respects the
  user preferences for image width like 'thumb' but without a frame.
* (bug 7960) Link to "what links here" for each "what links here" entry
* Added support for configuration of an arbitrary number of commons-style
  file repositories.
* Added a Content-Disposition header to thumb.php output
* Improved thumb.php error handling
* Display file history on local image description pages of shared images
* Added $wgArticleRobotPolicies
* (bug 10076) Additional parameter $7 added to MediaWiki:Blockedtext
  containing, the ip, ip range, or username whose block is affecting the
* (bug 7691) Show relevant lines from the deletion log when re-creating a
  previously deleted article
* Added variables 'wgRestrictionEdit' and 'wgRestrictionMove' for JS to header
* (bug 9898) Allow viewing all namespaces in Special:Newpages
* (bug 10139) Introduce 'EditSectionLink' and 'EditSectionLinkForOther' hooks;
  see docs/hooks.txt for details
* (bug 9769) Provide "watch this page" toggle on protection form
* (bug 9886) Provide clear example "stub link" in Special:Preferences
* (bug 10055) Populate email address and real name properties of User objects
  passed to the 'AbortNewAccount' hook
* Show result of Special:Booksources in wiki content language always, it's
  normally better maintained than the generic list from the standard message
  files
* (bug 7997) Allow users to be blocked from using Special:Emailuser
* (bug 8989) Blacklist 'mhtml' and 'mht' files from upload
* (bug 8760) Allow wiki links in "protectexpiry" message
* (bug 5908) Add "DEFAULTSORTKEY" and "DEFAULTCATEGORYSORT" aliases for
  "DEFAULTSORT" magic word
* (bug 10181) Support the XCache object caching mechanism
* (bug 9058) Introduce '--aconf' option for all maintenance scripts, to provide
  a path to the AdminSettings.php file
* (bug 8781) Remind users to check file permissions for LocalSettings.php
  post-installation
* Use shared.css for all skins and oldshared.css in place of common.css for
  pre-Monobook skins.  As always, modifications should go in-wiki to MediaWiki:
  Common.css and MediaWiki:Monobook.css.
* (bug 8869) Introduce Special:Uncategorizedtemplates
* (bug 8734) Different log message when article protection level is changed
* (bug 8458, 10338) Limit custom signature length to $wgMaxSigChars Unicode
  characters
* (bug 10096) Added an ability to query interwiki map table
* On reupload, add a null revision to the image description page
* Group log output by date
* Kurdish interface latin/arabic writing system with transliteration
* Support wiki text in all query page headers
* Add 'Orphanedpages' as an alias to Special:Lonelypages
* (bug 9328) Use "revision-info-current" message in place of "revision-info"
  when viewing the current revision of a page, if available
* (bug 8890) Enable wiki text for "license" message
* Throw a showstopper exception when a hook function fails to return a value.
  Forgetting to give a 'true' return value is a very common error which tends
  to cause hard-to-track-down interactions between extensions.
* Use $wgJobClasses to determine the correct Job to instantiate for a particular
  queued task; allows extensions to introduce custom jobs
* (bug 10326) AJAX-based page watching and unwatching has been cleaned up and
  enabled by default.
* Added option to install to MyISAM
* (bug 9250) Remove hardcoded minimum image name length of three characters
* Fixed DISPLAYTITLE behavior to reject titles which don't normalise to the
  same title as the current page, and enabled per default
* Wrap site CSS and JavaScript in a <pre> tag, like user JS/CSS
* (bug 10196) Add classes and dir="ltr" to the <pre>s on CSS and JS pages (new
  classes: mw-code, mw-css, mw-js)
* (bug 6711) Add $wgAddGroups and $wgRemoveGroups to allow finer control over
  usergroup assignment.
* Introduce 'UserEffectiveGroups' hook; see docs/hooks.txt for more information
* (bug 10387) Detect and handle '.php5' extension environments at install time
* Introduce 'ShowRawCssJs' hook; see docs/hooks.txt for more information
* (bug 10404) Show rights log for the selected user in Special:Userrights
* New javascript for upload page that will show a warning if a file with the
  "destination filename" already exists.
* Add 'editsection-brackets' message to allow localization (or removal) of the
  brackets in the "[edit]" link for sections
* (bug 10437) Move texvc styling to shared.css
* Introduce "raw editing" mode for the watchlist, to allow bulk additions,
  removals, and convenient exporting of watchlist contents
* Show "undo" links in page histories
* Option to jump to specified time period in user contributions
* Improved feedback on "rollback success" page
* Show distinct 'namespaceprotected' message to users when namespace protection
  prevents page editing
* (bug 9936) Per-edit suppression of preview-on-first edit with "preview=no"
* Allow showing a one-off preview on first edit with "preview=yes"
* (bug 9151) Remove timed redirects on "Return to X" pages for accessibility.
* Link to user logs in toolbox when viewing a user page
* (bug 10508) Allow HTML attributes on <gallery>
* (bug 1962) Allow HTML attributes on <math>
* (bug 10530) Introduce optional "sp-contributions-explain" message for
  additional explanation in Special:Contributions
* (bug 10520) Preview licences during upload via AJAX (toggle with
  $wgAjaxLicensePreview)
* New Parser::setTransparentTagHook for parser extension and template
  compatibility
* Introduced 'ContributionsToolLinks' hook; see docs/hooks.txt for more
  information
* Add a message if category is empty
* Add CSS compatibility for Opera 9.5
* Remove largely untested handheld stylesheet, which was causing more trouble
  than good.  Proper handheld support will be added at a future date.  For now,
  display should be acceptable either with CSS turned off or when using a so-
  phisticated handheld browser.
* (bug 3173) Option to offer exported pages as a download, rather than displaying
  inline, as in most browsers
* Pass the user as an argument to 'isValidPassword' hook callbacks; see
  docs/hooks.txt for more information
* Introduce 'UserGetRights' hook; see docs/hooks.txt for more information
* (bug 9595) Pass new Revision to the 'ArticleInsertComplete' and
  'ArticleSaveComplete' hooks; see docs/hooks.txt for more information
* (bug 9575) Accept upload description from GET parameters
* Skip the difference engine cache when 'action=purge' is used while requesting
  a difference page, to allow refreshing the cache in case of errors
* (bug 10701) Link to Special:Listusers in default Special:Statistics messages
* Improved file history presentation
* (bug 10739) Users can now enter comments when reverting files
* Improved handling of permissions errors
* (bug 10793) "Mark patrolled" links will now be shown for users with
  patrol permissions on all eligible diff pages
* (bug 10655) Show standard tool links for blocked users in block log messages
* Show standard tool links for blocked users in Special:Ipblocklist
* Miscellaneous aesthetic improvements to Special:Ipblocklist
* (bug 10826) Added link trail with Cyrillic characters for Mongolian language
* (bug 10859) Introduce 'UserGetImplicitGroups' hook; see docs/hooks.txt for
  more information
* (bug 10832) Include user information when viewing a deleted revision
* (bug 10872) Fall back to sane defaults when generating protection selector
  labels for custom restriction levels
* Show edit count in user preferences
* Improved support for audio/video extensions
* (bug 10937) Distinguish overwritten files in upload log
* Introduce 'ArticleUpdateBeforeRedirect' hook; see docs/hooks.txt for more
  information
* Confirmation is now required when deleting old versions of files
* (bug 7535) Users can now enter comments when deleting old versions of files
* (bug 11001) Submit Special:Newpages as a GET, rather than a POST request
* The <strong></strong> around links to watched pages in change lists now
  has a class - "mw-watched"
* (bug 9002) Provide a "view/restore deleted edits" link on Special:Upload
  when a destination filename is provided that corresponds with previous
  deleted files
* Make the "invalid special page" message clearer
* Add accesskey 's' and tooltip to 'upload file' button at Special:Upload
* Introduced 'SkinAfterBottomScripts' hook; see docs/hooks.txt for
  more information
* (bug 11095) Honour "preview on first edit" preference when preloading
  text for a non-existent page
* (bug 11022) Use a more accurate page title for Special:Whatlinkshere and
  Special:Recentchangeslinked
* Add link to user contributions in normal watchlist edit mode
* (bug 9426) Add 'newsectionheaderdefaultlevel' message to allow
  modification of the heading formatting for new sections when section=new
  argument is supplied
* (bug 10836) Add 'newsectionsummary' message to allow modification of the
  text that prefixes a new section link in Recent Changes

== Bugfixes since 1.10 ==

* (bug 9712) Use Arabic comma in date/time formats for Arabic and Farsi
* (bug 9670) Follow redirects when render edit section links to transcluded
  templates.
* (bug 6204) Fix incorrect unindentation with $wgMaxTocLevel
* (bug 3431) Suppress "next page" link in Special:Search at end of results
* Don't show unblock form if the user doesn't have permission to use it
  (cosmetic change, no vulnerabilities existed)
* Subtitle success message when unblocking a block ID instead of a pseudo link
  like [[User:#123|#123]]
* Use the standard HTTP fetch functions when retrieving remote wiki pages
  through transwiki, so we can take advantage of cURL goodies if available
* Disable user JavaScript on Special:Userlogin, Special:Resetpass and
  Special:Preferences, to avoid a compromised script sniffing passwords, etc.
* (bug 9854, 3770) Clip overflow text in gallery boxes for visual cleanliness
  instead of letting it flow outside the box or trigger ugly scroll bars.
* Tooltips for print version and permalink
* Links to the MediaWiki namespace for system messages having their default
  values are no longer shown as nonexistent (e.g., in red)
* Special:Ipblocklist differentiates between empty list and no search results.
* (bug 5375) profiling does not respect read-only mode.
* (bug 7070) monobook/user.gif has antialias artifacts
* (bug 9123) Safer way when applying $wgLocalTZoffset
* (bug 9896) Documentation for $wgSquidServers and X-FORWARDED-FOR
* (bug 9417) Uploading new versions of images when using Postgres no longer
  throws warnings.
* (bug 9908) Using tsearch2 with Postgres 8.1 no longer gives an error.
* (bug 1438) Fix for diff table layout on very wide lines.
  Diff style rules have been broken out to common/diff.css,
  and the dupes removed from the default skin files.
  Skins can still override the default rules.
* (bug 1229) Balance columns in diff display evenly
* Right-align diff line numbers in RTL language display
* (bug 9332) Fix instructions in tests/README
* (bug 9813) Reject usernames containing '#' to avoid silent truncation
  of fragments during the normalisation process
* (bug 7989) RSS feeds content now use black text when using white background.
* (bug 9971) Typo in a french language message.
* (bug 9973) Changed size was shown in advanced recentchanges collapsible items
  with $wgRCShowChangedSized = false.
* Fix PHP strict standards warning in enhanced recent changes.
* (bug 5850) Added hexadecimal html entities comments for $digitTransformTable
  entries.
* (bug 7432) Change language name for Aromanian (roa-rup)
* (bug 908) Unexistent special pages now generate a red link.
* (bug 7899) Added \hline and \vline to the list of allowed TeX commands
* (bug 7993) support mathematical symbol classes
* (bug 10007) Allow Block IP to work with Postgrs again.
* Add Google Wireless Transcoder to the Unicode editing blacklist
* (bug 10083) Fix for Special:Version breakage on PHP 5.2 with some hooks
* (bug 3624) TeX: \ker, \hom, \arg, \dim treated like \sin & \cos
* (bug 10132, 10134) Restore back-compatibility Image::imageUrl() function
* (bug 10113) Fix double-click for view source on protected pages
* (bug 10117) Special:Wantedpages doesn't handle invalid titles in result
  set [now prints out a warning]
* (bug 10118) Introduced Special:Mostlinkedtemplates, report which lists
  templates with a high number of inclusion links
* (bug 10104) Fixed Database::getLag() for PostgreSQL and Oracle
* (bug 9820) session.save_path check no longer halts installation, but
  warns of possible bad values
* (bug 9978) Fixed session.save_path validation when using extended
  configuration format, e.g. "5;/tmp"
* Don't generate a diff link in the patrol log if the page doesn't exist
* (bug 10067) Translations for former skins removed from message files
* (bug 9993) Force $wgShowExceptionDetails on during installation
* (bug 9980) Validate administrator username and password during
  installation
* (bug 9383) Don't set a default value for BLOB column in rc-deleted
  database patch
* (bug 10149) Don't show full template list on section-0 edit
* (bug 9909) Ensure access to binary fields in the math table use encodeBlob()
  and decodeBlob()
* (bug 6743) Don't link broken image links to the upload form when uploads
  are disabled
* (bug 9679) Improve documentation for $wgSiteNotice
* (bug 10215) Show custom editing introduction when editing existing pages
* (bug 10223) Fix edit link in noarticletext localizations for fr, oc
* (bug 10247) Fix IP address regex to avoid false positive IPv6 matches
* (bug 9948) Workaround for diff regression with old Mozilla versions
* (bug 10265) Fix regression in category image gallery paging
* (bug 8577) Fix some weird misapplications of time zones.
  {{CURRENT*}} functions now consistently use UTC as intended, while
  {{LOCAL*}} functions return local time per server config or $wgLocaltimezone.
  Signature dates for Japanese and other languages including weekday now show
  the correct day to match the rest of the time in local time.
* Escape the output of magic variables that return page name or part of it
* (bug 10309) Initialise parser state properly in extractSections(), fixes
  some cases where section edits broke because tags were improperly stripped
* Avoid PHP notice errors when doing HTTP proxy purges for an empty list
* As intended, *skip* the HTTP proxy purges when doing HTCP purges
* (bug 9696) Fix handling of brace transformations in "pagemovedtext"
* (bug 10325) Fix regression in form action on Special:Listusers
* Fixed installation on MyISAM or old InnoDB with charset=utf8, was giving
  overlong key errors.
* Fixed zero-padding issues with MySQL 5 binary schema
* (bug 10344) Don't follow a redirect after changing its protection level
* (bug 10333) Correct date format in Slovenian
* (bug 10160) Show error message for unknown namespace on Special:Allpages and
  Special:Prefixindex; making forms prettier for RTL wikis.
* (bug 10334) Replace normal spaces before percent (%) signs with non-breaking
  spaces
* (bug 10372) namespaceDupes.php no longer ignores namespace aliases
* (bug 10198) namespaceDupes.php no longer ignores interwiki prefixes
* namespaceDupes.php should work better for initial-lowercase wikis
* (bug 10377) "Permanent links" to revisions still work if the page is moved
  and the redirect deleted
* (bug 7071) Properly handle an 'oldid' passed to view or edit that doesn't
  match the given title. Fixes inconsistencies with talk, history, edit links.
* (bug 10397) Fix AJAX watch error fallback when we receive a bogus result
* (bug 10396) Fix AJAX error when $wgScriptPath/index.php is not valid;
  using $wgScript now included in JS info
